
//[2012.06.16.][!!!]{**************
//[˵C]  <editor_edit_Form>  .
//}******************************************


#ifndef GEditorEditH                            
#define GEditorEditH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------

#include  <ExtCtrls.hpp>

#include  "font.h"

#include  "GCaret.h"

//[2010.02.07.][߰!!!]
// [˸â]  ϱ  ̴.
#include  "GMsgBox.h"

#include  "GFindDialog.h"


//[2010.02.13.][߰!!!]
//[]  <GList>  Ͽ Ѵ.
#include  "GList.h"


//[2018.02.23.][߰!!!]{---
//[ȯ溯]  Ѱ.
#include  "ide_main.h"
//}---------------------------


struct GEditorEdit_CARETINFO
{
  //[2007.02.14.][!!!]{------------------------------------------
  //[Է]   .
  //[ÿ] ó [Է]   ϱ Ͽ Ѵ.

  //ʿ    ߰Ҽ ִ.
  //}------------------------------------------------------------------

  int  caret_index;  //_caretindex  .
  int  caret_x;      //_caret_x     .
  int  caret_y;      //_caret_y     .

};

struct GEditorEdit_WORDCONFIG
{
  //[2007.01.23.ȭ][!!!]{-------------------
  //½ Ѱ Ǵ  Ѵ.
  //}-------------------------------------------

  int   index;
  int   length;
  int   front_color;
  int   back_color;
  bool  transparent;

  //[2007.02.05.][߰!!!]
  int   style;

};

//[]
//{
    //[2007.04.12.][߰!!!]{----------------------------------
    //⺻  20  Ҽ ְ .
    //[2009.04.24.][!!!]-----------------------------------
    // [VMOS]   12   []   ϹǷ
    //ִ 12  ̻  ʿ .
    //ִ Ѱ  12  ϰ ǹǷ.
    //}----------------------------------------------------------

    #define  d_breakpoint_max   12

    struct GBREAKPOINT
    {
      // ȣ(BASE: 0)  .
      int  line[d_breakpoint_max];

      //   ´.
      int  count; //(BASE: 0)

    };

//}

struct GTEXTINFO
{
  //[2007.01.01.][!!!]{-------------
  // ٸ  Ѵ.
  // ȯ ڵ Ǿ Ѵ.
  //
  //[2012.06.09.][!!!]--------------
  //}-------------------------------------

  //    Ǵ [] ̸.
  AnsiString         filename;

  //  byte  ũ⸦ Ѵ.
  int                filesize;

  int                font_margin_size;

  int                text_org_x;
  int                text_org_y;

  int                linecount;

  int                linestartindex;
  int                lineendindex;

  int                linetop_startindex;
  int                linetop_linenumber;

  int                caretindex;
  int                caretindexwidth;

  //[ܾ  ]
  //{
      //[2012.05.24.][߰!!!]{-------------------------------------------
      //ǽð [Է]  ġ [ܾ]  [/:ġ]  .
      //}-------------------------------------------------------------------

      int  wordStartIndex;
      int  wordEndIndex;

  //}

  //[ ]
  //{
      //[2012.06.09.][߰!!]{----------------------------------
      //ڿ []   []    .
      //}---------------------------------------------------------
      
      bool  vLineEn;
      int   vLineX;

  //}

  int                row;
  int                col;

  int                caret_x;
  int                caret_y;

  //[2007.04.05.][߰!!!]
  bool               changed;

  //[2007.04.12.][߰!!!]
  //  []  Ѵ.
  struct GBREAKPOINT  breakpoint;

  //[ÿ][2007.02.14.][!!!]
  //{
      struct GEditorEdit_CARETINFO select_start;
      struct GEditorEdit_CARETINFO select_end;

  //}

  //[ũ ]
  //{
      //[]  [ũ]  Ѵ.
      int  scroll_V_min;
      int  scroll_V_max;
      int  scroll_V_position;
      int  scroll_V_design_size;

      int  scroll_H_min;
      int  scroll_H_max;
      int  scroll_H_position;
      int  scroll_H_design_size;
  //}

  //[2009.03.31.ȭ][߰!!!]
  //[б] Ӽ (BASE : false).
  bool  readOnly;

  //  Ѵ.
  int   fileKind;

  //[  ]
  //{
      //[2011.06.26.][߰!!!]{-------------------------------------------------
      //[ ]   <*.c>   ٸ Ƿ  <*.c> 
      //  ־ Ѵ.
      //}-------------------------------------------------------------------------

      bool  dbgView_Visible;
      char  dbgView_State;

      //[2011.07.01.][߰!!!]{----------------------
      //[2/10/16 ]     ΰ?
      // <2/10/16>   Ѵ.
      int   dbgView_ViewKind; //(⺻ : 16)
      //}----------------------------------------------

  //}

};

struct GHISTORY
{
  //[2009.05.01.][!!!]{------------------------------------
  //[ǵ/ǻ츮]    ü.
  // ׸  ƴ϶ [ǵ]   Ѵ.
  //,  [] ó  ϴ ̴.
  //memmove() Լ  ó ϹǷ   ϴ.
  //}------------------------------------------------------------

  //********************
  //[<ǵ> ]
  //********************


  //[Ϲ ]{*********************************************************************
  //
  //      4Byte          1Byte        1Byte        XByte         4Byte
  //{ <index> + <'+'/'-'\'> + <'c'/'s'> +<ڿ + '\0'> + <ũ> }
  //  |<-------------------<ũ>---------------------------->|
  //
  //
  //<ũ>  ó ڿ  Byte  .
  //
  //̴ [ǵ ]   <STACK>  ǹǷ Ųٷ ں
  //ؾϴµ,   ڿ  Ƿ ϴ  ã .
  //, ٷ [ǵ]  ġ ˱ Ͽ <ũ>  ݵ ʿϴ.
  //
  //ϴ, [ǵ]  ġ ˸ ڿ ϰ ũⰡ  Ƿ
  //ϰ  Ͽ 밡ϴ.
  //
  //[2009.05.06.][!!!]-----------------------------------------------------------
  //<'c'/'s'>  ߰Ѵ.
  //'c' : (ѱ, , ȣ, CRLF)  .
  //'s' : ڿΰ(ÿ̾ 쳪 ٿֱ ߶󳻱  ).
  //
  //}**********************************************************************************

  
  //[̵][2012.02.03.][߰!!!]{*******************************************************
  //
  //[2012.02.06.][߿!!!]{-------------------------------------------
  // [̵]   üʹ ϴ.
  //   [̷]  ϱ  ̰  ִ .
  //}-----------------------------------------------------------------------
  //
  //[̵]    ٸ  ´.
  //[ι°]  [Ϲ/̵]   Ҽ ִ.
  //
  //      4Byte          1Byte          4Byte                  4Byte                    4Byte               4Byte       4Byte
  //{ <index> + <'>'/'<'> + <:ġ> + <::ġ> + <::ġ> + <̵> + <ũ> }
  //
  //  |<---------------------------------------------<ũ:21Byte>-------------------------------------------->|     21
  //
  // ׸ ũ̹Ƿ ü  [ũ]  ȴ.
  //
  //[з]
  //(>) : [̵:]  .
  //(<) : [̵:]  .
  //
  //  [Ctrl]+[=>]  [Ctrl]+[<=]  ϰų  ȭڸ ̿ [ÿ] 
  //[̵] ϴ  [̷]  Ѱ.
  //
  //[C]  ۼ [鿩]  ؾ ϴ     óϴ 
  //ð  ɸǷ ̸  ο ɿ Ϸ°.
  //  [̷]  [̵:(>)], [̵:(<)]   ϵǰ
  //    [ǵ/ǻ츮] ϴ   ð  ɸǷ
  //  ѹ [ǵ/ǻ츮] ϱ Ͽ ȴ.
  //
  //    Լ Ѵ.
  //
  //[2012.02.06.][߿!!!]****************************************************************
  //<:ġ>  <::ġ>  <::ġ>  ΰ  .
  //̴ [ǵ/ǻ츮] ÿ    ʿϱ .
  //
  //<:ġ>  ȭ Ƿ Ѱ  Ѵ.
  //}*******************************************************************************************


  //˳ϰ 4M Byte  Ѵ.
  // [ǵ]  Ѵ.
  #define  d_History_Max   1024*4000
  char   buf[d_History_Max];

  //  ũ( ġ) ´.
  int    bufCount;

  //[ɹ] ġ ´.
  int    packetPtr;


  //[ڿ]{-----------------------
  //[]  ڿ  ġ.
  int    strStartIndex;
  //[]  ڿ  ġ.
  int    strEndIndex;
  //}-------------------------------

  //[̵ ]
  //{
      //[2012.02.06.][߰!!!]{-------------------------------------
      //[̵]  [̷]   .
      // ׸  Ǵ  ƴ϶ ʿ信  ӽ ҷ
      // ȴ.
      //}-------------------------------------------------------------

      //Է ġ ġ(  ġ).
      // [:ġ]    .
      //ÿ  Լ ϱ Ͽ [ǻ] Է ġ
      //[:ġ]  ϴ .
      int   mCaretIndex;

      //<:ġ>.
      // ġ  / ׻    ʴ´.
      int   mStartLineStartIndex;

      // <:ġ>.
      int   mEndLineStartIndex;

      // <:ġ>.
      int   mEndLineStartIndex_moved;

      //̵ .
      int   mMoveCount;

  //}

};

struct GCOMMENTBLOCK_INFO_ITEM
{
  //[2009.06.02.ȭ][!!!]{-------------------
  //1  {/* ... */}   Ѵ.
  //
  //startIndex : "/*"  ġ('/'  ġ).
  //endIndex   : "*/" ġ('/'  ġ).
  //}-------------------------------------------

  int  startIndex;
  int  endIndex;

  //[2012.06.09.][߰!!!]
  //  .
  int  startLine;
  int  endLine;

};

struct GCOMMENTBLOCK_INFO
{
  //[2009.06.02.ȭ][!!!]{---------------------------------
  //   {/* ... */}    Ѵ.
  //}---------------------------------------------------------

  //[2012.06.09.][!!!]
  //<1024*100>   ϳ  ״ д.
  #define  d_COMMENTBLOCK_INFO_ITEM_Max  1024*100

  struct GCOMMENTBLOCK_INFO_ITEM   items[d_COMMENTBLOCK_INFO_ITEM_Max];

  //  Ѵ.
  //[2012.06.09.][߿!!!]{---------------------------------------------------------
  // ó  <_ROOT_TEXTINFO_Init()>  ݵ <-1>  ʱȭ.
  //̴ ѹ  ʾҴٴ ǹ.
  //ó     []    ̸ ϱ Ͽ ʿ.
  // ȯÿ    Ҽ ֱ  .
  int    itemCount; //(ʱⰪ:-1)
  //}---------------------------------------------------------------------------------

};

class TGEditorEdit_Form : public TForm
{
__published:	// IDE-managed Components
        void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
        void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
private:	// User declarations
public:		// User declarations

        __fastcall TGEditorEdit_Form(TComponent* Owner);

        //[2012.04.29.][Ϸ!!!]
        __fastcall ~TGEditorEdit_Form(void);

        //[Ŭ]
        //{
            //[2009.04.03.][߿Ϸ!!!]
            //[2018.02.23.][Ϸ!!!]
            void __fastcall WndProc(Messages::TMessage &Message);

        //}

        //[ȯ溯]
        //{
            //[2018.02.23.][߰!!!]{------------
            //[Linux:wine]  Ѱ.
            //<editor_edit>   ڵ带 Ѱ.
            //}------------------------------------

            struct  IDE_OPTION   *_ide_option;

        //}

        //[]
        //{
            //[2012.05.01.ȭ][߿߰!!!]{-------------------------------------------
            //<GVmos>  <[]˵󱸵>   Ǵ 
            //Ϻ [׸ǰ]    []  Ŀ
            //Լ ɼ ִ.
            //̸  Ͽ  ü [ /]  Ȯ  ϳ д.
            //
            // Լ ݵ <_this_:true>  츸 óǾ Ѵ.
            //
            //[]  ݵ <true>  ϰ, [Ҹ]  <false>  ó.
            //true  :  .
            //false :  .
            //}-----------------------------------------------------------------------

            bool  _this_;

        //}

        //[VAR]
        //{
            //[ ׸ ]{-----------
            Graphics::TBitmap  *_bmp_;

            //  ׸.
            Graphics::TBitmap  *_bmp_back_;
            //}-----------------------------

            //[۲]{--------------
            struct FONTPACK     _font;
            //}------------------------

            // Ʈ    .
            int                 _line_height;
            // Ʈ   Ѱ .
            int                 _word_width;


            //[]{-------------------------------------------------------------
            //⺻ ũ 10M 뷮 Ѵ.
            //ɼ  Ҽ ־ ϹǷ Ҽ ֵ Ѵ.
            char               *_editbuf;
            // []   []  Ѱ Ƿ ƿ  ũ⸦ 
            //Ͽ  ȿ ÿ []  ũ⸦  ʿ䰡  .
            //10M   ̴.
            //}-------------------------------------------------------------------------


            //[ ӽ ó ]{---------------------------------------------------------------------
            //[2007.04.09.][߰!!!]
            //_editbuf[]  [/ڿ]   ֱ  []  Ҷ
            //for()  ϴ     ó ӵ .
            //memmove() Լ Ҽ   ó ѵ, Ѱ ҷδ ҰϹǷ
            //_editbuf[]   ũ []   memmove() Լ Ͽ о ڿκ
            //̰ ϰ -> ڿ   -> ٽ ϻؼ ִ̾  Ѵ.
            // memmove() Լ ϰ ǹǷ  óҼ ִ.
            char               *_tempbuf;
            //}--------------------------------------------------------------------------------------------


            //[ü׸ ǥ][2007.03.25.][߰!!!]{------------------------
            //ü ׸ ϴ    ǥ  ġ ǥ .
            //  ׸   ʴ´.
            int   _bmporg_x, _bmporg_y;
            //}-----------------------------------------------------------------------


            //[2007.03.31.][߰!!!]{--------------------------------------------------------
            // bmp δ    ϴ  .(÷ ٲ  ƴϹǷ...)
            AnsiString  _bmp_path;
            //}--------------------------------------------------------------------------------

        //}

        //[  ü]
        //{
            //[]
            //{
                //[VAR]
                //{
                    //[2007.03.06.ȭ][߰!!!]
                    TGList_Form  *_popupMenu;

                //}

                //[Լ]
                //{
                    //[׸]  ׸ õ  ȣȴ.
                    //[2007.03.31.][Ϸ!!!]
                    void __fastcall _EVENT_ItemSelect_popupMenu(void);

                //}

            //}

        //}

        //[߰Ӽ]
        //{
            //ϴ  ´.

            //[ã ȭ]
            //{
                //[2012.05.01.ȭ][!!!]{------------------------------------------------------------
                //<_GPART_GFindDialog>  ġ ϴ <:_GPART_GFindDialog> ü ġ
                //Ѵ.
                //̴  <:_GPART_GFindDialog> ü  ġ  ʱ ̸
                //
                //[GUI]  [X] ư   ʰ
                //<[]˵󱸵>   ٷ ϴ 
                //
                //<GVmos>  <GPART_GVmos_Delete()>   Ǹ鼭 <_GPART_GFindDialog> 
                //ϴ [ãȭ]  <GVmos>   ,
                //̸ ϴ <GEditorEdit>   <GVmos>  ɶ Ǳ ̴.
                //, []  ٲ Ǹ鼭 ߻ϴ ε,
                // <GEditorEdit>  [ãȭ]  ġ ϱ ̸
                // ġ ó <GEditorEdit>  ɶ ѹ <GPART_GFindDialog_GetPtr()> Լ
                // ϱ  <GPART_GVmos_Delete()>  [ãȭ]  ̹ []
                //Ǿ <_GPART_GFindDialog:NULL>   ,    [ãȭ] 
                //ġ  ϴٰ []  ߻ϰ ٴ ̴.
                //<TGEditorEdit_Form::_EDITBUF_LINE_Out()> Լ ο []  óҶ
                //̹  ʴ [ãȭ]   ּҷ ϸ []  .
                //
                //, ƿ  ġ   <GVmos>  Ǿ  []  
                //Ȯϰ [ãȭ:NULL] ¸ ˼ ִ <_GPART_GFindDialog> ü ּҸ 
                //ϴ  Ѵ.
                //   [ãȭ]  [] Ǿ  ˼ ִ.
                //
                // [ãȭ]  ϴ κ <GEditorEdit> ۿ .
                //
                //<GPART_GFindDialog_GetPtr2()>  Լ .
                //}------------------------------------------------------------------------------------

                //[2012.05.01.ȭ][!!!]{---------------------------------------------------
                //<*_GFindDialog> => <**_GFindDialog>  .
                //[ãȭ] ġ ƴ϶ ̸ ϴ <:_GPART_GFindDialog> 
                //ġ Ѵ.
                // [ãȭ]  ̹ [] Ȼ¶  / ȮҼ ִ.
                //
                //[2012.05.05.][!!!]----------------------------------------------------
                //[BCB]  ϴ  ̹ ϵ ִ [ǰ] 
                //ϰ   [׸ǰ]  ϸ ȴ.
                TGFindDialog_Form  **_GFindDialog;
                //}---------------------------------------------------------------------------

            //}

            //[׸]
            //{
                //[׸ ̸]  Ѵ.
                AnsiString  _backBmpPath;

            //}

            //[]
            //{
                //[!]{--------------------------------------
                //[]    Ѵ.
                //}-----------------------------------------

                //[VAR]
                //{
                    int  _colorKeyword;    //.
                    int  _colorBinWord;    //2.
                    int  _colorHexWord;    //16.
                    int  _colorDirective;  //þ.
                    int  _colorString;     //ڿ.
                    int  _colorChar;       //.
                    int  _colorComment;    //ּ.

                //}

                //[2010.02.17.][Ϸ!!!]
                void __fastcall _Syntax_ColorKeyword(int  pColor);

                //[2010.02.17.][Ϸ!!!]
                void __fastcall _Syntax_ColorBinWord(int  pColor);

                //[2010.02.17.][Ϸ!!!]
                void __fastcall _Syntax_ColorHexWord(int  pColor);

                //[2010.02.17.][Ϸ!!!]
                void __fastcall _Syntax_ColorDirective(int  pColor);

                //[2010.02.17.][Ϸ!!!]
                void __fastcall _Syntax_ColorString(int  pColor);

                //[2010.02.17.][Ϸ!!!]
                void __fastcall _Syntax_ColorChar(int  pColor);

                //[2010.02.17.][Ϸ!!!]
                void __fastcall _Syntax_ColorComment(int  pColor);

            //}

            //[  ܾ]
            //{
                //[2012.08.03.][߰!!!]{--------------------------------
                //[  ܾ]  .
                //<_MoonjaConfig_LineGet_C>  []  óȴ.
                //}--------------------------------------------------------

                //[!!!]{----------------------------------------------------------------
                //
                //[] = { [ܾ0'\0'][ܾ1'\0'][ܾ2'\0']... }  [ܾ] .
                //̴ [빮ڿ]   .
                //
                //<_syntaxWord_[ȣ] = [0] ġ;
                //
                //<_syntaxWord_[ȣ]>  .
                //
                //}-------------------------------------------------------------------------

                //[VAR]
                //{
                    //{ [ܾ0'\0'][ܾ1'\0'][ܾ2'\0']... }  ڿ .
                    char   *_syntaxWordBuf_;     //(ʱȭ:NULL)
                    int     _syntaxWordBuf_Size; //(⺻:0)

                    //{ [ܾ0'\0'][ܾ1'\0'][ܾ2'\0']... }   [ܾ] ּ .
                    //ٷ ڿ Ҽ ֵ [ּ]  .
                    char  **_syntaxWord_;        //(ʱȭ:NULL)
                    int     _syntaxWord_Count;   //(⺻:0)

                    //[]
                    //{
                        //[!]{--------------------------------------
                        // []  [˵C] API ʰ   .
                        //}-----------------------------------------

                        unsigned char  _syntaxWord_Style;
                        unsigned int   _syntaxWord_FontColor;
                        unsigned int   _syntaxWord_BackColor;
                        bool           _syntaxWord_Transparent;

                    //}

                //}

                //[2012.08.03.][Ϸ!!!]
                void __fastcall _Syntax_Word_Set(//"ܾvܾvܾ"  [:Ѱ]  еǰ
                                                 // []   Ѵ.
                                                 char           *pWordList_,
                                                 unsigned char   pStyle,
                                                 unsigned int    pFontColor,
                                                 unsigned int    pBackColor,
                                                 bool            pTransparent);
                //[2012.08.03.][Ϸ!!!]
                void __fastcall _Syntax_Word_UnSet(void);

                //[2012.08.17.][Ϸ!!!]
                void __fastcall _Syntax_Word_Color(int  pColor);

            //}

            //[׵θ]
            //{
                //[VAR]
                //{
                    int  _borderColor;

                //}

                //[2010.02.10.][Ϸ!!!]
                void __fastcall _BorderColor(int  pBorderColor);

            //}

            //[  ]
            //{
                //[VAR]
                //{
                    // ȭ (⺻ : 225).
                    int  _editBackBrightness;

                //}

                //[2010.02.10.][Ϸ!!!]
                void __fastcall _EditBackBrightness(int  pEditBackBrightness);

            //}

            //[ ]
            //{
                //[VAR]
                //{
                    //[2010.02.14.][߰!!!]
                    //[Ư]   ȣ.
                    // ʴ  <-1>  ҴѴ.
                    int  _focusLineNum; //(⺻ : -1)

                    //[2012.08.19.][߰!!!]{--------------------------------------------------
                    //<true>   []  []  Ҿ []   ʴ´.
                    //[˵C]  [G.M.RC.BASiC-IDE]    ʿ信  ߰.
                    //[:߱]  óϴ <_DEBUG_Indicator_Hide()> Լ ȴ.
                    bool _focusLineNoHide; //(⺻:false).
                    //}--------------------------------------------------------------------------

                    // [ڻ].
                    int  _focusLineFontColor;

                    // [].
                    int  _focusLineBackColor;

                    //[2010.03.16.ȭ][߰!!!]
                    // .
                    int  _lineArrowColor;

                    //.
                    int  _breakPointColor;

                //}

                //[2010.02.14.][Ϸ!!!]
                void __fastcall _FocusLineNum(int  pLineNum);

                //[2010.02.14.][Ϸ!!!]
                void __fastcall _FocusLineFontColor(int  pColor);

                //[2010.02.14.][Ϸ!!!]
                void __fastcall _FocusLineBackColor(int  pColor);

                //[2010.02.14.][Ϸ!!!]
                void __fastcall _LineArrowColor(int  pColor);

                //[2012.08.18.][Ϸ!!!]
                void __fastcall _BreakPointColor(int  pColor);

                //[ΰԼ]
                //{
                    //[2010.02.14.][Ϸ!!!]
                    void __fastcall _FocusLine_Draw(void);

                //}

            //}

            //[]
            //{
                //[!]{---------------------------------------------------
                // [/б] ȯ̳, []  Ѵ.
                //}------------------------------------------------------

                //[2010.02.17.][Ϸ!!!]
                void __fastcall _Document_ReadOnly(//б  : true.
                                                   bool  pReadOnly);

                //[2010.02.17.][Ϸ!!!]
                //[]  Ʒ ǵ ִ.
                void __fastcall _Document_FileKind(//[] .
                                                   int  pFileKind);





            //}

            //[]
            //{
                //[2010.02.07.][߰!!!]{------------------------------------------
                //<*.h> ߺ   ƿ ߻ ʵ <void *)  
                //ش [ǰ]  ȯ ϴ  Ѵ.
                //}------------------------------------------------------------------

                void  *_vpGEditor;

                //[2010.02.10.][߰!!!]
                //  ϸ 1 ϸ ȴ.
                void  *_vpGVmos;

            //}

        //}

        //[ ˸â]
        //{
            //[2010.02.07.][߰!!!]{---------------------------------------
            //ü Ǵ [˸â]  ϱ  ̴.
            //̹  Ƿ  Լ ޾Ƽ ϱ⸸ ϸ ȴ.
            //
            //[2012.05.01.ȭ][!!!]{---------------------------------------
            //ڼ  <GPART_GFindDialog_GetPtr2()> Լ  .
            //
            //<*> => <**>  .
            //[ü] ġ ƴ϶ ̸ ϴ <>  ġ .
            //[ü]  ̹ [] Ȼ¶  [/]  ȮҼ ִ.
            //
            //[2012.05.05.][!!!]----------------------------------------
            //[BCB]  ϴ  ̹ ϵ ִ [ǰ] 
            //ϰ   [׸ǰ]  ϸ ȴ.
            //}---------------------------------------------------------------

            TGMsgBox_Form  **_GMsgBox;

        //}

        //[ ȭ]
        //{
            //[2010.03.17.][߰!!!]{-------------------------------------
            // [/ ȭ]  Ѵ.
            //̹  Ƿ  Լ ޾Ƽ Ѵ.
            //
            //[2012.05.01.ȭ][!!!]{-------------------------------------
            //ڼ  <GPART_GFindDialog_GetPtr2()> Լ  .
            //
            //<*> => <**>  .
            //[ü] ġ ƴ϶ ̸ ϴ <>  ġ .
            //[ü]  ̹ [] Ȼ¶  [/]  ȮҼ ִ.
            //
            //[2012.05.05.][!!!]--------------------------------------
            //[BCB]  ϴ  ̹ ϵ ִ [ǰ] 
            //ϰ   [׸ǰ]  ϸ ȴ.
            //}-------------------------------------------------------------

            TOpenDialog  **_GOpenDialog;

            TSaveDialog  **_GSaveDialog;

        //}

        //[FUNCTION]
        //{
            //[2018.09.04.ȭ][Ϸ!!!]
            void __fastcall _Enable(bool  pEnable);

            //[2018.09.04.ȭ][Ϸ!!!]  
            void __fastcall _Shape(void);

            //[2012.06.13.][Ϸ!!!]
            void __fastcall _Resize(void);

            void __fastcall _Draw(void);

            //[2018.09.04.ȭ][Ϸ!!!]
            void __fastcall _EditBuf_Text(void);

            //[2011.06.30.][Ϸ!!!]
            void __fastcall _EditBuf_LineText(int   pLineNumber,
                                              //[]  ׷ٰ true.
                                              bool  pFocusLineEn);

            //[2011.06.29.][Ϸ!!!]
            void __fastcall _EditBuf_LineTextX(//ٽ ׸   ȣ.
                                               int   pStartLineNumber,
                                               //ٽ ׸  .
                                               int   pLineCount,
                                               //[2011.06.29.][߰!!!]
                                               //[]  ִ  <true>.
                                               bool  pDbgViewEn,
                                               //[]  ׷ٰ true.
                                               bool  pFocusLineEn);

            //[2012.03.27.ȭ][Ϸ!!!]
            void __fastcall _Scroll_Set(void);

            //[2006.11.29.][Ϸ!!!]
            void __fastcall _Scroll_Resize(void);

            //[2006.12.17.][Ϸ!!!]
            void __fastcall _EditBuf_Clear(void);

            //[2011.06.06.][Ϸ!!!]
            bool __fastcall _EditFile_SetKind(char  *pFileName);

            //[2019.03.08.][Ϸ!!!]
            void __fastcall _EDITFILE_Open(AnsiString  pFILEname);

            //[2012.03.01.][Ϸ!!!]
            void __fastcall _EDITFILE_ReOpen(AnsiString  pFILEname);

            //[2009.05.05.ȭ][Ϸ!!!]
            void __fastcall _EDITFILE_TempDelete(char  *pFileFullName);

            //[2012.03.01.][Ϸ!!!]
            void __fastcall _EDITFILE_SaveNowFile_inTEMPfile(void);

            //[BCB/˵C ]
            //{
                //[2012.05.05.][!!!]{--------------------------
                //[BCB/˵C]  ؼ   Լ .
                //}--------------------------------------------------

                //[2012.05.03.][Ϸ!!!]
                //[BCB/˵C]  .
                //Լΰ .
                void __fastcall _EDITFILE_SaveNowEditFile(void);

                //[2012.07.22.][Ϸ!!!]
                void __fastcall _EDITFILE_SaveNowEditFile2(void);

            //}

            //[BCB/˵C ]
            //{
                //[2012.05.05.][!!!]{--------------------------
                //[BCB/˵C]  ؼ   Լ .
                //}--------------------------------------------------

                //[2012.05.03.][Ϸ!!!]
                //[BCB/˵C]  .
                //Լΰ .
                void __fastcall _EDITFILE_SaveAsNowEditFile(void);

                //[2012.05.05.][Ϸ!!!]
                void __fastcall _EDITFILE_SaveAsNowEditFile2(void);

            //}

            //[2012.03.01.][Ϸ!!!]
            void __fastcall _EDITFILE_SaveAllFile(void);

            //[2012.07.22.][Ϸ!!!]
            void __fastcall _EDITFILE_NewFile(void);

        //}

        //[]
        //{
            //[VAR]
            //{
                //[ذ]
                //{
                    //[ѱ/]   ǥ  []  .
                    // []   ۲ø ǹǷ [ѱ/]  Ѱ
                    //[]  ٸ ó Ͽ  ־ Ѵ.
                    //  [۲]  Ҷ ѹ س ȴ.
                    int  _font_kor_width;
                    int  _font_eng_width;
                //}

                //[]
                //{
                    //  µǴ    ȴ.
                    //[Է] ġ, [/] ǥ     ǥ  Ѵ.
                    int  _text_org_x;
                    int  _text_org_y;
                //}

                //[]
                //{
                    //[]    Ѵ.
                    //ϴµ ð  ŸǷ ׻ ô   ƾ Ѵ.
                    // ٲ []  (Enter/Del/Back Ű  ߶󳻱, ̱) 
                    //   ôϿ Ȯ   ƾ Ѵ.
                    //,    ⺻   ´.
                    //, [ ]  1  ǹ̰ ִ. ([ ȣ]  0  ǹ̰ Ƿ ȥ ʾƾ Ѵ.)
                    // ̶ [Է]  ġؾ ϹǷ ּ Ѱ  ־Ѵ.
                    int  _linecount; //(BASE : 1)

                    //  _editbuf[]   index( ù  ġ)  Ѵ.
                    // Ȳ    ־ ϰ ׻ Ȯ   ־ Ѵ.
                    int  _linestartindex; //(BASE : 0)

                    //_linestartindex ʹ ޸ ׻  ʿ  ʿҶ ȴ.
                    //    ġ + 1  ġ ´.
                    //Ϲ    CRLF  CR(0x0d)  ġ   
                    //CRLF    쵵 Ƿ Ϲ   ġ + 1  ġ
                    // ϸ ϴ.
                    int  _lineendindex; //(BASE : 0)

                    // _editbuf[]  ִ  byte  ũ.(ڿ  '\0'   ũ.)
                    //FILE_Open_inBUF() Լ    ڿ  '\0'  ũ⿡ Եȴ.
                    int  _filesize;

                    //[̴  ]
                    //{
                        //Ϲ [ũ] Ǵ   ٲ ǹǷ ̶ Ѵ.

                        //[] â ̴   [ ȣ]  Ѵ.
                        //[ ȣ]  0  ȿϴ.
                        int  _linetop_linenumber; //(BASE : 0)

                        //[] â ̴    index  Ѵ.
                        int  _linetop_startindex; //(BASE : 0)
                    //}

                    //[߿!!!]
                    //{
                        //------------------------------------------------------------------------
                        //_editbuf[]   [Է]  ġ  index  ´.
                        // ⺻ Ǵ ̸, ٸ    ǹǷ  Ͽ
                        //Ȯ   ־ Ѵ.
                        int  _caretindex; //(BASE : 0)

                        //_caretindex ġ  ǥû  ó []  .
                        int  _caretindexwidth; //(BASE : 0)
                        //------------------------------------------------------------------------
                    //}

                    //[ܾ  ]
                    //{
                        //[2012.05.24.][߰!!!]{---------------------------------------------------
                        //[Է]  ġ [ܾ]  [/:ġ]  ǽð .
                        //[]   Ǵ κп <_caretindex>  Ȯ
                        // ġ [ܾ:/:ġ]  ؼ .
                        //
                        //ܼ [Է]  [ġ̵]   <_EDIT_CaretPos()> Լ
                        //ȹϰ, [ ]  ܾ ǰų ϴ  
                        //<_filesize>  Ǵ [Լ] 鿡 óȴ.
                        //
                        //̴ [Է] ġ ε [Key:Del]  Ǵ 
                        //<_caretindex>   Ȯǰ, ߿ ġ ܾ ɼ Ƿ
                        //ݵ []  Ŀ  Ǿ ϱ ̴.
                        //
                        //<_filesize>  Ǵ [Լ]   Ʒ .
                        //<_EDITBUF_MOONJA_Delete()>, <_SELECT_Delete()>, <_EDITBUF_MOONJA_Insert()>,
                        //<_EditBuf_LineStr_Insert()>, <_EditBuf_LineStr_Delete()>, <_EDIT_Paste()>,
                        //<History_Insert()>
                        //}---------------------------------------------------------------------------

                        int  _wordStartIndex; //(⺻:0)
                        int  _wordEndIndex;   //(⺻:0)

                    //}

                    //[/]
                    //{
                        //-----------------------------------------------------------------------------
                        //[Է]  / ̵ÿ  []  ؼ ġ ãƾ Ѵ.
                        //  editor_info_Form  ش ġ  ǥ ɼ ־ Ѵ.
                        int  _row;
                        int  _col;
                        //-----------------------------------------------------------------------------
                    //}

                    //[]
                    //{
                        //[2007.04.05.][߰!!!]
                        //    true  Ѵ.
                        bool  _changed; //(BASE : false)

                    //}

                    //[б]
                    //{
                        //[2009.03.31.ȭ][߰!!!]
                        //б  Ӽ Ѵ(BASE : false).
                        bool  _readOnly;

                        //[2009.04.25.][߰!!!]{---------------------------------------------------
                        // <_readOnly> ʹ    Ӽ true  
                        //  ִ   [Ұ] ° ȴ.
                        //̴ [߰] ÿ true  Ǹ,   Ӽ  ʰ
                        //ȯ  ܼȭ Ű  ̴.
                        bool  _readOnlyAll;
                        //}---------------------------------------------------------------------------

                    //}

                    //[]
                    //{
                        //[2009.03.31.ȭ][߰!!!]{------------------------------------------------
                        //  Ѵ.
                        //̴  о ̸鼭 Ȯڸ ˻ϴ ͸ ϰ ˼ ִ.
                        //}------------------------------------------------------------------------

                        int   _fileKind;

                        #define   d_Editor_FileKind_c        1  //<*.c   > .
                        #define   d_Editor_FileKind_gasm     2  //<*.gasm> .
                        #define   d_Editor_FileKind_gcsm     3  //<*.gcsm> .

                        //[2009.05.28.][߰!!!]
                        //<*.c>   []  ޴´.
                        #define   d_Editor_FileKind_gtxt     4  //<*.gtxt> .

                        //[2011.05.27.][߰!!!]{-----------------------------------------
                        //<*.gasm>  ,  ó Ѵ.
                        #define   d_Editor_FileKind_obj      5   //<*.gobj>, <*.glib> .
                        //}-----------------------------------------------------------------

                        //[2011.06.06.][߰!!!]{-------------------------------
                        //<*.gtmp>  óѴ.
                        #define   d_Editor_FileKind_gtmp     6   //<*.gtmp> .
                        //}-------------------------------------------------------

                        #define   d_Editor_FileKind_default  0  //<*.txt >  ⺻ .

                    //}

                //}

                //[Է]
                //{
                    //-------------------------------------------------------
                    //ü ´.
                    TGCaret_Form  *_caret;

                    //ǥ ġ.
                    //(_text_x, _text_y) ġ  Ѵ.
                    //  offset ǥ ̹Ƿ  ""  ɼ .
                    int  _caret_x; //(BASE : 0)
                    int  _caret_y; //(BASE : 0)
                    //-------------------------------------------------------
                //}

                //Ѱ Ѵ.(ѱ/ ϼ Ƿ 2byte   Ѵ.)
                short  _moonja;
                bool   _ime_TkorFeng; //(BASE : false)

                //[2008.02.13.][߰!!!]{-------------------------------------------------------------
                //ѱ   ԷµǸ ѱ  ϼǴµ ̶ Է ȣ
                // ־ ϴµ ̶ ѱ   ڸ .
                //) ѱ  '2'  ԷϿ  ٸ '2' ڰ  ־ Ѵ.
                //̸ Ͽ WM_IME_COMPOSITION óο ImmGetCompositionString() Լ
                //Ͽ "2"  ڿ о óҼ ִ.
                //߿ '2' ڸ   ߿Ѵ. ''  WParam    Ƿ...

                HIMC  _imeHimc;         //IME ڵ.
                char  _imeBuffer[1024]; //ime ۿ  ڿ  Ѵ.
                int   _imeBufcount;
                //}-------------------------------------------------------------------------------------

                //_EditBuf_Text() Լθ ó Ѵ.
                //̴ [ũ] ÿ ߺǾ ̴  ϱ  ̴.
                bool  _editbuf_text_on;  //(BASE : true)
                bool  _edit_caretpos_on; //(BASE : true)
                //[2007.03.08.][߰!!!]
                bool  _edit_paste_ing;   //(BASE : true)
                //[2007.03.09.][߰!!!]
                bool  _editbuf_text_no;  //(BASE : false)

                //[Լ ȿ ]
                //{
                    //[2012.03.27.ȭ][߰!!!]--------------------------------
                    //[:ȭ]  [̸]  ϱ Ѱ.
                    //
                    //[2012.06.16.][!!!]--------------------------------
                    //[˵C] δ ʿ.
                    //}-------------------------------------------------------

                    //[2012.03.27.ȭ][߰!!!]
                    bool  _no_Editbuf_Text; //(⺻:false).

                    //[2012.03.27.ȭ][߰!!!]
                    bool  _no_Scroll_Set; //(⺻:false).

                //}

                //[2009.05.07.][߰!!!]{-------------------------------------------------------------
                //_EDIT_CaretPos() Լ ȿ [ÿ]   Լ ȣϰ Ǵµ
                //[ǵ/ǻ츲] óó [ü]  [ÿ]   ϰ Ǿ
                //ߺ ó  ð ս .
                //, ̸ Ͽ ̷   Լ  Ű ʵ ϱ   ߰Ѵ.
                bool  _editBuf_Text_No_Select;
                //}-------------------------------------------------------------------------------------

                //[][2007.01.22.]
                //{
                    //--------------------------------------------------------------------------
                    //[]   Ǵ    Ѵ.
                    //  []    ̹Ƿ []   Ѵ.
                    // -1  ʱȭ ϴµ ̰  [ÿ]  ٴ  Ѵ.
                    // ϳ -1   [ÿ   .]

                    //[ÿ]  ϴ  ġ( [Է] ġ).
                    struct GEditorEdit_CARETINFO  _select_start;

                    //[ÿ]      ġ( [Է] ġ).
                    //  ġ ƴϴ.
                    //̴ [ÿ] ڿ ̸  ϱ  ̴.
                    //ѱ  2 byte ̹Ƿ ù     ̴.
                    //,  ġ ںʹ Ϲ  ־  Ѵ.
                    struct GEditorEdit_CARETINFO  _select_end;

                    //[!!!][2007.02.14.][߰!!!]
                    //  [ÿ]    ⿡   "start < end" 
                    //谡  Ƿ ݵ _SELECT_Get_StartEndIndex() Լ
                    //ũ    ؾ Ѵ.
                    //--------------------------------------------------------------------------

                    //[ΰ]
                    //{
                        //[ÿ]  ϴ  ȴ.(鶧  ΰ   ȴ.)
                        //[콺]  ⸦ Ͽ [ÿ]  Ҷ, [shift + Ű]  Ͽ
                        //[ÿ]     ̹ ÿ  ˷ش.
                        //true  :  [ÿ]  ۵ ´.
                        //false : [ÿ]   .
                        bool  _select_ing;

                    //}

                //}

                //[2007.02.09.][߰!!!]
                //[콺]  [(true)]   ˸.
                bool  _mouse_down; //(BASE : false)

                //[2007.02.10.][߰!!!]
                //<shift-key>     true.
                bool  _shift_down; //(BASE : false)

                //[2007.02.11.][߰!!!]
                // [̵]   true.
                bool  _scroll_ing; //(BASE : false)

            //}

            //[<Ctrl + Alt> + 콺 ̵ Ž]
            //{
                //[2010.08.28.][߰!!!]{------------------------------------------------------
                //콺   쵵 콺 Ӹ ̿ Ž ϵ
                //<Ctrl + Alt> Ű յ Ž  Ѵ.
                //[<Ctrl + Alt> + 콺 /]  ̵  ó <Ctrl>   ġ 
                // ̵ ǰ, <Ctrl>   ġ Ʒ Ʒ ̵ȴ.
                //  ,  ߴ.
                // Ÿ Žϴµ []   ߴ.
                //}------------------------------------------------------------------------------

                // []  [ȭ] Y ġ  .
                //̴ Ctrl   ġ Ȯϰ ˱  ̴.
                int   _mousePosY; // ȴ.

                //<Ctrl>    []  Y ġ .
                int   _mousePosY_Ctrl;

                //[2011.05.06.][߰!!!]{---------------------------------------------------------
                //<Ctrl + Alt>   <true>  ϰ,    <false>  Ѵ.
                //  [̵  ]  ϴ [  [] ̵ ׷ֱ Ͽ
                //ݵ ʿϴ.
                // []  []   ٽ ׷  ׷ ̴.
                bool  _mouseCtrlAlt;
                //}---------------------------------------------------------------------------------

            //}

            //[ؼ]
            //{
                //[2012.06.08.][߰!!!]{------------------------------------
                // "{", "}" ġ ߱   ֱ Ѱ.
                //   [ؼ]  ִ .
                //
                //[]  ǥ Ǿ [̵]   ̵Ѵ.
                //
                //[߿!!!]----------------------------------------------------
                //[]    ϴ.
                //}------------------------------------------------------------

                //[] ȿ/ȿ.
                bool  _vLineEn; //(⺻:false)

                //[]   X ǥ.
                //[̵]   ̵Ѵ.
                //⺻δ <Ctrl+'G'>  [Է] X ǥ ȴ.

                // <_Edit_Col()>  ׻ Ȯ  
                //<_caretindexwidth> ġ ȴ.
                int   _vLineX; //(⺻: -1)

            //}

            //[  ]
            //{
                //-------------------------------------------------------
                // ϴ  + 1  ũ⸦  ־ Ѵ.
                #define  d_GEditorEdit_TEXTINFO_max    41
                struct GTEXTINFO  _textinfo[d_GEditorEdit_TEXTINFO_max];

                // Ǵ []  Ѽ.
                int              _textinfo_count; //(BASE : 0)

                // ǥõ []  index;
                int              _textinfo_index; //(BASE : -1)

                //[2007.03.28.][߰!!!]
                int              _newfile_count;  //(BASE : 0)
                //-------------------------------------------------------

                //[   ]
                //{
                    //[2010.03.21.][߿߰!!!]{-------------------------------------------
                    //  ִ  Ѽ Ѵ.
                    // ̻    ؾ  ߻ ʴ´.
                    //ٸ     Ҽ ֵ   ش.
                    // <d_TEXTINFO_max> ǰ -1   ؾ Ѵ.
                    //  1   ξ ϴ ̴.
                    //̴ <_TEXTINFO_Delete()> Լȿ    ϴ 
                    // Ųٰ Ƿ ߻ϴ    ڿ 1  
                    //ξ Ѵ.
                    //}-----------------------------------------------------------------------

                    int  _textMaxCount;

                //}

            //}

            //[Լ]
            //{
                //[2012.06.09.][Ϸ!!!]
                void __fastcall _EDIT_Init(void);

                //[2007.10.09.ȭ][Ϸ!!!]
                void __fastcall _EDIT_TextOut(char  pText[]);

                //[2006.12.19.ȭ][Ϸ!!!]
                bool __fastcall _EDIT_IS_ImeHangul(void);

                //[2006.12.19.ȭ][Ϸ!!!]
                void __fastcall _EDIT_Change_ImeMode(void);

                //[2009.06.02.ȭ][Ϸ!!!]
                void __fastcall _EDIT_Changed(bool  pALWAYS,
                                              bool  pCHANGED);

                //[2012.05.05.][Ϸ!!!]
                //[BCB/˵C]  .
                bool __fastcall _EDIT_SaveCheckChanged_whenCloseThis(int  pLISTindex);

                //[2012.05.05.][Ϸ!!!]
                //[BCB/˵C]  .
                bool __fastcall _EDIT_SaveCheckChanged_whenCloseAll(void);

                //[2006.12.23.][Ϸ!!!]
                void __fastcall _EDIT_Get_TextOrigin(void);

                //[2012.06.09.][Ϸ!!!]
                void __fastcall _EDIT_CaretPos(int  pX,
                                               int  pY);

                //[2009.05.25.][Ϸ!!!]
                void __fastcall _Edit_Col(int   pCaretindex);

                //[2006.12.27.][Ϸ!!!]
                void __fastcall _EDIT_Get_Kor_Eng_Moonja_Width(void);

                //[2012.04.15.][Ϸ!!!]
                void __fastcall _EDIT_V_Scroll(void);

                //[2012.04.15.][Ϸ!!!]
                void __fastcall _EDIT_H_Scroll(void);

                //[2007.03.15.][Ϸ!!!]
                void __fastcall _KEY_PageUp(void);

                //[2007.03.15.][Ϸ!!!]
                void __fastcall _KEY_PageDown(void);

                //[2006.12.27.][Ϸ!!!]
                void __fastcall _CARETINDEX_CaretIndexWidth(int   pLINEstartINDEX,
                                                            int   pCARETINDEX,
                                                            int  *rCARETINDEXwidth,
                                                            int  *rMOONJAcount);

                //[2006.12.27.][Ϸ!!!]
                void __fastcall _CARETINDEXWIDTH_CaretIndex(int   pLINEstartINDEX,
                                                            int   pLINEendINDEX,
                                                            int  *prCARETINDEXwidth,
                                                            int  *rCARETINDEX,
                                                            int  *rMOONJAcount);

                //[2006.12.27.][Ϸ!!!]
                void __fastcall _CARETINDEX_MoveLeft(int   pLINEstartINDEX,
                                                     int  *prCARETINDEX);

                //[2006.12.27.][Ϸ!!!]
                void __fastcall _CARETINDEX_MoveRight(int   pLINEendINDEX,
                                                      int  *prCARETINDEX);

                //[2007.03.01.][Ϸ!!!]
                void __fastcall _MOUSEDOWN_Get_LineStartIndex(int   pLINEnumber,
                                                              int  *pLINEstartindex);

                //[2007.03.19.][Ϸ!!!]
                bool __fastcall _CARETPOS_MouseDown(int  pMOUSEdownX,
                                                    int  pMOUSEdownY);

                //[2012.06.09.][Ϸ!!!]
                void __fastcall _ROOT_TEXTINFO_Init(void);

                //[2012.06.09.][Ϸ!!!]
                void __fastcall _TEXTINFO_Format(struct GTEXTINFO  *pTEXTINFO);

                //[2007.01.03.][Ϸ!!!]
                void __fastcall _TEXTINFO_Init(void);

                //[2007.01.01.][Ϸ!!!]
                void __fastcall _TEXTINFO_Add(struct GTEXTINFO  *pTEXTINFO);

                //[2007.01.01.][Ϸ!!!]
                void __fastcall _TEXTINFO_Delete(int  pDELETEindex);

                //[2009.05.21.ahr][Ϸ!!!]
                int __fastcall _TEXTINFO_GetIndex_withFILEname(AnsiString  pFILEname);

                //[2012.06.09.][Ϸ!!!]
                void __fastcall _TEXTINFO_Backup(int  pINDEX);

                //[2012.06.09.][Ϸ!!!]
                void __fastcall _TEXTINFO_Restore(int  pINDEX);

                //[2007.04.10.ȭ][Ϸ!!!]
                bool __fastcall _TEXTINFO_IsChangedOne(void);

                //[2007.03.13.ȭ][Ϸ!!!]
                void __fastcall _KEY_Up(bool  pETCcontrol);

                //[2007.03.13.ȭ][Ϸ!!!]
                void __fastcall _KEY_Down(bool  pETCcontrol);

                //[2007.03.14.][Ϸ!!!]
                void __fastcall _KEY_Left(bool  pETCcontrol);

                //[2007.03.14.][Ϸ!!!]
                void __fastcall _KEY_Right(bool  pETCcontrol,
                                           bool  pSELECTtrue);

                //[2007.03.14.][Ϸ!!!]
                void __fastcall _KEY_Home(bool  pETCcontrol);

                //[2007.03.14.][Ϸ!!!]
                void __fastcall _KEY_End(bool  pETCcontrol);

                //[2009.05.09.][Ϸ!!!]
                void __fastcall _KEY_Enter(//[̷]  ϴ  true.
                                           bool  pHistoryAdd);

                //[2009.05.06.][Ϸ!!!]
                void __fastcall _KEY_Delete(//[̷]  ϴ  true.
                                            bool  pHistoryAdd);

                //[2009.05.08.][Ϸ!!!]
                void __fastcall _KEY_Backspace(void);

                //[2012.06.01.][Ϸ!!!]
                bool __fastcall _EDITBUF_MOONJA_Delete(int    pDELETEindex,
                                                       bool  *rIScrlf);

                //[2009.05.06.][Ϸ!!!]
                bool __fastcall _SELECT_Get_StartEndIndex(struct GEditorEdit_CARETINFO  *rSELECTstart,
                                                          struct GEditorEdit_CARETINFO  *rSELECTend);

                //[2012.06.01.][Ϸ!!!]
                bool __fastcall _SELECT_Delete(struct GEditorEdit_CARETINFO  *rSELECTstart,
                                               int               *rCRLFcount);

                //[2011.06.24.][Ϸ!!!]
                int __fastcall _SELECT_StartLineNum(void);

                //[2012.06.01.][Ϸ!!!]
                void __fastcall _EDITBUF_MOONJA_Insert(int    pINSERTindex,
                                                       short  pCODE);

                //[2012.06.01.][Ϸ!!!]
                void __fastcall _EditBuf_LineStr_Insert(int    pInsertIndex,
                                                        char  *pStr);

                //[2012.06.01.][Ϸ!!!]
                bool __fastcall _EditBuf_LineStr_Delete(//[]  ġ.
                                                        int  pDelIndex,
                                                        //[]  ũ.
                                                        int  pDelSize);
                //[2018.02.23.][Ϸ!!!]
                void __fastcall _CARET_MOONJA_Insert(short  pCODE,
                                                     //[̷]  ϴ  true.
                                                     bool   pHistoryAdd);

                //[2007.03.19.][Ϸ!!!]
                void __fastcall _SELECTSCROLL_Up(int  pMOUSEy);

                //[2007.03.19.][Ϸ!!!]
                void __fastcall _SELECTSCROLL_Down(int  pMOUSEy);

                //[2007.03.19.][Ϸ!!!]
                void __fastcall _SELECTSCROLL_Left(int  pMOUSEx);

                //[2007.03.19.][Ϸ!!!]
                void __fastcall _SELECTSCROLL_Right(int  pMOUSEx);

                //[2012.06.09.][Ϸ!!!]
                void __fastcall _EDIT_SelectDelete(void);

                //[2012.06.01.][Ϸ!!!]
                void __fastcall _EDIT_Paste(char *pPASTEstr,
                                            //[2009.05.07.][߰!!!]
                                            //ٽñ׸  true.
                                            bool   pReDraw);

                //[2007.03.21.][Ϸ!!!]
                void __fastcall _EDIT_SelectAll(void);

                //[2009.05.08.][Ϸ!!!]
                void __fastcall _Edit_SelectX(//  ġ.
                                              int    pSelStartIndex,
                                              //  ġ.
                                              int    pSelEndIndex,
                                              //true ΰ ׻ [ ]  ׻ ̴ ġ ְ Ѵ.
                                              bool   pSelView,
                                              //[ÿ]  []  ȯѴ.
                                              int   *rStartLineNumber,
                                              //[2009.05.07.][߰!!!]
                                              //ٽñ׸  true.
                                              bool   pReDraw);

                //[2009.05.08.][Ϸ!!!]
                void __fastcall _Mouse_WordSelect(void);


                //[2011.07.19.ȭ][Ϸ!!!]
                void __fastcall _Select_CaretIndex(//<_select_start/_select_end>  Ѵ.
                                                   struct GEditorEdit_CARETINFO  *pSelectX_CaretInfo,
                                                   //[Է] ġ.
                                                   int                pCaretIndex);

            //}

            //[ڿó]
            //{
                //ٸ  ϸ ǹǷ 1024  ܾ ϸ ϴ.
                #define  d_WORDCONFIG_max   1024
                struct GEditorEdit_WORDCONFIG  _wordconfig[d_WORDCONFIG_max];
                int                            _wordconfig_count;

                //[2011.05.11.][Ϸ!!!]
                void __fastcall _WORD_LineGet(char  *pSTR,
                                              int    pINDEX,
                                              char   rWORD[],
                                              int   *rWORDindex,
                                              int   *rWORDlength);

                //[2011.06.06.][Ϸ!!!]
                void __fastcall _MOONJACONFIG_LineGet(int   pLINEstartindex,
                                                      int  *rLineEndIndex);

                //[2018.09.11.ȭ][Ϸ!!!]
                //  [] ó ߰!!!
                void __fastcall _MoonjaConfig_LineGet_C(int   pLineStartIndex,
                                                        int  *rLineEndIndex);

                //[2011.06.06.][Ϸ!!!]
                void __fastcall _MoonjaConfig_LineGet_Gasm(int   pLineStartIndex,
                                                           int  *rLineEndIndex);

                //[2009.05.09.][Ϸ!!!]
                void __fastcall _MoonjaConfig_LineGet_Gcsm(int   pLineStartIndex,
                                                           int  *rLineEndIndex);

                //[2011.06.02.][Ϸ!!!]
                void __fastcall _MoonjaConfig_LineGet_Obj(int   pLineStartIndex,
                                                          int  *rLineEndIndex);

                //[2011.06.06.][Ϸ!!!]
                void __fastcall _MoonjaConfig_LineGet_Gtmp(int   pLineStartIndex,
                                                           int  *rLineEndIndex);

                //[2009.05.09.][Ϸ!!!]
                void __fastcall _MoonjaConfig_LineGet_Default(int   pLineStartIndex,
                                                              int  *rLineEndIndex);


                //[/* ... */ ּ ]
                //{
                    //[VAR]
                    //{
                        //[2009.06.02.ȭ][߰!!!]{-----------
                        //{/* ... */} ּ  Ѵ.
                        //}-----------------------------------

                        struct GCOMMENTBLOCK_INFO  _cmtBlockInfo;

                    //}

                    //[2012.05.09.][Ϸ!!!][߿!!!]
                    //[ּ]  Ǿ ü <_EditBuf_Text()>  ٽ ׸
                    //ʿ䰡 ִ  <true>  ȯ.
                    //[2012.06.14.][Ϸ!!!]
                    //[]    ִٸ ü ٽ ׸.
                    bool __fastcall _CommentBlock_Info(//κó  <true>.
                                                       bool  pPartInfo);

                    //[2009.06.02.ȭ][Ϸ!!!]
                    bool __fastcall _CommentBlock_Check_Word(int  pWordIndex);

                    //[2009.06.02.ȭ][Ϸ!!!]
                    //bool __fastcall _CommentBlock_SymbolCheck(char  *pStr,
                    //                                          //<pStr: NULL>  츸 ȿϴ.
                    //                                          //ڿ ϴ  ׳ 0  ش(ƹ̳ ϴ).
                    //                                          int    pStartIndex,
                    //                                          int    pEndIndex);

                //}

                //[2019.01.09.][Ϸ!!!]
                bool __fastcall _EDITBUF_LINE_Out(int   pX,
                                                  int   pY,
                                                  int   pLINEstartindex,
                                                  int  *rLINEendindex);

                //[2012.06.09.][Ϸ!!!]
                bool __fastcall _EDITBUF_STRING_Out(int  pX,
                                                    int  pY,
                                                    int  pLINEstartindex);

                //[2009.05.09.][Ϸ!!!]
                bool __fastcall _CARET_ViewAlways(//  ʰ Ȯθ ϴ  true.
                                                  bool  pSimulate);

                //[2009.05.08.][Ϸ!!!]
                bool __fastcall _Caret_ViewAlways_Middle(//׻ ʵ ߰ ġ.
                                                         bool  pAlwaysTopMiddle,
                                                         //׻ Ʒʵ ߰ ġ.
                                                         bool  pAlwaysBottomMiddle);

            //}

            //[Ŭ]
            //{
                //[2007.03.06.ȭ][Ϸ!!!]
                bool __fastcall _CLIPBOARD_IsText(void);

                //[2007.03.07.][Ϸ!!!]
                void __fastcall _CLIPBOARD_Copy(void);

                //[2012.06.11.][Ϸ!!!]
                void __fastcall _CLIPBOARD_Cut(void);

                //[2019.03.08.][Ϸ!!!]
                void __fastcall _CLIPBOARD_Paste(void);

            //}

        //}

        //[̵]
        //{
            //[2012.01.28.][߰!!!]{-------------------------------------
            //[Ctrl + =>] Ǵ [Ctrl + =>] Ǵ  ȭڷ Ǵ
            //ÿ ԵǴ   [̵]   κ .
            //}-------------------------------------------------------------

            //[2012.02.07.ȭ][Ϸ!!!]
            bool __fastcall _LineBlock_MoveRL_Right(//߰ .
                                                    int  pSpaceCount);

            //[2012.03.03.][Ϸ!!!]
            bool __fastcall _LineBlock_MoveRL_Left(// .
                                                   int  pSpaceCount);

            //[̷ ]
            //{
                //[2012.02.04.][Ϸ!!!]
                void __fastcall History_MoveRL_Right(// [Է] ġ.
                                                     int  pCaretIndex,
                                                     //ó [ ġ].
                                                     int  pStartLineStartIndex,
                                                     //ó [ ġ].
                                                     int  pEndLineStartIndex,
                                                     //̵ .
                                                     int  pSpaceCount);

                //[2012.02.05.][Ϸ!!!]
                void __fastcall History_MoveRL_Left(// [Է] ġ.
                                                    int  pCaretIndex,
                                                    //ó [ ġ].
                                                    int  pStartLineStartIndex,
                                                    //ó [ ġ].
                                                    int  pEndLineStartIndex,
                                                    //̵ .
                                                    int  pSpaceCount);

                //[2012.02.06.][Ϸ!!!]
                void __fastcall History_MoveRL_Add(//̵ ('>', '<').
                                                   char  pKind,
                                                   //Է ġ ġ(  ġ).
                                                   //[̵]  <pStartLineStartIndex>  .
                                                   int   pCaretIndex,
                                                   //<:ġ>.
                                                   // ġ  / ׻    ʴ´.
                                                   int   pStartLineStartIndex,
                                                   // <:ġ>.
                                                   int   pEndLineStartIndex,
                                                   // <:ġ>.
                                                   int   pEndLineStartIndex_moved,
                                                   //̵ .
                                                   int   pMoveCount);

            //}

        //}

        //[ǵ ]
        //{
            //[!]{-----------------------------------------
            //[ǵ/ǻ츲]  óϴ Լ .
            //}--------------------------------------------

            //[VAR]
            //{
                //[2009.05.02.][߰!!!]
                struct GHISTORY  _history;

            //}

            //[̷ ⺻Լ]
            //{
                //[2009.05.02.][Ϸ!!!]
                void __fastcall History_Init(void);

                //[2009.06.03.][Ϸ!!!]
                bool __fastcall History_CheckAndMake(void);

                //[2009.06.03.][Ϸ!!!]
                //[2012.02.05.][!!!]
                // Լ [Ϲ ]  츸 ȴ.
                //[̵]    Լ Ѵ.
                void __fastcall History_Add(//߰('+') ('-') Ѵ.
                                            char  pChangeKind,
                                            //[2009.05.06.][߰!!!]
                                            //<c:>, <s:ڿ>  Ѵ.
                                            char  pCharString);

                //[2012.06.11.][Ϸ!!!]
                void __fastcall History_UnDo(void);

                //[2012.06.11.][Ϸ!!!]
                void __fastcall History_ReDo(void);

                //[2012.06.13.][Ϸ!!!]
                void __fastcall History_SetCaretPos(//[Է] ġ.
                                                    int    pCaretIndex,
                                                    //[Է]  ׻ ̴ ġ α:true.
                                                    bool   pCaretView);

                //[2009.05.08.][Ϸ!!!]
                void __fastcall History_SelectX(//  ġ.
                                                int    pSelStartIndex,
                                                //  ġ.
                                                int    pSelEndIndex,
                                                //true ΰ ׻ [ ]  ׻ ̴ ġ ְ Ѵ.
                                                bool   pSelView,
                                                //[ÿ]  []  ȯѴ.
                                                int   *rStartLineNumber,
                                                //ٽ ׷(true)/(false) Ѵ.
                                                bool   pReDraw,
                                                //[2009.05.08.][߰!!!]
                                                //[Է]   .
                                                bool   pAlwaysTopMiddle,
                                                //[Է] Ʒ  .
                                                bool   pAlwaysBottomMiddle);

            //}

            //[̷ Ư ó Լ]
            //{
                //[2012.02.05.][!!!]{---------------------------------------
                //[̵]  [̷] Լ ߰ϸ鼭,  [̷]
                //ó Ư Լ  ʿ䰡 ־   ´.
                //}---------------------------------------------------------------

                //[2009.05.02.][Ϸ!!!]
                void __fastcall History_SelectDelete(void);

                //[2012.06.01.][Ϸ!!!]
                void __fastcall History_Insert(char  *pInsertStr,
                                               //[2009.05.07.][߰!!!]
                                               //ٽñ׸  true.
                                               bool   pReDraw);

                //[2009.05.05.ȭ][Ϸ!!!]
                void __fastcall History_FileSave(char  *pFileFullName);

                //[2009.05.05.ȭ][Ϸ!!!]
                void __fastcall History_FileOpen(char  *pFileFullName);


                //[2009.05.15.][Ϸ!!!]
                void __fastcall History_EditFileSave(void);

                //[2009.05.05.ȭ][Ϸ!!!]
                void __fastcall History_EditFileOpen(void);


                //[2009.05.05.ȭ][Ϸ!!!]
                void __fastcall History_FileDelete(char  *pFileFullName);

            //}

        //}

        //[]
        //{
            //[2007.04.08.][߰!!!]{---------------------------------------------
            //[]   bmp   ǰ, ׷  ٽ _bmp_ 
            //Ͽ ü ϼϴ  ȴ.
            //̴ [ ̵] ÿ Ϻϰ []  ȭ ϱ  ̴.
            //}---------------------------------------------------------------------

            //[VAR]
            //{
                //[2012.06.08.][!!!]{------------------------------------------------
                //<_bmp_>   ÷ [:]   ũⰡ ȴ.
                //ũ ÷  ʱ  ׸ ӵ  ȭ ϱ Ͽ
                // ʿ ũ ׻ ǵ Ѵ.
                //}------------------------------------------------------------------------
                
                Graphics::TBitmap  *_bmp_debug;

                //[  ׸]
                //{
                    //Ҷ Ӽ  ־ Ѵ.

                    //[]
                    Graphics::TBitmap  *_bmp_breakpoint_;

                    //[2018.09.11.ȭ][߰!!!]{******************************************
                    //[:]   µ .
                    // ׳  ĥϴ Ŀ [:]  [] ϰ
                    //ִ  ݰؼ ʿ.
                    //⿡ [̵:]   []  ׸,  ׸
                    //״ [] ࿡ [(:)]  ϴ  .
                    Graphics::TBitmap  *_bmp_BreakPointLine_;
                    //}******************************************************************

                    //[ ]
                    Graphics::TBitmap  *_bmp_run_arrow_;

                //}

                //scroll  ֱ Ͽ ϴ   y.(BASE : 0)
                int                 _scroll_y;

                //[]  ǥ [/]  Ѵ.(BASE : false)
                bool                _run_arrow_visible;

                //[]  ġ  Ѵ.(scroll    .)
                int                 _run_arrow_line;
            //}

            //[Լ]
            //{
                //[2018.09.11.ȭ][Ϸ!!!]
                void __fastcall _DEBUG_Init(void);

                void __fastcall _DEBUG_Shape(void);
                void __fastcall _DEBUG_BreakPoint(void);

                //[2018.09.04.ȭ][Ϸ!!!]
                void __fastcall _DEBUG_RunArrow(int   pLINEnumber,
                                                bool  pSELFdraw);
                void __fastcall _DEBUG_RunArrow_Show(void);
                void __fastcall _DEBUG_RunArrow_Hide(void);
                void __fastcall _DEBUG_Scroll(int  pPOSITION);
                void __fastcall _DEBUG_Draw(void);

                //[2012.08.19.][Ϸ!!!]
                void __fastcall _DEBUG_Indicator_Hide(void);

            //}

        //}

        //[]
        //{
            //[]     ȴ.

            //[VAR]
            //{
                //[2007.04.12.][߰!!!]
                //[]  ϱ  ü .
                //̴     ȴ.
                struct GBREAKPOINT  _breakpoint;
                int                 _breakline_color;

                //[2018.09.11.ȭ][߰!!!]{***********************************************
                //<_BREAKPOINT_Edit_Draw()>  [:]  <_bmp_BreakPointLine_> 
                //׸   <_breakline_color>  Ѵ.
                //̴   Ǵ  ̸ ϰ ٽ ׷ֱ  .
                //ٽ ׸⿡ ð ɸǷ  [ѹ]  ׸ Ѱ.
                int                 _breakline_color_Save; //(⺻: -1)
                //}***********************************************************************

                //[  ]
                //{
                    //[]  [/ȿ] ¿  Ǵ Ʈ ٸ ϱ  ̴.

                    #define  d_Editor_BreakPoint_Enable    1 //[] ȿ.
                    #define  d_Editor_BreakPoint_Disable   0 //[] ȿ.

                //}

            //}

            //[Լ]
            //{
                //[2007.04.12.][Ϸ!!!]
                void __fastcall _BREAKPOINT_Init(struct GBREAKPOINT  *pBREAKpoint);

                int __fastcall _BREAKPOINT_Search(int  pLINEnumber);

                bool __fastcall _BREAKPOINT_Add(int  pLINEnumber);

                void __fastcall _BREAKPOINT_Delete(int  pLINEnumber);

                void __fastcall _BREAKPOINT_DebugPanel_Draw(bool pERASEback,
                                                            int  pLINEnumber);

                //[2012.08.19.][Ϸ!!!]
                void __fastcall _BREAKPOINT_Set(// ġ.
                                                //[2012.08.19.][߿!!!]{----------------------------------
                                                // <pPosX, pPosY> ΰ μ [˵C]  [׸ǰ] 
                                                //ʿ䰡 . ,  ȥ  Ͽ  ´.
                                                // δ  ʱ  ÿ <0>  Ҵ.
                                                int  pPosX,
                                                int  pPosY,
                                                //}--------------------------------------------------------------
                                                int  pLINEnumber);

                //[2018.09.11.ȭ][Ϸ!!!]
                void __fastcall _BREAKPOINT_Edit_Draw(int  pLINEnumber);

                //[2007.04.15.][Ϸ!!!]
                void __fastcall _BREAKPOINT_Edit_DrawAll(void);

                //[2007.04.16.][Ϸ!!!]
                void __fastcall _BREAKPOINT_Edit_Verify_Draw(int  pLINEnumber);

                //[2007.04.16.][Ϸ!!!]
                void __fastcall _BREAKPOINT_Edit_StartLine_Draw(int  pLINEnumber);

                //[2009.04.29.][Ϸ!!!]
                void __fastcall _BREAKPOINT_Bmp(int  pBmpIndex);

            //}

        //}

        //[  ]
        //{
            //[2007.12.04.ȭ][Ϸ!!!]
            void __fastcall _BACKBMP_Brightness(int  pBrightness);

            //[2018.07.31.ȭ][Ϸ!!!]
            void __fastcall _BACKBMP_ChangeJpeg(AnsiString  pJpegFilePath);

        //}

        //[ΰԼ]
        //{
            //[2007.12.03.][Ϸ!!!]
            void __fastcall _Debug_BreakPoint_RePaint(void);

            //[2007.12.03.][Ϸ!!!]
            //void __fastcall _Debug_Arrow_RePaint(void);

            //[2011.05.06.][Ϸ!!!]
            void __fastcall _CtrlAltMouse_ScrollAreaDotLine(void);

            //[2012.08.14.ȭ][Ϸ!!!]
            void __fastcall _VLine(void);
            //{
                //[2012.06.09.][߰!!!]
                //<_VLine()> Լ [/ȿ] .
                //<Ctrl+G>   ׻ <true>  .
                bool  _sw_VLine; //(⺻:true);

            //}

        //}

        //[ã ȭ ]
        //{
            //[2019.01.09.][Ϸ!!!]
            void __fastcall _FindDialog_Show(void);

        //}

        //[å ȭ]
        //{
            //[2012.03.01.][߰!!!]{-------------------------------------------------
            //[2012.03.03.][!!!]--------------------------------------------------
            //<bookMark_DialogBox.cpp>  []   <_bookMark_DialogBox> 
            //[]   [] ȴٴ Ϳ !!!
            //}-------------------------------------------------------------------------

            //class BookMark_DialogBox  *_bookMark_DialogBox;

        //}


};

//---------------------------------------------------------------------------
extern PACKAGE TGEditorEdit_Form *GEditorEdit_Form;
//---------------------------------------------------------------------------

#endif
