//---------------------------------------------------------------------------

#ifndef gui_editH
#define gui_editH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------

#include  "font.h"

#include  "MyTypes.h"

#include  "ide_main.h"
#include  "gui_caret.h"
#include  "ide_popup.h"


class Tgui_edit_Form : public TForm
{                                                                //[2018.02.14.]
__published:	// IDE-managed Components
        void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
          
private:	// User declarations
public:		// User declarations

        __fastcall Tgui_edit_Form(TComponent* Owner);

        //[2012.04.29.][Ϸ!!!]
        __fastcall ~Tgui_edit_Form(void);

        //[Ŭ]
        //{
            //[2018.02.14.][Ϸ!!!]
            void __fastcall WndProc(Messages::TMessage &Message);

        //}

        //[VAR]
        //{
            //[ȯ溯]
            //{
                //[2007.10.02.ȭ][߰!!!]
                struct  IDE_OPTION   *_ide_option;

            //}

            //[ ׸ ]{-----------
            Graphics::TBitmap  *_bmp_;

            //  ׸.
            Graphics::TBitmap  *_bmp_back_;
            //}-----------------------------

            //[۲]{--------------
            struct FONTPACK     _font;
            //}------------------------

            // Ʈ    .
            int                 _line_height;
            // Ʈ   Ѱ .
            int                 _word_width;

            //[]
            //{
                //⺻ ũ 10M 뷮 Ѵ.
                //ɼ  Ҽ ־ ϹǷ Ҽ ֵ Ѵ.
                char               *_editbuf;
                // []   []  Ѱ Ƿ ƿ  ũ⸦ 
                //Ͽ  ȿ ÿ []  ũ⸦  ʿ䰡  .
                //10M   ̴.

            //}

            //[ ӽ ó ]
            //{
                //[2007.04.09.][߰!!!]
                //_editbuf[]  [/ڿ]   ֱ  []  Ҷ
                //for()  ϴ     ó ӵ .
                //memmove() Լ Ҽ   ó ѵ, Ѱ ҷδ ҰϹǷ
                //_editbuf[]   ũ []   memmove() Լ Ͽ о ڿκ
                //̰ ϰ -> ڿ   -> ٽ ϻؼ ִ̾  Ѵ.
                // memmove() Լ ϰ ǹǷ  óҼ ִ.
                char               *_tempbuf;

            //}

            //[2007.09.28.][߰!!!]
            //{
                // ̵밡 Ƿ  ġ Ͽ Ѵ.
                int _scroll_h_position;

            //}

            //[2008.02.03.][߰!!!]{-----------------------------------------
            //[ǳ]   ڿ .
            //, ޸   Ͽ ش   츸 óѴ.
            bool   _balloonHelpUse; //(⺻ : false)

            //  ũ⸦ ־ Ѵ.
            char  *_balloonHelpStr;
            //}-----------------------------------------------------------------

        //}

        //[  ü]
        //{
            //[ɸ]
            //{
                //[2007.03.06.ȭ][߰!!!]
                Tide_popup_Form  *_popup_menu_;

                //[Լ]
                //{
                    //[׸]  ׸ õ  ȣȴ.
                    //[2007.03.31.][Ϸ!!!]
                    void __fastcall _EVENT_PopupMenu(void);

                //}
                
            //}

            //[Enter Ű  Լ]
            //{
                //[2009.04.10.][߰!!!]{----------
                //[Enter Key]    ߻Ѵ.
                //}----------------------------------

                void __fastcall (__closure * _EVENT_KeyEnter)(void);

                //[2012.05.20.][߰!!!]
                //<Ű:ESC>    .
                void __fastcall (__closure * _EVENT_KeyDown_Esc)(void);


                //[2019.03.02.][߰]
                //{
                    //[!]{---------------------------------------------------
                    //[ã:ȭ]  [ܾ:]   Ѱ.
                    //}------------------------------------------------------

                    //[]   ִ  ߻(//߶󳻱/̱   ).
                    void __fastcall (__closure * _EVENT_Change)(void);

                    void __fastcall (__closure * _EVENT_KeyDown_Left)(void);

                    void __fastcall (__closure * _EVENT_KeyDown_Right)(void);

                    void __fastcall (__closure * _EVENT_KeyDown_Up)(void);

                    void __fastcall (__closure * _EVENT_KeyDown_Down)(void);

                    void __fastcall (__closure * _EVENT_KeyDown_Home)(void);

                    void __fastcall (__closure * _EVENT_KeyDown_End)(void);

                //}

            //}

        //}

        //[FUNCTION]
        //{
            //[2008.02.03.][Ϸ!!!]{--------------------
            void __fastcall _BalloonHelpUse(bool    pUse);
            void __fastcall _BalloonHelpStr(char   *pStr);
            //}--------------------------------------------

            void __fastcall _Shape(void);

            void __fastcall _Draw(void);

            void __fastcall _Width(int  pWidth);

            //[2007.03.26.][Ϸ!!!]
            void __fastcall _EditBuf_Text(void);

            //[2006.12.17.][Ϸ!!!]
            void __fastcall _EditBuf_Clear(void);

            void __fastcall _EDIT_Get_TextOrigin(void);
            void __fastcall _EDIT_H_Scroll(void);

        //}

        //[]
        //{
            //[2012.09.23.][߰!!!]{------------------------------------------
            //[ ۼ]  <editor_edit>  ߰ϴ  ʿϿ .
            //}------------------------------------------------------------------

            //[VAR]
            //{
                int  _backColor;

            //}

            //[2012.09.23.][Ϸ!!!]
            void __fastcall _BackColor(int  pColor);

        //}

        //[]
        //{
            //[VAR]
            //{
                //[ذ]
                //{
                    //[ѱ/]   ǥ  []  .
                    // []   ۲ø ǹǷ [ѱ/]  Ѱ
                    //[]  ٸ ó Ͽ  ־ Ѵ.
                    //  [۲]  Ҷ ѹ س ȴ.
                    int  _font_kor_width;
                    int  _font_eng_width;
                //}

                //[]
                //{
                    //  µǴ    ȴ.
                    //[Է] ġ, [/] ǥ     ǥ  Ѵ.
                    int  _text_org_x;
                    int  _text_org_y;
                //}

                //[]
                //{
                    //[]    Ѵ.
                    //ϴµ ð  ŸǷ ׻ ô   ƾ Ѵ.
                    // ٲ []  (Enter/Del/Back Ű  ߶󳻱, ̱) 
                    //   ôϿ Ȯ   ƾ Ѵ.
                    //,    ⺻   ´.
                    //, [ ]  1  ǹ̰ ִ. ([ ȣ]  0  ǹ̰ Ƿ ȥ ʾƾ Ѵ.)
                    // ̶ [Է]  ġؾ ϹǷ ּ Ѱ  ־Ѵ.
                    int  _linecount; //(BASE : 1)

                    //  _editbuf[]   index( ù  ġ)  Ѵ.
                    // Ȳ    ־ ϰ ׻ Ȯ   ־ Ѵ.
                    int  _linestartindex; //(BASE : 0)

                    //_linestartindex ʹ ޸ ׻  ʿ  ʿҶ ȴ.
                    //    ġ + 1  ġ ´.
                    //Ϲ    CRLF  CR(0x0d)  ġ   
                    //CRLF    쵵 Ƿ Ϲ   ġ + 1  ġ
                    // ϸ ϴ.
                    int  _lineendindex; //(BASE : 0)

                    // _editbuf[]  ִ  byte  ũ.(ڿ  '\0'   ũ.)
                    //FILE_Open_inBUF() Լ    ڿ  '\0'  ũ⿡ Եȴ.
                    int  _filesize;

                    //[̴  ]
                    //{
                        //Ϲ [ũ] Ǵ   ٲ ǹǷ ̶ Ѵ.

                        //[] â ̴   [ ȣ]  Ѵ.
                        //[ ȣ]  0  ȿϴ.
                        int  _linetop_linenumber; //(BASE : 0)

                        //[] â ̴    index  Ѵ.
                        int  _linetop_startindex; //(BASE : 0)
                    //}

                    //[߿!!!]
                    //{
                        //------------------------------------------------------------------------
                        //_editbuf[]   [Է]  ġ  index  ´.
                        // ⺻ Ǵ ̸, ٸ    ǹǷ  Ͽ
                        //Ȯ   ־ Ѵ.
                        int  _caretindex; //(BASE : 0)

                        //_caretindex ġ  ǥû  ó []  .
                        int  _caretindexwidth; //(BASE : 0)
                        //------------------------------------------------------------------------
                    //}

                    //[/]
                    //{
                        //-----------------------------------------------------------------------------
                        //[Է]  / ̵ÿ  []  ؼ ġ ãƾ Ѵ.
                        //  editor_info_Form  ش ġ  ǥ ɼ ־ Ѵ.
                        int  _row;
                        int  _col;
                        //-----------------------------------------------------------------------------
                    //}
                    
                //}

                //[Է]
                //{
                    //-------------------------------------------------------
                    //ü ´.
                    Tgui_caret_Form  *_caret;

                    //ǥ ġ.
                    //(_text_x, _text_y) ġ  Ѵ.
                    //  offset ǥ ̹Ƿ  ""  ɼ .
                    int  _caret_x; //(BASE : 0)
                    int  _caret_y; //(BASE : 0)
                    //-------------------------------------------------------
                //}

                //Ѱ Ѵ.(ѱ/ ϼ Ƿ 2byte   Ѵ.)
                short  _moonja;
                bool   _ime_TkorFeng; //(BASE : false)

                //[2008.02.13.][߰!!!]{-------------------------------------------------------------
                //ѱ   ԷµǸ ѱ  ϼǴµ ̶ Է ȣ
                // ־ ϴµ ̶ ѱ   ڸ .
                //) ѱ  '2'  ԷϿ  ٸ '2' ڰ  ־ Ѵ.
                //̸ Ͽ WM_IME_COMPOSITION óο ImmGetCompositionString() Լ
                //Ͽ "2"  ڿ о óҼ ִ.
                //߿ '2' ڸ   ߿Ѵ. ''  WParam    Ƿ...

                HIMC   _imeHimc;         //IME ڵ.
                char   _imeBuffer[1024]; //ime ۿ  ڿ  Ѵ.
                int    _imeBufcount;
                //}-------------------------------------------------------------------------------------

                //_EditBuf_Text() Լθ ó Ѵ.
                //̴ [ũ] ÿ ߺǾ ̴  ϱ  ̴.
                bool  _editbuf_text_on;  //(BASE : true)
                bool  _edit_caretpos_on; //(BASE : true)
                //[2007.03.08.][߰!!!]
                bool  _edit_paste_ing;   //(BASE : true)
                //[2007.03.09.][߰!!!]
                bool  _editbuf_text_no;  //(BASE : false)

                //[][2007.01.22.]
                //{
                    //--------------------------------------------------------------------------
                    //[]   Ǵ    Ѵ.
                    //  []    ̹Ƿ []   Ѵ.
                    // -1  ʱȭ ϴµ ̰  [ÿ]  ٴ  Ѵ.
                    // ϳ -1   [ÿ   .]

                    //[ÿ]  ϴ  ġ( [Է] ġ).
                    struct CARETINFO  _select_start;

                    //[ÿ]      ġ( [Է] ġ).
                    //  ġ ƴϴ.
                    //̴ [ÿ] ڿ ̸  ϱ  ̴.
                    //ѱ  2 byte ̹Ƿ ù     ̴.
                    //,  ġ ںʹ Ϲ  ־  Ѵ.
                    struct CARETINFO  _select_end;

                    //[!!!][2007.02.14.][߰!!!]
                    //  [ÿ]    ⿡   "start < end" 
                    //谡  Ƿ ݵ _SELECT_Get_StartEndIndex() Լ
                    //ũ    ؾ Ѵ.
                    //--------------------------------------------------------------------------

                    //[ΰ]
                    //{
                        //[ÿ]  ϴ  ȴ.(鶧  ΰ   ȴ.)
                        //[콺]  ⸦ Ͽ [ÿ]  Ҷ, [shift + Ű]  Ͽ
                        //[ÿ]     ̹ ÿ  ˷ش.
                        //true  :  [ÿ]  ۵ ´.
                        //false : [ÿ]   .
                        bool  _select_ing;
                    //}
                //}

                //[2007.02.09.][߰!!!]
                //[콺]  [(true)]   ˸.
                bool  _mouse_down; //(BASE : false)

                //[2007.02.10.][߰!!!]
                //<shift-key>     true.
                bool  _shift_down; //(BASE : false)

                //[2007.02.11.][߰!!!]
                // [̵]   true.
                bool  _scroll_ing; //(BASE : false)
            //}

            //[Լ]
            //{
                //[2007.01.18.][Ϸ!!!]
                void __fastcall _EDIT_Init(void);


                //[2010.06.28.][Ϸ!!!]
                void __fastcall _EDIT_TextOut(char  pText[]);



                //[2006.12.19.ȭ][Ϸ!!!]
                bool __fastcall _EDIT_IS_ImeHangul(void);
                void __fastcall _EDIT_Change_ImeMode(void);

                //[2007.04.08.][Ϸ!!!]
                void __fastcall _EDIT_CaretPos(int  pX,
                                               int  pY);
                //[2006.12.27.][Ϸ!!!]
                void __fastcall _EDIT_Get_Kor_Eng_Moonja_Width(void);

                //[2018.02.24.][Ϸ!!!]
                void __fastcall _CARETINDEX_CaretIndexWidth(int   pLINEstartINDEX,
                                                            int   pCARETINDEX,
                                                            int  *rCARETINDEXwidth,
                                                            int  *rMOONJAcount);
                //[2006.12.27.][Ϸ!!!]
                void __fastcall _CARETINDEXWIDTH_CaretIndex(int   pLINEstartINDEX,
                                                            int   pLINEendINDEX,
                                                            int  *prCARETINDEXwidth,
                                                            int  *rCARETINDEX,
                                                            int  *rMOONJAcount);
                //[2006.12.27.][Ϸ!!!]
                void __fastcall _CARETINDEX_MoveLeft(int   pLINEstartINDEX,
                                                     int  *prCARETINDEX);
                //[2006.12.27.][Ϸ!!!]
                void __fastcall _CARETINDEX_MoveRight(int   pLINEendINDEX,
                                                      int  *prCARETINDEX);

                //[2007.03.01.][Ϸ!!!]
                void __fastcall _MOUSEDOWN_Get_LineStartIndex(int   pLINEnumber,
                                                              int  *pLINEstartindex);

                //[2007.03.19.][Ϸ!!!]
                bool __fastcall _CARETPOS_MouseDown(int  pMOUSEdownX,
                                                    int  pMOUSEdownY);

                //[2007.03.17.][Ϸ!!!]
                void __fastcall _ROOT_TEXTINFO_Init(void);

                //[2007.03.14.][Ϸ!!!]
                void __fastcall _KEY_Left(bool  pETCcontrol);
                //[2007.03.14.][Ϸ!!!]
                void __fastcall _KEY_Right(bool  pETCcontrol,
                                           bool  pSELECTtrue);

                //[2007.03.14.][Ϸ!!!]
                void __fastcall _KEY_Home(bool  pETCcontrol);
                //[2007.03.14.][Ϸ!!!]
                void __fastcall _KEY_End(bool  pETCcontrol);

                //[2007.03.26.][Ϸ!!!]
                void __fastcall _KEY_Delete(void);
                //[2007.03.13.][Ϸ!!!]
                void __fastcall _KEY_Backspace(void);

                //[2007.01.18.][Ϸ!!!]
                bool __fastcall _EDITBUF_MOONJA_Delete(int    pDELETEindex,
                                                       bool  *rIScrlf);
                //[2007.02.14.][Ϸ!!!]
                bool __fastcall _SELECT_Get_StartEndIndex(struct CARETINFO  *rSELECTstart,
                                                          struct CARETINFO  *rSELECTend);
                //[2007.02.14.][Ϸ!!!]
                bool __fastcall _SELECT_Delete(struct CARETINFO  *rSELECTstart,
                                               int               *rCRLFcount);
                //[2007.04.09.][Ϸ!!!]
                void __fastcall _EDITBUF_MOONJA_Insert(int    pINSERTindex,
                                                       short  pCODE);
                //[2018.02.20.ȭ][Ϸ!!!]
                void __fastcall _CARET_MOONJA_Insert(short  pCODE);

                //[2007.03.19.][Ϸ!!!]
                void __fastcall _SELECTSCROLL_Left(int  pMOUSEx);
                //[2007.03.19.][Ϸ!!!]
                void __fastcall _SELECTSCROLL_Right(int  pMOUSEx);

                //[2007.03.07.][Ϸ!!!]
                void __fastcall _EDIT_SelectDelete(void);

                //[2018.02.24.][Ϸ!!!]
                void __fastcall _EDIT_Paste(char *pPASTEstr);

                //[2007.03.21.][Ϸ!!!]
                void __fastcall _EDIT_SelectAll(void);
            //}

            //[ڿó]
            //{
                //ٸ  ϸ ǹǷ 1024  ڸ ϸ ϴ.
                #define  d_WORDCONFIG_max   1024
                struct WORDCONFIG _wordconfig[d_WORDCONFIG_max];
                int               _wordconfig_count;

                //[2007.01.31.][Ϸ!!!]
                void __fastcall _WORD_LineGet(char  *pSTR,
                                              int    pINDEX,
                                              char   rWORD[],
                                              int   *rWORDindex,
                                              int   *rWORDlength);

                //[2007.02.03.][Ϸ!!!]
                void __fastcall _MOONJACONFIG_LineGet(int  pLINEstartindex);

                //[2007.04.15.][Ϸ!!!]
                bool __fastcall _EDITBUF_LINE_Out(int   pX,
                                                  int   pY,
                                                  int   pLINEstartindex,
                                                  int  *rLINEendindex);

                //[2007.02.02.][Ϸ!!!]
                bool __fastcall _EDITBUF_STRING_Out(int  pX,
                                                    int  pY,
                                                    int  pLINEstartindex);

                //[2007.03.11.][Ϸ!!!]
                bool __fastcall _CARET_ViewAlways(void);
            //}

            //[Ŭ]
            //{
                //[2007.03.06.ȭ][Ϸ!!!]
                bool __fastcall _CLIPBOARD_IsText(void);
                //[2012.04.29.][Ϸ!!!]
                void __fastcall _CLIPBOARD_Copy(void);
                //[2007.03.22.][Ϸ!!!]
                void __fastcall _CLIPBOARD_Cut(void);
                //[2007.03.07.][Ϸ!!!]
                void __fastcall _CLIPBOARD_Paste(void);
            //}
        //}

};

//---------------------------------------------------------------------------
extern PACKAGE Tgui_edit_Form *gui_edit_Form;
//---------------------------------------------------------------------------

#endif
