

//[2010.02.25.][!!!]


#ifndef ring_buffer_h
#define ring_buffer_h

//---------------------
#include <Classes.hpp>
//---------------------

#include  "vmos_def.h"


//[2010.02.25.][!!!]{------------------------------------------------------------
//ó ӵ Ͽ [1 Ʈ ]  [8 Ʈ ]  Ͽ  óѴ.
//ȥջϴ  ũ⿡  [ּ]  ϰ Ҽ  б/ÿ
// ش [ũ]  ٶ [ȯ]  ؾ ϴµ ̰ ܼ  ȵǾ
// 쿡   óҼ ۿ .
//, ƿ    óϴ   .
//}------------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//[DTU1 ]-------------------------------------------------------------------
//------------------------------------------------------------------------------

struct RING_BUFFER // 12 Byte ũ⸦ ´.
{
  //[2009.08.24.][!!!]{----------------------------
  //[]  Ѵ.
  //̰ [] ̿ܿ [MsgQueue] ε ȴ.
  //}----------------------------------------------------

  // ġ.
  DTU1  *buf;

  //[]  ũ.
  DTU2   size; //(ʱⰪ :  )

  // ġ(index).
  //ڵ.
  DTU2   wrInx; //(ʱⰪ : 0)

  //  ġ(index, +1  ϰ о Ѵ).
  //ڵ.
  DTU2   rdInx; //(ʱⰪ : _com0_RingBufSize - 1)

  //ִ ڷᰳ(/б  ڵ Ǿ óȴ).
  //ڵ.
  DTU2   count; //(ʱⰪ : 0)

};

//[2009.08.27.][Ϸ!!!]
void RingBuf_Init(struct RING_BUFFER  *pRB);

//[2009.08.24.][Ϸ!!!]
void RingBuf_Create(struct RING_BUFFER  *pRB,
                    // MCU .
                    DTU8                 pBufMcuAdr,
                    // ũ.
                    DTU2                 pBufSize);

//[2009.08.27.][Ϸ!!!]
void RingBuf_Clear(struct RING_BUFFER  *pRB);

//[2009.08.24.][Ϸ!!!]
DTU2 RingBuf_Count(struct RING_BUFFER  *pRB);

//[2009.08.24.][Ϸ!!!]
void RingBuf_WrInxInc(struct RING_BUFFER  *pRB);

//[2009.08.24.][Ϸ!!!]
void RingBuf_RdInxInc(struct RING_BUFFER  *pRB);

//[2009.08.24.][Ϸ!!!]
bool RingBuf_Write(struct RING_BUFFER  *pRB,
                   DTU1                 pData);

//[2009.08.24.][Ϸ!!!]
bool RingBuf_Read(struct  RING_BUFFER  *pRB,
                  DTU1                 *rData);

//------------------------------------------------------------------------------
//[DTU8 ]-------------------------------------------------------------------
//------------------------------------------------------------------------------

//[2010.02.25.][߰!!!]{--------------------------------------------
//GUI  [˸]  Ͽ Ӱ [8 Ʈ ]  .
//̴ [GUI ˸]  [8 Ʈ ] ̱ ̴.
//
//[2014.12.05.][߰!!!]---------------------------------------------
//[VCOM]   [˸]  [8 Ʈ ]  .
//  Ȯ忡 Ͽ [2 ˸]   [8 Ʈ ] .
//}--------------------------------------------------------------------

struct RING_BUFFER8
{
  //[2010.02.25.][߰!!!]{-------------------------------
  //[]  Ѵ.
  // [8 Ʈ ]  óѴ.
  // ũ⳪ ġ  [8Ʈ ]  óȴ.
  //}-------------------------------------------------------

  // ġ.
  DTU8  *buf;

  //[]  ũ(8 Ʈ    ).
  DTU2   size; //(ʱⰪ :  )

  // ġ(index).
  //ڵ.
  DTU2   wrInx; //(ʱⰪ : 0)

  //  ġ(index, +1  ϰ о Ѵ).
  //ڵ.
  DTU2   rdInx; //(ʱⰪ : _com0_RingBufSize - 1)

  //ִ ڷᰳ(/б  ڵ Ǿ óȴ).
  //ڵ([8 Ʈ ] ).
  DTU2   count; //(ʱⰪ : 0)

};

//[2010.02.25.][Ϸ!!!]
void RingBuf8_Init(struct RING_BUFFER8  *pRB);

//[2010.02.25.][Ϸ!!!]
void RingBuf8_Create(struct RING_BUFFER8  *pRB,
                     // MCU .
                     DTU8                  pBufMcuAdr,
                     //[ ] ũ(1 Ʈ   ũⰡ ƴ϶ 8Ʈ  ).
                     DTU2                  pBufSize);

//[2010.02.25.][Ϸ!!!]
void RingBuf8_Clear(struct RING_BUFFER8  *pRB);

//[2010.02.25.][Ϸ!!!]
DTU2 RingBuf8_Count(struct RING_BUFFER8  *pRB);

//[2010.02.25.][Ϸ!!!]
void RingBuf8_WrInxInc(struct RING_BUFFER8  *pRB);

//[2010.02.25.][Ϸ!!!]
void RingBuf8_RdInxInc(struct RING_BUFFER8  *pRB);

//[2010.02.25.][Ϸ!!!]
bool RingBuf8_Write(struct RING_BUFFER8  *pRB,
                    DTU8                  pData);

//[2010.02.25.][Ϸ!!!]
bool RingBuf8_Read(struct  RING_BUFFER8  *pRB,
                   DTU8                  *rData);

//[API:DTU1 ]
//{
    //[2018.11.04.][߿!!!]{******************
    // []  ޸ <rxInx> Ǹ Ѵ.
    //}**********************************************

    //[2018.11.01.][!!!]{---------------------------------------------------
    //API  [DTU1::]   Ѵ.
    //   ϰ  [˵-C]  ϴ [] 
    //[]  ġϹǷ ̿ õ κи Ѵ.
    //
    //[!!!]*******************************************************************
    //[̳]  [ǵ/ǻ츮]    [] 
    //ʿϹǷ  °.
    //[˵-C]    ϳ Ȱ뵵   ƿ API  .
    //
    //[߿!!!]*******************************************************************
    //  [˵(GMTDL)]     ũ⸦ [DTU2]  
    //̹  [̳] ̹Ƿ [MByte:]  óҼ ֵ [DTU4] 
    //Ѵ.
    //}---------------------------------------------------------------------------

    class VRING_BUFFER
    {
      //[2018.11.01.][!!!]{-----------------------------------------
      //  [˵-C]  ǵ []   
      //⼭  []   ҿ  ϱ  ͸ .
      //
      //[!!!]*********************************************************
      // [˵-C]  ϴ  <buf>, <size>  ̰ 
      //θ ȴ.
      //}-----------------------------------------------------------------

      //[]{-------------------------
      //
      //{  : (unsigned char)[8] }
      //
      //}-------------------------------

      public:

      //[VAR]
      //{
          //[ ]
          //{
              //[] ġ.
              DTU1  *buf;

              //[]  ũ.
              DTU4   size; //(ʱⰪ :  )

          //}

          //[ ]
          //{
              //[2018.11.04.][߿!!!]{**************************
              // []  ޸ <rdInx, wrInx>  Ȯϰ .
              //}******************************************************

              /*[]{-------------------------------------------------------------------------

              *) (wrInx == rdInx)     0  .

              *) [  ũ] = (size - 1);

                 ̴ 1   ξ wrInx  rdInx   full  츦 ϱ .
                 , (wrInx == rdInx)   Ұ    찡 .

              *) wrInx, rdInx  [/б:ġ]  .

              *) [尳] ϱ.

                 1) (rdInx == wrInx) : 尳 0( ).

                 2) (rdInx > wrInx)  : (size - rdInx) + wrInx;

                 3) (rdInx < wrInx)  : wrInx - rdInx;

              *///------------------------------------------------------------------------------

              //[]  ġ.
              DTU4   wrInx; //(ʱⰪ : 0)

              //[б]  ġ.
              DTU4   rdInx; //(ʱⰪ : 0)

              //ִ ڷᰳ(/б  ڵ Ǿ óȴ).
              DTU4   count; //(ʱⰪ : 0)

          //}

      //}

      //[2018.11.04.][Ϸ!!!]
      void __fastcall RingBuf_Init(void);

      //[2018.11.04.][Ϸ!!!]
      void __fastcall RingBuf_Create(// MCU .
                                     DTU8  pBufMcuAdr,
                                     // ũ.
                                     DTU4  pBufSize);
      //[2018.11.04.][Ϸ!!!]
      void __fastcall RingBuf_Clear(void);

      //[2018.11.04.][Ϸ!!!]
      DTU4 __fastcall RingBuf_Count(void);

      //[2018.11.04.][Ϸ!!!]
      void __fastcall RingBuf_WrInxInc(void);

      //[2018.11.04.][Ϸ!!!]
      void __fastcall RingBuf_RdInxInc(void);

      //[2018.11.04.][Ϸ!!!]
      bool __fastcall RingBuf_Write(DTU1  pData);

      //[2018.11.04.][Ϸ!!!]
      bool __fastcall RingBuf_WriteX(DTU1  *pData,
                                     DTU4   pSize,
                                     //  .
                                     DTU4  *rRealCount);

      //[2018.11.16.][Ϸ!!!]
      bool __fastcall RingBuf_Read(DTU1  *rData);

      //[2018.11.04.][Ϸ!!!]
      bool __fastcall RingBuf_ReadX(DTU1  *rData,
                                    DTU4   pSize,
                                    //  .
                                    DTU4  *rRealCount);

      //[2018.11.05.][Ϸ!!!]
      bool __fastcall RingBuf_DataArea_Check(DTU4  pIndex);

      //[2018.11.05.][Ϸ!!!]
      void __fastcall RingBuf_Info(//ڷ   ġ( ڷ  ġ).
                                   DTU4  *rWrInx,
                                   //ڷ   ġ(ڷ  ġ).
                                   DTU4  *rRdInx,
                                   //<_VRingBufRead_XXX()> Լ ϴ  ġ.
                                   DTU4  *rRxPos,
                                   //  ڷᰳ.
                                   DTU4  *rCount);

      //[Ư ]
      //{
          //[2018.11.04.][߰!!!]{----------------------------------------
          //[Redo/Undo]    Ư ɰ.
          // [] ü   ,  [ ] 
          // Ͽ  о ̱ Ѱ.
          //}----------------------------------------------------------------

          //[VAR]
          //{
              // б⸦   ġ(rdInx ʹ   ٸ).
              // ġ  д´.
              //<rxInx(  ġ)>  ޸ ׻ [ġ]  .
              DTU4   rxPos; //(ʱⰪ : rdInx)

          //}

          //[2018.11.05.][Ϸ!!!]
          bool __fastcall RingBufRead_RxPos_Set(//{ 0 <= pRxPos < size }
                                                DTU4  pRxPos);

          //[2018.11.05.][Ϸ!!!]
          void __fastcall RingBufRead_RxPos_Set_WrInx(void);


          //[2018.11.05.][Ϸ!!!]
          void __fastcall RingBufRead_RxPosInc(void);

          //[2018.11.16.][Ϸ!!!]
          bool __fastcall RingBufRead_Read(DTU1  *rData);

          //[2018.11.16.][Ϸ!!!]
          bool __fastcall RingBufRead_ReadX(DTU1  *rData,
                                            DTU4   pSize,
                                            //  (̻ NULL).
                                            DTU4  *rRealCount);
                            
          //[2018.11.16.][Ϸ!!!]
          bool __fastcall RingBufRead_ReadX_Back(DTU1  *rData,
                                                 DTU4   pSize,
                                                 //  (̻ NULL).
                                                 DTU4  *rRealCount);

      //}

    };

    //[2018.11.01.][Ϸ!!!]
    void __fastcall VRingBuf_Create(//ü   [].
                                    void  *pPart_,
                                    //[]  [BCB]  ּ.
                                    DTU8   pBufAdr,
                                    // ũ.
                                    DTU4   pBufSize);

    //[2018.11.01.][Ϸ!!!]
    void __fastcall VRingBuf_Delete(//ü .
                                    void  *pPart_);

//}


#endif






