
//[2009.07.07.ȭ][!!!]{---------------------------------------------------
//˵  STM32F103  Flash  ϱ  Լ Ѵ.
// [Ĺ]   ϴ  Ѵ.
//ӵ   ϱ ,   IDE ʿ  Ҽ Ƿ
//  .
//}---------------------------------------------------------------------------


#include <vcl.h>
#pragma hdrstop


#include  "ide_library.h"

#include  "flash.h"

#include  "combus.h"

#include  "STM32F103C8T6.h"


bool __fastcall Flash_Key(void)
{
  //[2009.07.07.ȭ][!!!]{------------------------------
  //Flash   Ͽ ϴ [ȣ]  ؾ Ѵ.
  //}------------------------------------------------------

  //[VAR]
  //{
      unsigned int  flash_keyr;

  //}

  //[ʱȭ]
  //{
      flash_keyr = 0;

  //}

  //KEY1 .
  flash_keyr = 0x45670123;
  if(ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_KEYR, (unsigned char *)(&flash_keyr)) != true) return(false);

  //KEY2 .
  flash_keyr = 0xcdef89ab;
  if(ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_KEYR, (unsigned char *)(&flash_keyr)) != true) return(false);

  return(true);

}

bool __fastcall Flash_WriteBoho(void)
{
  //[2009.12.24.][!!!]{----------------------------------------------------
  //Flash  ϵ ٸ Ű ־ش.
  //Ͻ Flash    Ҽ  ° ȴ.
  //
  //Flash  ⸦ Ͽ Flash_Key() Լ  ¸   
  //ڿ ݵ  Լ [ȣ]   ƾ Ѵ.
  //̴ VMOS   []     ̴.
  //}----------------------------------------------------------------------------

  //[VAR]
  //{
      DTU4  temp4;

  //}

  //[FLASH_CR б]
  //{
      //<FLASH_CR>  о δ.
      if(ComBus_Read(d_CB_TS_T, d_CB_AK_M, 2, FLASH_CR, (unsigned char *)(&temp4)) != true) return(false);

  //}

  //[FLASH_CR ]
  //{
      //[!]{---------------------------------------------------------------------------------------
      //<FLASH_CR.7 : 1>  ϸ Flash    Ҽ  ȣ ° ȴ.
      //̴ Flash_Key() Լ Ű ־߸ ȴ(SW δ  ǰ  ʴ´).
      //}------------------------------------------------------------------------------------------

      temp4 |= (1 << 7);
      if(ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_CR, (unsigned char *)(&temp4)) != true) return(false);

  //}

  return(true);

}

void __fastcall Flash_Write(DTU4  pAdr,
                            DTU2  p16Bit)
{
  //[2009.07.07.ȭ][!!!]{-----------------------------------------------------------
  //Flash   ּҿ 16Bit  Ѵ.
  //STM32FXXX 迭 1Address:16Bit  ؾϸ,
  // Լ ̹ ش Page  Lock  ŵǰ, Erase   쿡 ؾ Ѵ.
  //   ȴ.
  //}-----------------------------------------------------------------------------------

  //[VAR]
  //{
      unsigned int  flash_cr, flash_sr;

  //}
  
  //[ʱȭ]
  //{
      flash_cr = 0;
      flash_sr = 0;
  
  //}
  
  //[Flash α׷ 㰡]
  //{
      //FLASH_CR.PG(0) Ʈ 1 Ͽ Flash   㰡Ѵ.
      flash_cr = (1 << 0);
      ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_CR, (unsigned char *)(&flash_cr));
      
  //}    
  
  //[ ]
  //{
      //Ϲ  FLash  ҿ ׳ ϰ ϸ ȴ.
      ComBus_Write(d_CB_TS_T, d_CB_AK_M, 1, pAdr, (unsigned char *)(&p16Bit));
      
  //}    
  
  //[Ϸ Ȯ]
  //{
      //FLASH_SR.BSY(0) Ʈ 0 ̸ Ϸ ̴.
      do 
      { 
        ComBus_Read(d_CB_TS_T, d_CB_AK_M, 2, FLASH_SR, (unsigned char *)(&flash_sr));
      
      }
      while(flash_sr & (1 << 0));
      
  //}

  return;

}

void __fastcall Flash_Erase(void)
{
  //[2009.07.07.ȭ][!!!]{--------------------------------------------------
  //<d_CodeBase_VMOS>  Flash   .
  // VMOS  ϴ 0x1000    .
  //, ü Ѳ  ȵǰ, PAGE  1 Kbyte   Ѵ.
  // ǰ ִ STM32F103  1KByte/1Page ̴.
  // 64Kbyte  Flash   Ƿ BaseVM  ϰ  60
  //  ȴ.
  //
  // , Flash_ȣ() Լ ȣ  ¿ Ѵ.
  //}--------------------------------------------------------------------------
  
  //[VAR]
  //{
      unsigned int  flash_cr, flash_ar, flash_sr;
      int           i;
      
  //}
  
  //[ʱȭ]
  //{
      flash_cr = 0; 
      flash_ar = 0;
      flash_sr = 0;
  
  //}

  //[Flash   㰡]
  //{
      //FLASH_CR.PER(1) Ʈ 1 Ͽ Flash  ⸦ 㰡Ѵ.
      flash_cr = (1 << 1);
      ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_CR, (unsigned char *)(&flash_cr));

  //}

  //[60  ]
  //{
      //BaseVm  ϴ ó 4   60    .
      for(i = 0; i < 60; i++)
      {
        //[ ּ ]
        //{
            flash_ar = //BaseVM   Ѵ.
                       0x1000 +
                       // 1KByte ũ⸦ ´.
                       0x400*i;

            ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_AR, (unsigned char *)(&flash_ar));

        //}

        //[ ]
        //{
            //FLASH_CR.STRT(6) Ʈ 1 Ͽ Flash  .
            flash_cr |= (1 << 6);
            ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_CR, (unsigned char *)(&flash_cr));

        //}

        //[Ϸ Ȯ]
        //{
            //FLASH_SR.BSY(0) Ʈ 0 ̸ Ϸ ̴.
            do
            {
              ComBus_Read(d_CB_TS_T, d_CB_AK_M, 2, FLASH_SR, (unsigned char *)(&flash_sr));

            }
            while(flash_sr & (1 << 0));

        //}

      }

  //}

  // BaseVM   60   .

  return;

}

void __fastcall Flash_PageErase(// [ּ].
                                DTU4  pPageBaseAdr)
{
  //[2009.07.15.][!!!]{--------------------------------------------------
  //STM32F103  1KByte    ִµ,   [ּ] 
  // ޾Ƽ ش  Ѵ.
  //
  // , Flash_ȣ() Լ ȣ  ¿ Ѵ.
  //}--------------------------------------------------------------------------

  //[VAR]
  //{
      unsigned int  flash_cr, flash_ar, flash_sr;
      int           i;

  //}

  //[ʱȭ]
  //{
      flash_cr = 0;
      flash_ar = 0;
      flash_sr = 0;
  
  //}

  //[Flash   㰡]
  //{
      //FLASH_CR.PER(1) Ʈ 1 Ͽ Flash  ⸦ 㰡Ѵ.
      flash_cr = (1 << 1);
      ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_CR, (unsigned char *)(&flash_cr));

  //}

  //[  ]
  //{
      //BaseVm  ϴ ó 4   60    .

      //[ ּ ]
      //{
          //  [ּ]  Ѵ.
          //1KByte  Ѵ.
          flash_ar = pPageBaseAdr & (~((DTU4)0x3ff));

          ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_AR, (unsigned char *)(&flash_ar));

      //}

      //[ ]
      //{
          //FLASH_CR.STRT(6) Ʈ 1 Ͽ Flash  .
          flash_cr |= (1 << 6);
          ComBus_Write(d_CB_TS_T, d_CB_AK_M, 2, FLASH_CR, (unsigned char *)(&flash_cr));

      //}

      //[Ϸ Ȯ]
      //{
          //FLASH_SR.BSY(0) Ʈ 0 ̸ Ϸ ̴.
          do
          {
            ComBus_Read(d_CB_TS_T, d_CB_AK_M, 2, FLASH_SR, (unsigned char *)(&flash_sr));

          }
          while(flash_sr & (1 << 0));

      //}

  //}

  return;

}



