

//[2009.02.19.][!!!]{------------------------------------
//VMOS    и ϹǷ    ش.
//}------------------------------------------------------------


#ifndef vmos_def_h
#define vmos_def_h

//[2009.08.11.ȭ][߰!!!]
#include  "vmos_api_def.h"
#include  "vmos_commap_def.h"
#include  "vmos_memmap_def.h"


//[ӽ  ]
//{
    //[CODE] ü θ ϰ    <8 Byte Align> Ǿ Ѵ.

    //[ ũ]
    //{
        #define  DTU8     unsigned long long
        #define  DTS8     signed long long

        #define  DTU4     unsigned int
        #define  DTS4     signed int

        #define  DTU2     unsigned short
        #define  DTS2     signed short

        #define  DTU1     unsigned char
        #define  DTS1     signed char

    //}

    //[ ġ]
    //{
        #define  d_Wr       0
        #define  d_Rd       1

        #define  d_True     1
        #define  d_False    0

    //}

    //[ǿ ]
    //{
        //------------------------------------------------------------------------------------
        // 1bit    1bit     4bit     2bit      4bit       4bit   : Ʈ.
        //  15      14     13:10     9:8        7:4       3:0    : Ʈ.
        // [i/f] . [s/u] . [size] . [kind] . [segment] . [byte]  : ̸.
        //------------------------------------------------------------------------------------

        #define  d_Bit16_fi          15  //1 bit ũ.
        //{
            #define  d_Mask_fi       0x01

        //}
        #define  d_Bit16_su          14  //1
        //{
            #define  d_Mask_su       0x01

        //}
        #define  d_Bit16_size        10  //4
        //{
            #define  d_Mask_size     0x0f

        //}
        #define  d_Bit16_kind        8   //2
        //{
            #define  d_Mask_kind     0x03

        //}
        #define  d_Bit16_segment     4   //4
        //{
            #define  d_Mask_segment  0x0f

        //}
        #define  d_Bit16_byte        0   //4
        //{
            #define  d_Mask_byte     0x0f

        //}

        //
        // [i/f]
        //
        // - /Ǽ Ѵ.
        // - i(0) : .
        //   f(1) : Ǽ.

        #define  d_Float    1
        #define  d_Integer  0

        //
        // [s/u]
        //
        // - signed  unsigned  Ѵ.
        // - u(0) : unsigned.
        //   s(1) : signed.

        #define  d_Signed    1
        #define  d_Unsigned  0

        //
        // [size]
        //
        // -  о  [ũ]  (c-type ũ).
        // - 1, 2, 4, 8   ũ  Ѵ(ٷ о Ҽ ֵ ϱ  ).
        //
        // [kind]
        //
        // -   ΰ?
        // - pv(3) : .
        //   pc(2) : .
        //   v (1) : .
        //   c (0) : .

        #define  d_Kind_pv    3
        #define  d_Kind_pc    2
        #define  d_Kind_v     1
        #define  d_Kind_c     0

        //
        // [segment]
        //
        // -   .
        // - #(0) : .
        //   R(1) : .
        //   C(2) : @CODE.
        //   G(3) : @DATA.
        //   L(4) : @LOCAL.
        //   T(5) : @TEMP.
        //   F(6) : @FUNC.

        #define  d_Seg_Constant    0
        #define  d_Seg_Reg         1
        #define  d_Seg_Code        2
        #define  d_Seg_Data        3
        #define  d_Seg_Local       4
        #define  d_Seg_Temp        5
        #define  d_Seg_Func        6

    //}

    //[]
    //{
        //[2009.01.14.][߰!!!]{-------
        //  ũ 1 Byte ̴.
        //}-------------------------------

        #define  d_VMOS_OpcodeSize      1

        //[2009.02.24.ȭ][߰!!!]
        // [ɾ] Ѽ []   Ͽ 56  ̴.
        #define  d_VMOS_OpcodeCount     56

        //[2009.03.28.][߰!!!]
        #define  d_VMOS_firstOpcode     1
        #define  d_VMOS_lastOpcode      56

    //}

    //[͹ȣ]
    //{
        //[2008.12.30.ȭ][߰!!!]{--------------------------------------------------------
        // [˵]  []  10  ۿ   [1] ÿ Ǵ 
        //R0, R1  ΰ ۿ .   θ ȴ.
        //}--------------------------------------------------------------------------------

        //R0, R1, R2  Ϲ []  ALU  ÿ ǹǷ  տ ġѴ.
        // R0  ȣ  ġ Ͽ   ϹǷ R0  0  ġѴ.

        //  8 Byte ũ⸦ ´.

        #define  d_VM_RegCount     11

        //[ ] ü Byte  ũ.
        #define  d_VM_RegSize      (8 * d_VM_RegCount)

        //           <name>       <index>
        #define  d_VM_Reg_R0       0
        #define  d_VM_Reg_R1       1
        #define  d_VM_Reg_R2       2

        #define  d_VM_Reg_PC       3
        #define  d_VM_Reg_MP       4
        #define  d_VM_Reg_SP       5

        //Ϲ [׸Ʈ ]   ġѴ.
        #define  d_VM_Reg_CODE     6
        #define  d_VM_Reg_DATA     7
        #define  d_VM_Reg_LOCAL    8
        #define  d_VM_Reg_TEMP     9
        #define  d_VM_Reg_FUNC     10 

    //}

    //[VM ]
    //{
        //[2009.02.19.][߰!!!]{------------------------------------
        //VMEX  _RAM_[]  VM  Ǹ鼭    .
        //}------------------------------------------------------------

        #define  d_VM_HdrCount   7
        #define  d_VM_HdrSize    (8 * d_VM_HdrCount)

        //[]
        //{
            //  8 Byte ũ⸦ ´.

            //               <name>       <index>
            #define  d_VM_Hdr_Mount        0
            #define  d_VM_Hdr_MemStart     1
            #define  d_VM_Hdr_MemEnd       2
            #define  d_VM_Hdr_RomStart     3
            #define  d_VM_Hdr_RomEnd       4
            #define  d_VM_Hdr_RamStart     5
            #define  d_VM_Hdr_RamEnd       6

        //}

    //}

    //[VECTOR]
    //{
        //[2009.02.24.ȭ][߰!!!]{-----------
        //[VMOS]  [̵ּ]  Ѵ.
        //{-----------------------------------

        //[̵ּ]  @CODE:BASE  [ּ߰]  Ѵ.
        #define  d_CODE_Vect_Reset       0
        #define  d_CODE_Vect_Event       8

    //}

//}

//[VMEX  ]
//{
    //[2009.02.19.][!!!]{-----------
    //<*.gvmx>  ڼ  Ѵ.
    //}-----------------------------------

    //[VMEX-]
    //{
        //[ũ ]
        //{
            //[2009.02.11.][߰!!!]{-----------------------------------
            // Ǵ <*.gvmx>  [] ũ⸦ Ѵ.
            //8 * 6 = 48 Byte ũ ȴ.
            //
            //[VMEX ] = []:[  CODE]
            //
            //}-----------------------------------------------------------

            #define  d_VMEX_HdrCount  6
            #define  d_VMEX_HdrSize   (8 * d_VMEX_HdrCount)

        //}

        //[]
        //{
            //  8 Byte ũ⸦ ´.

            //[2021.01.15.][߰]{****************************************************
            //GVMX, GVMS   Ǵ 츦 .
            //
            //{ <d_VMEX_Hdr_MemSize> = <VMOS  RAM ũ> - 64(ũ) }  ȴ.
            //
            //,  Ѱ    [(64 Ʈ)]  ϰ
            // Ҽ ִ RAM   ũⰡ ȴ.
            //
            // κ  Ͽ  ǥ <MemSize> ǹ ؼ ȥ ߻Ͽ
            //, ٽ  ǹ̸ ȮѴ.
            //}*****************************************************************************

            //                 <name>      <index>
            #define  d_VMEX_Hdr_Version     0
            #define  d_VMEX_Hdr_HdrSize     1
            #define  d_VMEX_Hdr_CodeSize    2
            #define  d_VMEX_Hdr_DataSize    3
            #define  d_VMEX_Hdr_MemSize     4
            #define  d_VMEX_Hdr_Option      5

        //}

    //}

//}


#endif







