
//[!]{---------------------
//[2011.06.08.][!!!]
//}------------------------

#ifndef debug_view_h
#define debug_view_h


#include "c_define.h"
#include "database.h"

//[2021.11.24.][߰]
#include  "vmos_def.h"


struct DEBUGVIEWINFO
{
  //[2011.06.08.][!!!]{--------------------
  //[]    ⼭ Ѵ.
  //}--------------------------------------------

  //[] ڿ Ѵ.
  // []  ؼ ̰ ڿ  Ѵ.
  char  expBuf[Opt_DebugView_StrBufSize];

  //[2011.06.09.][߰!!!]{-----------------------------------------------------------------------
  //{DATABASE}  {FILELIST}  [ȣ]  Ѵ.
  //̴ [] ڿ ó ϱ Ͽ <Get_NextWord()> Լ ϴµ
  //<#define>  ǵ ̸ ˻Ҷ <ParserInfo.filelistindex>  ʿϱ ̴.
  //̴ [̸]  ݵ  [̸]  ϴ [ȣ]  ˻縦 ϱ ̴.
  //<{DATABASE}.FILELIST_GetIndex_WithName()>, <{DATABASE}.FILELIST_GetSize_WithIndex()> Լ
  //ϰ  Ҽ ִ.
  //
  int   dbFileListIndex; //(⺻ : 0)
  //<DebugView_Get_ExpStr_fromEditor()> Լ ó.
  //}-----------------------------------------------------------------------------------------------

  //[2011.06.21.ȭ][߰!!!]
  // [ÿ]   [Լ]  {DB}  ġ.
  //[2011.07.19.ȭ][!!!]
  //  Լ ġ ȴ.
  //[ÿ]  ִ Լ ġ ƴϴ!!!
  //<DebugViewDisplay_Make_DisplayStr>  [ ]  ڿ Ҷ 
  // [ Լ ̸]  µ, [  ]  
  //    []  ϴ Լ̸ Ǿ  
  // []  ִ [Լ]  ƴ  [Ұ]  Ǿ ڵ
  //[ ]   Ǿ  Ƿ ϰ ȴ.
  //Ҿ, []   ڵ  [ Լ̸]  Ƿ  .
  //  Ȯϰ ϰ Ѵ.
  int   dbFuncRecIndex;
  //<DebugView_Get_ExpStr_fromEditor()> Լ ó.

  //[2011.06.21.ȭ][߰!!!]
  //[]   ó  <exprecord>  .
  //[ڷ]  Ȯϰ ˱ Ͽ ݵ ʿϴ.
  struct EXPRECORD  expRecord;
  //<DebugView_DebugExp_CalCulate()> Լ ó.

};



//[2011.07.24.][Ϸ!!!]
void __fastcall DebugView_Create(void);

//[2011.06.23.][Ϸ!!!]
void __fastcall DebugView_Delete(void);



//[2011.07.17.][Ϸ!!!]
bool __fastcall DebugView_EditorSelExpStr(//[2011.06.21.ȭ][߰!!!]
                                          struct DEBUGVIEWINFO      *pDbgViewInfo,
                                          struct DEBUGVIEW_DISPLAY  *pDbgViewDisplay);


//[2011.06.21.ȭ][Ϸ!!!]
bool __fastcall DebugView_Get_ExpStr_fromEditor(//[2011.06.21.ȭ][߰!!!]
                                                struct DEBUGVIEWINFO  *pDbgViewInfo);

//[2011.07.17.][Ϸ!!!]
bool __fastcall DebugView_DebugExp_CalCulate(char              *pExpStr,
                                             int                pFileListIndex,
                                             //[2011.07.19.ȭ][!!!]{-------
                                             //  Լ .
                                             int                pFuncRecIndex,
                                             //}-------------------------------
                                             struct EXPRECORD  *rExpRecord,
                                             char              *rExpRsltSymbol);
//[2011.06.21.ȭ][Ϸ!!!]
//bool __fastcall DebugView_DebugExp_CalCulate(//[2011.06.21.ȭ][߰!!!]
//                                             struct DEBUGVIEWINFO  *pDbgViewInfo,
//                                             char                  *rExpRsltSymbol);

//[2011.06.21.ȭ][Ϸ!!!]
void __fastcall DebugViewInfo_Init(struct DEBUGVIEWINFO  *pDbgViewInfo);


//[2011.07.17.][Ϸ!!!]
bool __fastcall DebugView_Check_DebugExp(char  *pExpStr,
                                         int    pFileListIndex);



struct DBG_OPND
{
  //[2011.06.14.ȭ][!!!]{------------------------------------------
  //<DebugView_WrRd()> Լ  μ Ѵ.
  //[μ]     ɼ Ƿ [ü]  .
  //}------------------------------------------------------------------

  //  ϴ  [ȣ].
  //[2011.06.16.][!!!]
  //[ȣ]   ־ ϹǷ []  Ѵ.
  char                symbol[OPT_name_length];

  //[<Ǽ/> ]{----------------------------------------------------------------------
  //  [Ǽ/]   б    [Ǽ/]  ȯѴ.
  //<d_Integer/d_Float>  ϳ.
  //    ˷ִ  ̴ֱ.
  int                 f_i;
  //}----------------------------------------------------------------------------------------

  //Ҷ ޸ ó Ѵ.
  unsigned char       mem[8];

  //[2011.06.17.][߿߰!!!]{---------------------------------------------------------
  //ڿ  [ǿ]  [ּ]  Ѵ.
  //ΰ  <DbgExp_Opcode_Operator_10()>  [:&]  óϴµ ʿϴ.
  unsigned long long  adrAbs;
  //}-------------------------------------------------------------------------------------

  //[2011.06.21.ȭ][߰!!!]{----------------------------------------------------------
  //[ּ]  Ѵ.
  //G(DATA), L(LOCAL), T(TEMP)   Ѱ  Ҽ ִ.
  //  [⹮ڿ]  鶧 ʿѵ,  <DebugView_Opnd_WrRd()> Լ
  // ̸, ȣ ü ٽ    ϹǷ ϵ Ѵ.
  char  segmentChar;
  //}----------------------------------------------------------------------------------

  int                  s_u;
  int                  size;

};

//[2011.07.25.][Ϸ!!!]
//[2022.01.13.][Ϸ]
bool __fastcall DebugView_Opnd_WrRd(//<˵:true>, <:flase>.
                                    bool  pTmtdl_Fsim,
                                    ///б .
                                    //<d_Wr/d_Rd>  .
                                    int   pW_R,
                                     //[2011.06.14.ȭ][!!!]
                                    // [μ] ü üѴ.
                                    struct DBG_OPND  *prOpnd);

//[2021.11.28.][Ϸ]                                    
bool __fastcall DebugView_Str_Cut_CRLF(//[˵(G.MTDL.X)]  о [ڿ] ּ.
                                       DTU8   pAdr,
                                       //о ڿ.
                                       char  *rStr,
                                       //ڿ ̸  (0̸  ).
                                       int    pSetLength,
                                       //ȯ ڿ .
                                       int   *rStrSize);

//[2021.11.28.][Ϸ]                                       
bool __fastcall DebugView_Str_Read(//[˵(G.MTDL.X)]  о [ڿ] ּ.
                                   DTU8   pAdr,
                                   //о ڿ.
                                   char  *rStr,
                                   //ڿ ̸  (0̸  ).
                                   int    pSetLength,
                                   //ȯ ڿ .
                                   int   *rStrSize);

//[2011.07.23.][Ϸ!!!]
bool __fastcall AbsAdrRange_Check(unsigned long long  pAdr);

//[2011.06.13.][Ϸ!!!]
int __fastcall SizeTo2Exp(int pSize);


//[ TEMP ]
//{
    //[2011.06.15.][Ϸ!!!]
    void __fastcall VTemp_WrRd(int                  pW_R,
                               unsigned long long   pAdr,
                               int                  pSize,
                               void                *pMem);

//}

//[   ]
//{
    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_1(//1.
                                             char  *p1stCode); //(OPCODE : (0x01) 1)  : "[]"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_2(//1.
                                             char  *p1stCode); //(OPCODE : (0x02) 2)  : "->"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_3(//1.
                                             char  *p1stCode); //(OPCODE : (0x03) 3)  : "."

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_4(//1.
                                             char  *p1stCode); //(OPCODE : (0x04) 4)  : "!/"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_5(//1.
                                             char  *p1stCode); //(OPCODE : (0x05) 5)  : "~/"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_8(//1.
                                             char  *p1stCode); //(OPCODE : (0x08) 8)  : "-/"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_9(//1.
                                             char  *p1stCode); //(OPCODE : (0x09) 9)  : "*/"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_10(//1.
                                              char  *p1stCode); //(OPCODE : (0x0a) 10) : "&/"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_11(//1.
                                              char  *p1stCode); //(OPCODE : (0x0b) 11) : "*"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_12(//1.
                                              char  *p1stCode); //(OPCODE : (0x0c) 12) : "/"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_13(//1.
                                              char  *p1stCode); //(OPCODE : (0x0d) 13) : "%"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_14(//1.
                                              char  *p1stCode); //(OPCODE : (0x0e) 14) : "+"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_15(//1.
                                              char  *p1stCode); //(OPCODE : (0x0f) 15) : "+*"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_16(//1.
                                              char  *p1stCode); //(OPCODE : (0x10) 16) : "-"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_17(//1.
                                              char  *p1stCode); //(OPCODE : (0x11) 17) : "-*"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_18(//1.
                                              char  *p1stCode); //(OPCODE : (0x12) 18) : "<<"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_19(//1.
                                              char  *p1stCode); //(OPCODE : (0x13) 19) : ">>"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_20(//1.
                                              char  *p1stCode); //(OPCODE : (0x14) 20) : "<"

    //[2011.06.17.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_21(//1.
                                              char  *p1stCode); //(OPCODE : (0x15) 21) : "<="

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_22(//1.
                                              char  *p1stCode); //(OPCODE : (0x16) 22) : ">"

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_23(//1.
                                              char  *p1stCode); //(OPCODE : (0x17) 23) : ">="

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_24(//1.
                                              char  *p1stCode); //(OPCODE : (0x18) 24) : "=="

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_25(//1.
                                              char  *p1stCode); //(OPCODE : (0x19) 25) : "!="

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_26(//1.
                                              char  *p1stCode); //(OPCODE : (0x1a) 26) : "&"

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_27(//1.
                                              char  *p1stCode); //(OPCODE : (0x1b) 27) : "^"

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_28(//1.
                                              char  *p1stCode); //(OPCODE : (0x1c) 28) : "|"

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_29(//1.
                                              char  *p1stCode); //(OPCODE : (0x1d) 29) : "&&"

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_30(//1.
                                              char  *p1stCode); //(OPCODE : (0x1e) 30) : "||"

    //[2011.06.18.][Ϸ!!!]
    bool __fastcall DbgExp_Opcode_Operator_31(//1.
                                              char  *p1stCode); //(OPCODE : (0x1f) 31) : "="

//}


//[ ǥ]
//{
    struct  DEBUGVIEW_DISPLAY
    {
      //[2011.06.21.ȭ][!!!]{-----------------------------
      //[]  []  ǥ  .
      //}-----------------------------------------------------

      //[2011.06.20.][߰!!!]{---------------------------------------------
      // 4  4  ǥõǹǷ  ǥ  
      //Ѱ ڿ Ƶΰ, óϴ ʿ  Ͽ Ѵ.
      char  displayStr[Opt_DebugView_ViewStrSize];
      //}---------------------------------------------------------------------

      //[2011.07.01.][߰!!!]{------------------------
      //2/10/16    ΰ?
      // [2, 10, 16  ]  Ѵ.
      //
      //[2018.07.24.ȭ][߰!!!]-------------------------
      //[ڿ]  ߰ Ѵ.
      //'$' ڷ . 
      int   viewKind; //(⺻:16)
      //}------------------------------------------------

    };

    //[2011.06.22.][Ϸ!!!]
    //[2018.07.24.ȭ][Ϸ!!!]
    //[2021.11.28.][Ϸ]
    //[2022.01.13.][Ϸ]
    void __fastcall DebugViewDisplay_Make_DisplayStr(struct DEBUGVIEWINFO      *pDbgViewInfo,
                                                     struct DEBUGVIEW_DISPLAY  *pDbgViewDisplay,
                                                     struct DBG_OPND           *pOpnd);

//}


//[ â ]
//{
    //[2011.07.12.ȭ][߰!!!]{-----------------------
    //[Tree: â]    óѴ.
    //}-----------------------------------------------

    struct DBGEXP_TREE_INFO
    {
      //[2011.07.12.ȭ][!!!]{------------------------------------------
      //[Tree: â]  ߰ϴ [ ]  Ѵ.
      //  ޾Ƽ ó ϰ ȴ.
      //  [] Ҷ [μ]   Ѱִ 뵵θ ȴ.
      //}------------------------------------------------------------------

      //[ڿ ]{------------------------------------------------------------
      //
      //...
      //(2/10/16 ǥ)
      //Լ̸ : ...
      //ּ : ...
      //ڷ : ...
      //
      // 5   ڿν   ϳ  [׸]  óѴ.
      //}-------------------------------------------------------------------------

      // []  ǥϴµ ϴ ⺻   ڿ(5 ڿ).
      //[2011.07.17.][!!!]
      //⺻ [ ڿ] ũ Ҹ Ҵ ش.
      char   infoStr[Opt_DebugView_StrBufSize];      //(⺻ : NULL)

      //[]  ϴ {DB}  [ȣ].
      int    fileListIndex; //(⺻ : -1)

      //[Ȯ߿!!!]{------------------------------------------------------------------------
      //[]  ϴ [Լ]  {DB}  ġ.
      //[2011.07.19.ȭ][!!!][!!!]
      //   [ ]  ʿϴ.
      //[ ]   [ Լ ] <debug.cpp:_debug_FuncRecIndex>  Ѵ.
      int    funcRecIndex;  //(⺻ : -1)
      //}-----------------------------------------------------------------------------------------

      //ش   []  [/ ġ].
      // [ÿ]  ǹǷ [ÿ]  [/] ġ .
      int    expStartIndex; //(⺻ : -1)
      int    expEndIndex;   //(⺻ : -1)

    };

    //[2011.07.12.ȭ][Ϸ!!!]
    void __fastcall DbgExpTreeInfo_Format(struct DBGEXP_TREE_INFO  *pInfo);

    //[óԼ]
    //{
        //[2011.07.17.][Ϸ!!!]
        bool __fastcall DbgExpTreeInfo_Make_AddInfo(struct DBGEXP_TREE_INFO  *pInfo);

        //[2012.09.22.][Ϸ!!!]
        bool __fastcall DbgExpTreeInfo_Make_AddInfo_Edit(struct DBGEXP_TREE_INFO  *pInfo);

        //[2012.04.21.][Ϸ!!!]
        //[2018.07.24.ȭ][Ϸ!!!]
        //[2021.11.28.][Ϸ]
        //[2022.01.13.][Ϸ]
        void __fastcall DbgExpTree_Set_Info(//ó  ׸ġ(ݵ [׸:] ̾ ).
                                            int                pExpItemIndex,
                                            int                pFuncRecIndex,
                                            struct EXPRECORD  *pExpRecord,
                                            struct DBG_OPND   *pOpnd);

        //[2012.04.21.][Ϸ!!!]
        // [Tree: â]   []  ϰ ش  ϴ Լ.
        bool __fastcall DbgExpTree_View(//ó  ׸ġ(ݵ [׸:] ̾ ).
                                        int  pExpItemIndex);

        //[2011.07.20.][Ϸ!!!]
        bool __fastcall DbgExpTree_ViewAll(//[2011.07.20.][߰!!!]
                                           //true : [ â]  ٽ ׸.
                                           bool  pTreeRePaint);
                                        
    //}

//}

//[  ΰ Լ]
//{




//}


#endif
