
#ifndef font_h
#define font_h


//[!!!]{--------------------------------------------
//۲     Big-Endian   ִ.
//}-----------------------------------------------------


//[file]
//{
    //*.gft  [ID].
    #define  d_FILEID_font             0x00000001

//}

//[*.gft ۲ ]
//{
    //[۲]  ⺻ header   4 byte ̰  9  ִ.
    //̴  [۲]  쵵  .
    #define  d_HEADERsize              4 * 9

    //index ġ.
    #define  d_HEADER_fileid_ix        0
    #define  d_HEADER_filesize_ix      1
    #define  d_HEADER_width_ix         2
    #define  d_HEADER_height_ix        3
    #define  d_HEADER_language_ix      4
    #define  d_HEADER_count_ix         5
    #define  d_HEADER_coderange_ix     6
    #define  d_HEADER_DWinfo_ix        7
    #define  d_HEADER_dataindex_ix     8

    #define  d_HEADER_table_ix         9
//}

//[language  ]
//{
    //[⺻/ڿ ۲]
    #define  d_LANGUAGE_default_string_bt   31
    //{
        #define  d_default_bv    0
        #define  d_string_bv     1
    //}

    //[/ ۲]
    #define  d_LANGUAGE_fixed_variable_bt   30
    //{
        #define  d_fixed_bv      0
        #define  d_variable_bv   1
    //}

    //[Ե ]
    #define  d_LANGUAGE_KS_hangul_bt        0x000001
    #define  d_LANGUAGE_KS_symbol_bt        0x000002
    #define  d_LANGUAGE_KS_hanja_bt         0x000004
    #define  d_LANGUAGE_english_bt          0x000008

//}

//------------------------------------------------------------------------------

struct GFTNAME
{
  //[2010.01.26.ȭ][!!!]{-------------------------------------------------------
  //Ѱ <*.gft>  [̸]   Ҹ .
  // ó ϰ ϱ Ͽ [Ȯ]   Ѵ.
  //̷ ؾ δ ̹ [] Ƿ ϰ [ü]  ռҼ ִ.
  //}-------------------------------------------------------------------------------

  //<*.gft>   [̸]  ϸ ǹǷ 256 Ʈ ϴ.
  char  name[256];

  //߰ ̰ Ѵ.

};

struct FONTRESOURCE
{
  //[2006.09.26.ȭ][!!!]{---------------------
  //۲   ۲ ҽ Ѵ.
  // ۲  ҽ   óȴ.
  //}---------------------------------------------

  unsigned char  *buf;
  int             size;

  //[۲]
  //{
      //-------------------------------------------------------
      //۲ü.
      //buf[0] ġ ȴ.
      int             fontcount;   //4 byte.

      //۲ ڵ ̺ ġ.
      //buf[] 󿡼 4 byte  count ٷ ó ۵ȴ.
      //fonthandle[x]   *.gft  ִ ġ  ȴ.
      unsigned int   *fonthandle;  //4 byte  .
      //-------------------------------------------------------
  //}

  //[۲ ҽ ]{----------------------------------------------------------------
  //[۲ü] + {[۲0 handle] + [۲1 handle] + ... } + { [۲0] + [۲1] + ... }.
  //   4              4                 4                    *.gft     *.gft
  //}----------------------------------------------------------------------------------

  //[۲ ü (ڿ)]
  //{
      //[2010.01.26.ȭ][߰!!!]{------------------------------------------------------
      //[۲]  [۲̸]  Ҽ ֵ [ҽ]   
      // [۲̸]  Ѵ.
      //, ݵ   ġؾ ϸ ̷ ־ ã ġ  index 
      //ǹǷ ó .
      //}------------------------------------------------------------------------------

      // [font]   ͸ ϸ ȴ.
      struct GFTNAME  *names;

  //}

};

struct FONTPACK
{
  //[2006.09.27.][!!!]{----------------------------------------
  //  شϴ *.gft  handle  Ѵ.
  //⺻ 4  ϹǷ  ؼ Ѵ.
  //handle[0] : ѱ.
  //handle[1] : ȣ.
  //handle[2] : .
  //handle[3] : .

  //[2007.02.04.][߰!!!]
  //handle[4] : ѱ().
  //handle[5] : ȣ().
  //handle[6] : ().
  //handle[7] : ().

  //, ⺻ ġ +4  ϸ ش ۲ [۲] ġ ȴ.
  //}----------------------------------------------------------------

  //*.gft Ͽ ٷ Ҽ ִ handle.
  #define  d_FontPack_GftMax    8
  unsigned char  *gft[d_FontPack_GftMax];

  //[۲ ]
  //{
      #define  d_FONTSTYLE_default           0
      #define  d_FONTSTYLE_bold              4

      //[⺻۲] ġ +4  ϸ [۲] ġ ǵ d_FONTSTYLE_bold  4  Ѵ.
      // ⺻۲ index + d_FONTSTYLE_bold  [۲] ġ ؼ Ѵ.
  //}

  #define  d_FONTPACK_hangul_ix          0  //handle[0]
  #define  d_FONTPACK_symbol_ix          1  //handle[1]
  #define  d_FONTPACK_hanja_ix           2  //handle[2]
  #define  d_FONTPACK_english_ix         3  //handle[3]

  #define  d_FONTPACK_hangul_bold_ix     4  //handle[4]
  #define  d_FONTPACK_symbol_bold_ix     5  //handle[5]
  #define  d_FONTPACK_hanja_bold_ix      6  //handle[6]
  #define  d_FONTPACK_english_bold_ix    7  //handle[7]

  //[option]
  //{
      //[۲ ]  ϳ TFont    [۲]     ´.

      //[editor-left margin]
      //{
          //  left margin.
          //̴ editor  debug     ̴.
          int  margin_size;

      //}

      //[moonja offset]
      //{
          //½ [] [///]   offset. (BASE : 0)
          // κ [ ]  Ѵ.(ݵ [ڹ]  ĥش.)
          int  offset_left;
          int  offset_right;
          int  offset_top;
          int  offset_bottom;
      //}

      //[  ]
      //{
          //[2010.01.25.][߿߰!!!]{------------------------------------------
          //ASCII ڴ   ϱ Ͽ   ߰ ´.
          //⺻ [۲ù]  [3, 7]  index   Ƿ  
          // ⺻ ۲ð ʹ ޸ ߰    Ѵ.
          //, / 츸 شѴ.
          //
          //  [ ۲]    ϴ.
          //⺻ [ ۲]   ȿ pixel  ϹǷ ״
          //ϴ 
          //}----------------------------------------------------------------------

          int  en_offset_left;   //⺻(0).
          int  en_offset_right;  //⺻(0).

      //}

  //}

};

//[FONTRESOURCE]----------------------------------------------------------------

void __fastcall FONTRESOURCE_GetHandle(struct FONTRESOURCE **rFONTRESOURCE);

void __fastcall FONTRESOURCE_Init(void);

//[2006.09.29.][Ϸ!!!]
void __fastcall FONTRESOURCE_Load(void);

//[FONTPACK]--------------------------------------------------------------------

void __fastcall FONTPACK_GetHandle(struct FONTPACK **rFONTPACK);

void __fastcall FONTPACK_Init(void);

//[2006.09.29.][Ϸ!!!]
void __fastcall FONTPACK_Register(struct FONTPACK  *pFONTpack,
                                  unsigned char    *pHANGUL,
                                  unsigned char    *pSYMBOL,
                                  unsigned char    *pHANJA,
                                  unsigned char    *pENGLISH,
                                  unsigned char    *pHANGULbold,
                                  unsigned char    *pSYMBOLbold,
                                  unsigned char    *pHANJAbold,
                                  unsigned char    *pENGLISHbold);

//[2018.07.02.][Ϸ!!!]
void __fastcall FONTPACK_SetDefault(struct FONTPACK *pFONTpack);

//[2010.01.26.ȭ][Ϸ!!!]
bool __fastcall FONTPACK_SetFont_withName(//  Ǵ [۲ù].
                                          struct FONTPACK  *pFontPack,
                                          //[۲ù]   ġ.
                                          int               pSetIndex,
                                          //[۲ù]  Ҵ [۲̸].
                                          char             *pFontName);

//[2010.02.12.][Ϸ!!!]
void __fastcall FONTPACK_Get_MaxHeight(//  [۲ù].
                                       struct FONTPACK  *pFontPack,
                                       //۲ ߰ 鼳 ݿϴ  true(⺻ : false).
                                       bool              pFontOfs,
                                       // ȯ.
                                       int              *rMaxHeight);

//[۲  Լ]--------------------------------------------------------------

void __fastcall FONT_Get_MoonjaPtr_byORDER(//*.gft  ڵ.
                                           unsigned char  *pFONThandle,
                                           //ڼ.
                                           int             pORDER,
                                           //{font-data}  byte ġ.
                                           int            *rPTRbyte,
                                           //{font-data}  bit ġ.
                                           int            *rPTRbit);

bool __fastcall FONT_Get_FontHandle_byCODE(//[ ۲ ].
                                           struct FONTPACK   *pFONTPACK,
                                           // code.
                                           unsigned short     pCODE,
                                           //ش code   [۲]  pFONTPACK  index  ȯѴ.
                                           int               *rFONTindex);

void __fastcall FONT_Get_MoonjaOrder_byCODE(unsigned char   *pFONThandle,
                                            unsigned short   pCODE,
                                            int             *rORDER);

bool __fastcall FONT_Get_MoonjaPtr_byCODE(//[ ۲ ].
                                          struct FONTPACK   *pFONTPACK,
                                          //ڼ.
                                          unsigned short     pCODE,
                                          //ش code   [۲]  pFONTPACK  index  ȯѴ.
                                          int               *rFONTindex,
                                          //ڼ.
                                          int               *rMOONJAorder,
                                          //{font-data}  byte ġ.
                                          int               *rPTRbyte,
                                          //{font-data}  bit ġ.
                                          int               *rPTRbit);

//[2012.05.15.ȭ][Ϸ!!!]
bool __fastcall FONT_Out_Moonja(//[]   bitmap handle.
                                Graphics::TBitmap  *pVIEWhandle,
                                //[ ۲ ].
                                struct FONTPACK    *pFONTPACK,
                                //ڸ ǥ ǥ.(BASE:0)
                                int                 pX,
                                int                 pY,
                                //ڻ.
                                int                 pMOONJAcolor,
                                //.
                                int                 pBACKcolor,
                                //Ӽ.
                                bool                pBACKtransparent,
                                //  ڵ.
                                unsigned short      pCODE,
                                //µ  width, height  ȯ.
                                //[2012.05.15.ȭ][!!!]
                                //NULL  ƴ 츸 ȯ.
                                int                *rWIDTH,
                                int                *rHEIGHT);

//[2011.08.22.][Ϸ!!!]
bool __fastcall FONT_Out_String(//[]   bitmap handle.
                                Graphics::TBitmap  *pVIEWhandle,
                                //[ ۲ ].
                                struct FONTPACK    *pFONTPACK,
                                //ڿ   ġ.(BASE:0)
                                //  ȯϱ⵵ Ѵ.
                                int                 pX,
                                int                 pY,
                                //ڻ.
                                int                 pMOONJAcolor,
                                //.
                                int                 pBACKcolor,
                                //Ӽ.
                                bool                pBACKtransparent,
                                // ڿ.
                                char               *pSTRING,
                                //ڿ   (x, y) ǥ ȯѴ.
                                int                *rX,
                                int                *rY);

bool __fastcall FONT_Out_Moonja2(//[]   bitmap handle.
                                 Graphics::TBitmap  *pVIEWhandle,
                                 //[ ۲ ].
                                 struct FONTPACK    *pFONTPACK,
                                 //ڸ ǥ ǥ.(BASE:0)
                                 int                 pX,
                                 int                 pY,
                                 //ڻ.
                                 int                 pMOONJAcolor,
                                 //.
                                 int                 pBACKcolor,
                                 //Ӽ.
                                 bool                pBACKtransparent,
                                 //  ڵ.
                                 unsigned short      pCODE,
                                 //[field option]--------------------------------
                                 // .
                                 int                 pUNDERLINEkind,
                                 //[]  .
                                 bool                pUNDERLINEspace,
                                 //  BOX  Ʒ   ġ.
                                 int                 pUNDERLINEoffset,
                                 // .
                                 int                 pUNDERLINEcolor,
                                 //----------------------------------------------
                                 //µ  width, height  ȯ.
                                 int                *rWIDTH,
                                 int                *rHEIGHT);

#define  d_FONT_underline_no      0
#define  d_FONT_underline_dot     1
#define  d_FONT_underline_dot2    2
#define  d_FONT_underline_line    3

//[2011.08.22.][Ϸ!!!]
bool __fastcall FONT_Out_String2(//[]   bitmap handle.
                                 Graphics::TBitmap  *pVIEWhandle,
                                 //[ ۲ ].
                                 struct FONTPACK    *pFONTPACK,
                                 //ڿ   ġ.(BASE:0)
                                 //  ȯϱ⵵ Ѵ.
                                 int                 pX,
                                 int                 pY,
                                 //ڻ.
                                 int                 pMOONJAcolor,
                                 //.
                                 int                 pBACKcolor,
                                 //Ӽ.
                                 bool                pBACKtransparent,
                                 // ڿ.
                                 char               *pSTRING,
                                 //[field option]--------------------------------
                                 // .
                                 int                 pUNDERLINEkind,
                                 //[]  .
                                 bool                pUNDERLINEspace,
                                 //  BOX  Ʒ   ġ.
                                 int                 pUNDERLINEoffset,
                                 // .
                                 int                 pUNDERLINEcolor,
                                 //----------------------------------------------
                                 //ڿ   (x, y) ǥ ȯѴ.
                                 int                *rX,
                                 int                *rY);

//[2010.01.30.][Ϸ!!!]
bool __fastcall FONT_Out_StyleMoonja(//[]   bitmap handle.
                                     Graphics::TBitmap  *pVIEWhandle,
                                     //[ ۲ ].
                                     struct FONTPACK    *pFONTPACK,
                                     //ڸ ǥ ǥ.(BASE:0)
                                     int                 pX,
                                     int                 pY,
                                     //ڻ.
                                     int                 pMOONJAcolor,
                                     //.
                                     int                 pBACKcolor,
                                     //Ӽ.
                                     bool                pBACKtransparent,
                                     //.(⺻۲/۲...)
                                     int                 pSTYLE,
                                     //  ڵ.
                                     unsigned short      pCODE,
                                     //[field option]--------------------------------
                                     // .
                                     int                 pUNDERLINEkind,
                                     //[]  .
                                     bool                pUNDERLINEspace,
                                     //  BOX  Ʒ   ġ.
                                     int                 pUNDERLINEoffset,
                                     // .
                                     int                 pUNDERLINEcolor,
                                     //----------------------------------------------
                                     //µ  width, height  ȯ.
                                     int                *rWIDTH,
                                     int                *rHEIGHT);

//[2011.08.22.][Ϸ!!!]
bool __fastcall FONT_Out_StyleString2(//[]   bitmap handle.
                                      Graphics::TBitmap  *pVIEWhandle,
                                      //[ ۲ ].
                                      struct FONTPACK    *pFONTPACK,
                                      //ڿ   ġ.(BASE:0)
                                      int                 pX,
                                      int                 pY,
                                      //ڻ.
                                      int                 pMOONJAcolor,
                                      //.
                                      int                 pBACKcolor,
                                      //Ӽ.
                                      bool                pBACKtransparent,
                                      //.(⺻۲/۲...)
                                      int                 pSTYLE,
                                      // ڿ.
                                      char               *pSTRING,
                                      //[field option]--------------------------------
                                      // .
                                      int                 pUNDERLINEkind,
                                      //[]  .
                                      bool                pUNDERLINEspace,
                                      //  BOX  Ʒ   ġ.
                                      int                 pUNDERLINEoffset,
                                      // .
                                      int                 pUNDERLINEcolor,
                                      //----------------------------------------------
                                      //ڿ   (x, y) ǥ ȯѴ.
                                      int                *rX,
                                      int                *rY);

//[2011.08.22.][Ϸ!!!]
bool __fastcall FONT_Out_StyleString3(//[]   bitmap handle.
                                      Graphics::TBitmap  *pVIEWhandle,
                                      //[ ۲ ].
                                      struct FONTPACK    *pFONTPACK,
                                      //ڿ   ġ.(BASE:0)
                                      int                 pX,
                                      int                 pY,
                                      //ڻ.
                                      int                 pMOONJAcolor,
                                      //.
                                      int                 pBACKcolor,
                                      //Ӽ.
                                      bool                pBACKtransparent,
                                      //.(⺻۲/۲...)
                                      int                 pSTYLE,
                                      // ڿ.
                                      char               *pSTRING,

                                      //[2010.02.19.][߰!!!]--------
                                      // [ ] ġ.
                                      int                 pStartIndex,
                                      // [ ]   ġ.
                                      int                 pEndIndex,

                                      //[field option]--------------------------------
                                      // .
                                      int                 pUNDERLINEkind,
                                      //[]  .
                                      bool                pUNDERLINEspace,
                                      //  BOX  Ʒ   ġ.
                                      int                 pUNDERLINEoffset,
                                      // .
                                      int                 pUNDERLINEcolor,
                                      //----------------------------------------------
                                      //ڿ   (x, y) ǥ ȯѴ.
                                      int                *rX,
                                      int                *rY);

//[2012.05.15.ȭ][Ϸ!!!]
bool __fastcall Font_StyleStr_AutoLine(//[]   bitmap handle.
                                       Graphics::TBitmap  *pViewHandle,
                                       //[ ۲ ].
                                       struct FONTPACK    *pFontPack,
                                       //ڿ   ġ.(BASE:0)
                                       int                 pX,
                                       int                 pY,

                                       //[2012.05.15.ȭ][߰!!!]{----------------------------------
                                       //[]  (0    ).
                                       // []  Ѵ  CRLF  ڵ  ٲش.
                                       //<pViewHandle> (0, 0) ġ    ȴ.
                                       int                 pWidth,
                                       //}----------------------------------------------------------

                                       //ڻ.
                                       int                 pMoonjaColor,
                                       //.
                                       int                 pBackColor,
                                       //Ӽ.
                                       bool                pBackTransparent,
                                       //.(⺻۲/۲...)
                                       int                 pStyle,
                                       // ڿ.
                                       char               *pStr,
                                       //[field option]--------------------------------
                                       // .
                                       int                 pUnderLineKind,
                                       //[]  .
                                       bool                pUnderLineSpace,
                                       //  BOX  Ʒ   ġ.
                                       int                 pUnderLineOffset,
                                       // .
                                       int                 pUnderLineColor,
                                       //----------------------------------------------
                                       //ڿ   (x, y) ǥ ȯѴ.
                                       int                *rX,
                                       int                *rY);



//[2011.08.22.][Ϸ!!!]
bool __fastcall FONT_Out_String2_withLINEstartINDEX(//[]   bitmap handle.
                                                    Graphics::TBitmap  *pVIEWhandle,
                                                    //[ ۲ ].
                                                    struct FONTPACK    *pFONTPACK,
                                                    //ڿ   ġ.(BASE:0)
                                                    int                 pX,
                                                    int                 pY,
                                                    //ڻ.
                                                    int                 pMOONJAcolor,
                                                    //.
                                                    int                 pBACKcolor,
                                                    //Ӽ.
                                                    bool                pBACKtransparent,
                                                    // ڿ.
                                                    char               *pSTRING,
                                                    //  index.(pSTRING[pLINEstartINDEX]  ȴ.)
                                                    int                 pLINEstartINDEX,
                                                    //.
                                                    int                 pLINEheight,
                                                    //[field option]--------------------------------
                                                    // .
                                                    int                 pUNDERLINEkind,
                                                    //[]  .
                                                    bool                pUNDERLINEspace,
                                                    //  BOX  Ʒ   ġ.
                                                    int                 pUNDERLINEoffset,
                                                    // .
                                                    int                 pUNDERLINEcolor);

//[2011.08.22.][Ϸ!!!]
bool __fastcall FONT_Out_LineStr_withSTARTENDindex(//[]   bitmap handle.
                                                   Graphics::TBitmap  *pVIEWhandle,
                                                   //[ ۲ ].
                                                   struct FONTPACK    *pFONTPACK,
                                                   //ڿ   ġ.(BASE:0)
                                                   int                 pX,
                                                   int                 pY,
                                                   //ڻ.
                                                   int                 pMOONJAcolor,
                                                   //.
                                                   int                 pBACKcolor,
                                                   //Ӽ.
                                                   bool                pBACKtransparent,
                                                   // ڿ.
                                                   char               *pSTRING,
                                                   //  index.
                                                   int                 pSTARTindex,
                                                   //  index.
                                                   int                 pENDindex,
                                                   //[field option]--------------------------------
                                                   // .
                                                   int                 pUNDERLINEkind,
                                                   //[]  .
                                                   bool                pUNDERLINEspace,
                                                   //  BOX  Ʒ   ġ.
                                                   int                 pUNDERLINEoffset,
                                                   // .
                                                   int                 pUNDERLINEcolor);

//[2012.05.15.ȭ][Ϸ!!!]
bool __fastcall FONT_Get_MoonjaOutAreaInfo(//[ ۲ ].
                                           struct FONTPACK    *pFONTPACK,
                                           //[2010.01.30.][߰!!!]
                                           //[۲/۲]  Ѵ.
                                           int                 pStyle,
                                           //  ڵ.
                                           unsigned short      pCODE,
                                           //µ  width, height  ȯ.
                                           //[2012.05.15.ȭ][!!!]
                                           //NULL   ȯ ʴ´.
                                           int                *rWIDTH,
                                           int                *rHEIGHT);
//[2012.05.28.][Ϸ!!!]
bool __fastcall FONT_Get_StringOutAreaInfo(//[ ۲ ].
                                           struct FONTPACK  *pFONTPACK,
                                           //[2010.01.30.][߰!!!]
                                           //[۲/۲]  Ѵ.
                                           int               pStyle,
                                           // ڿ.
                                           char             *pSTRING,
                                           //ڿ   ũ .
                                           int              *rWIDTH,
                                           int              *rHEIGHT);

//[2011.07.16.][Ϸ!!!]
int __fastcall FONT_Get_StringOutAreaInfo_Width(//[ ۲ ].
                                                struct FONTPACK  *pFontPack,
                                                //[۲/۲]  Ѵ.
                                                int               pStyle,
                                                // ڿ.
                                                char             *pStr);

//[2012.03.30.][Ϸ!!!]
bool __fastcall Font_LineStr_Get_Length_condWidth(//ó ڿ.
                                                  char             *pStr,
                                                  // [۲ ].
                                                  struct FONTPACK  *pFontPack,
                                                  //[۲/۲]  Ѵ.
                                                  int               pStyle,
                                                  //   .
                                                  int               pSetWidth,
                                                  //  Ű ڿ (NULL  ƴ 츸 ȯ).
                                                  int              *rStrLength);

//[2012.05.15.ȭ][Ϸ!!!]
bool __fastcall Font_Get_AutoLineStr_OutAreaInfo(//[ ۲ ].
                                                 struct FONTPACK  *pFontPack,
                                                 //[2010.01.30.][߰!!!]
                                                 //[۲/۲]  Ѵ.
                                                 int               pStyle,
                                                 //(  Ѵ  ڵ ٹٲ).
                                                 int               pWidth,
                                                 // ڿ.
                                                 char             *pStr,
                                                 //ڿ   ũ .
                                                 //[2012.05.16.][!!!]{------------------------------
                                                 //<pWidth > 0> ̶ Ȯ   [ִ]  ȯ.
                                                 int              *rWidth,
                                                 //}------------------------------------------------------
                                                 int              *rHeight);



#endif

