//---------------------------------------------------------------------------

#ifndef GTreeH
#define GTreeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------


#include  "font.h"
#include  "c_define.h"
#include  "ide_popup.h"


struct  TREEITEM
{
  //[2006.11.16.][!!!]{------------
  //tree  ׸ ϳ  ´.
  //}------------------------------------

  // Ѵ. (BASE : '.')
  char   kind;
  //{
      //'+' : ĥ ִ .
      //'-' : ̹  .
      //'.' : ܼ  ׸.
      //ݵ  3 ϳ ´.
  //}

  //[ٱ]  ܰ踦 .(BASE : 0)
  //0  [Ѹ]  Ǹ,  Ŭ level   ̴.
  int    level;

  //[׸]   ϴ ̸.(ߺɼ .)
  char   name[OPT_name_length];

  //[׸]  ǥϴ ڿ.(ߺɼ ִ.)
  char   txt[OPT_Tree_Item_Text_length];

  //[׸-׸]   Ѵ.
  int    bmpindex;

  //[2009.01.25.][߰!!!]
  //{
      //[߿!!!]{------------------------------------------------------------------------------
      //{DATABASE}  record-index  Ѵ.
      //̴ [׸]    ش  ִ     ֱ  ̴.
      //پ   ־ ϹǷ ٷ ã ֵ {DATABASE}  ϱ  ̴.
      //(BASE : -1)
      //}---------------------------------------------------------------------------------------

      int  dbRecIndex;

  //}

};

struct  ITEMXY
{
  //[2006.11.20.][!!!]{----------------------------------------------
  //tree  item ϳ ׷ִµ ʿ  ߿ ǥ Ѵ.
  //}----------------------------------------------------------------------

  //[꿡 ʿ ⺻]
  //{
      //  ѹ ϸ ȴ.

      //tree ü  . (BASE : 0)
      int  tree_x;
      int  tree_y;

      // ( ̿ .)
      int  line_height;
  //}

  //[ ⺻ ]
  //{
      //׷ item    ȴ.

      //׷  .(BASE : 0)
      int  line_number;

      //item  ٱ ܰ.(BASE : 0)
      int  item_level;
  //}

  //[  ǥ]
  //{
      //item  ׸  ü  .
      int  org_x;
      int  org_y;

      //[׸]   ǥ.
      int  icon_x;
      int  icon_y;

      //[׸]   ߽.
      int  icon_middle_x;
      int  icon_middle_y;

      //[׸]   ǥ.
      int  icon_top_x;
      int  icon_top_y;

      //[׸]   ǥ.
      int  icon_right_x;
      int  icon_right_y;

      //[׸] Ʒ  ǥ.
      int  icon_bottom_x;
      int  icon_bottom_y;

      //[׸] μ  ǥ.
      int  vline_top_x;
      int  vline_top_y;

      //[׸] μ Ʒ ǥ.
      int  vline_bottom_x;
      int  vline_bottom_y;

      //[׸] μ  ǥ.
      int  hline_right_x;
      int  hline_right_y;

      //ڿ  ġ ǥ.([׸-׸]   )
      int  text_x;
      int  text_y;

      //ڿ  ġ ǥ.([׸-׸]  ִ )
      int  text2_x;
      int  text2_y;

      //[׸-׸]  ǥ ǥ.
      int  item_icon_x;
      int  item_icon_y;

      // ߽  .
      int  mh;
      // ߽ Ʒ .
      int  ml;
  //}

};

struct  TREE
{
  //[2006.11.16.][!!!]{--------------------------------------------------------------
  //tree Ѱ ׷  ´.
  // ü  Ͽ Ѱ tree  ϼҼ ִ.
  //
  //[2009.09.13.][߿!!!]-----------------------------------------------------------
  //<items>  迭  ʰ Ҽ ֵ Ѵ.
  //̴ ޸𸮸  ʰ,  ҽ ٶ   Ƿ
  //   ϱ  ̴.
  //⺻ 1000  ϵ ũ⸦ Ѵ  ٽ  ū ũ  Ҽ ֵѴ.
  //}--------------------------------------------------------------------------------------

  //[2009.09.13.][߿!!!]{------------
  //    ͷ ٲ۴.
  struct TREEITEM  *items;
  //}----------------------------------------

  //[Tree ũ]
  //{
      //[2009.09.13.][߰!!!]{----------------------------------------------------
      // tree  Ҽ ִ <item>  ִ ( tree  ũ).
      // ǹǷ ش ũ  ⿡ Ͽ ؾ Ѵ.
      //}----------------------------------------------------------------------------

      int  size;

  //}

  int               items_count;

  //[level open/close]
  //{
      //------------------------------------------------------------------------
      // level  open/close  ´.
      // bit   level  ϹǷ  32  ٱ⸦ ǺҼ ִ.
      //1 : open.
      //0 : close.
      unsigned int     level_open_close_bit;
      //  tree  ׸ ٱ⸦ ׷ֱ Ͽ ʿϴ.
      //, ׷ٶ Ͻ ʿϴ.
      //------------------------------------------------------------------------
  //}

  //[ð]
  //{
      //--------------------------------------------------------------------------------------------
      // tree  õ .(  ȴ.)
      //(BASE : -1)
      int  select_line;

      //select_line   _TreeView() Լ ׸鼭   õ [׸]  itemindex.
      //̴   ȴ.
      //(BASE : -1)
      int  select_itemindex;
      //--------------------------------------------------------------------------------------------
  //}

  //׸   Ѵ.
  //̴ Ʒ ȿ     ϱ Ͽ ȴ.
  int  last_line;

  //ũ ġ Ѵ.
  int  scroll_position;

  //[2009.02.01.]
  //{
      //[]  [] ϴ  Ʒ   ־ Ѵ.
      //
      //items_count      : []   ŭ  ־ Ѵ.
      //select_line      :  -1  ʱȭ.
      //select_itemindex :  -1  ʱȭ.
      //
      //[]  õ   ϴ ƿ -1  ʱȭ ع  .

  //}

};


class TGTree_Form : public TForm
{
__published:	// IDE-managed Components

        void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
        void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall FormDblClick(TObject *Sender);
        void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);

private:	// User declarations
public:		// User declarations

        __fastcall TGTree_Form(TComponent* Owner);
        __fastcall ~TGTree_Form(void);

        //[Ŭ]
        //{
            void __fastcall WndProc(Messages::TMessage &Message);

        //}

        //----------------------------------------------------------------------
        //[]--------------------------------------------------------------
        //----------------------------------------------------------------------

        //[ ]
        //{
            //[2010.02.25.][߰!!!]{-----------------------------------------
            // ü VMOS 󿡼 <void *>  Ѱ(8 Byte)  ü
            //PC   ġ ϹǷ  ٸ  ü ü
            // [Ӽ]  Ѵ.
            //, VMOS 󿡼 ü ϳ ͷθ ȴ.
            //}-----------------------------------------------------------------

            //[ĺ]
            //{
                //[2010.02.25.][߰!!!]{----------------------------------------------------
                //ڰ  [ĺ]   ׸ ǰ  ٸ  ž Ѵ.
                // [ĺ]  [˸] ȿ  ־, ˸  [׸ǰ]  
                //VMOS ʿ  [ĺ] Ȯ  ϰ Ҽ ְ ϱ  ̴.
                //}----------------------------------------------------------------------------

                unsigned short  _GID;

            //}

        //}

        //----------------------------------------------------------------------
        //[Ӽ]----------------------------------------------------------------
        //----------------------------------------------------------------------

        //[VAR]
        //{
            //[ȯ溯]
            //{
                //[2007.10.02.ȭ][߰!!!]
                struct  IDE_OPTION   *_ide_option;

            //}

            //[ ׸ ]
            //{
                Graphics::TBitmap  *_bmp_;

                Graphics::TBitmap  *_bmp_back_;

            //}

            //[۲]
            //{
                struct FONTPACK     _font;

            //}

            // Ʈ    .
            int  _line_height;

            //[tree]
            //{
                //item  ׸ ϴ ǥ.
                // ⺻ ʱȭ ѵ Ѵ.
                struct  ITEMXY  _item_xy;

                //[bmp]
                //{
                    //-----------------------------------------------------------------------------------
                    //tree      ׸.
                    //ó ӵ  ϱ Ͽ ׸ ʰ ٷ Ҽ ֵ ׸ Ѵ.
                    Graphics::TBitmap  *_bmp_tree_p,   //'+'
                                       *_bmp_tree_m,   //'-'
                                       *_bmp_tree_i,   //'.'
                                       *_bmp_tree_3,   //3 ٱ.
                                       *_bmp_tree_end; //ٱ .

                    //̱׸ copy Ҷ  gui Լ clBlack κ  ִ κи copy Ͽ
                    // ġ ؾ Ѵ.
                    //------------------------------------------------------------------------------------
                //}

                //[׸ bmp]
                //{
                    // ׸ ǥϴ [׸].
                    #define  d_ITEMBMP_max  14
                    Graphics::TBitmap  *_bmp_item[d_ITEMBMP_max];
                    //{
                        #define  d_ITEMBMP_root        0
                        #define  d_ITEMBMP_define      1
                        #define  d_ITEMBMP_function    2
                        #define  d_ITEMBMP_global      3
                        #define  d_ITEMBMP_struct      4
                        #define  d_ITEMBMP_struct_def  5
                        #define  d_ITEMBMP_union       6
                        #define  d_ITEMBMP_union_def   7
                        #define  d_ITEMBMP_item        8
                        #define  d_ITEMBMP_folder      9
                        #define  d_ITEMBMP_file_c      10
                        #define  d_ITEMBMP_file_h      11
                        #define  d_ITEMBMP_file_x      12
                        #define  d_ITEMBMP_api         13

                    //}

                //}

                //[tree]
                //{
                    //[2006.11.19.][߰!!!]{---------
                    //tree  ׷ 3  ü.
                    //}---------------------------------

                    #define  d_TREE_max     4

                    struct TREE         _tree[d_TREE_max];
                    //{
                        #define  d_TREE_project   0
                        #define  d_TREE_info      1
                        #define  d_TREE_api       2
                        #define  d_TREE_system    3

                    //}

                    //ǥ tree   Ѵ.([]   ǥϴ )
                    int                 _tree_select_index;

                //}

            //}

            //[2007.03.31.][߰!!!]
            //{
                // bmp δ    ϴ  .(÷ ٲ  ƴϹǷ...)
                AnsiString  _bmp_path;

            //}

        //}

        //[  ü]
        //{
            //[]
            //{
                //[2009.02.02.][߰!!!]
                Tide_popup_Form  *_popupMenu;

                //[Լ]
                //{
                    //[2009.05.31.][Ϸ!!!]
                    void __fastcall _PopupMemu_Set(//[]    Ѵ.
                                                   int  pTreeIndex);

                    //[2009.05.31.][Ϸ!!!]
                    void __fastcall _EVENT_PopupMenu_Prj(void);

                    //[2009.05.31.][Ϸ!!!]
                    void __fastcall _EVENT_PopupMenu_Info(void);

                    //[2009.05.31.][Ϸ!!!]
                    void __fastcall _EVENT_PopupMenu_Api(void);

                    //[2009.05.31.][Ϸ!!!]
                    void __fastcall _EVENT_PopupMenu_System(void);

                //}

            //}

        //}

        //[FUNCTION]
        //{
            //[2006.10.26.][Ϸ!!!]
            void __fastcall _Resize(void);

            void __fastcall _Draw(void);

            void __fastcall _V_Scroll(int  pPOSITION);

            //[TREE ]
            //{
                void __fastcall _TreeView(int   pTREEindex,
                                          bool  pCONTROL);

                //[2009.06.02.ȭ][Ϸ!!!]
                void __fastcall _Tree(struct TREE  *pTREE,
                                      bool          pCONTROL);

                //[2009.01.27.ȭ][Ϸ!!!]
                void __fastcall _Item_Init(struct TREEITEM  *pTREEitem);

                //[2009.10.06.ȭ][Ϸ!!!]
                void __fastcall _Item_Text(struct TREEITEM  *pTreeItem,
                                           char             *pText); 

                //[2009.09.13.][Ϸ!!!]
                void __fastcall _Tree_Delete(struct TREE  *pTree);

                //[2009.09.13.][Ϸ!!!]
                void __fastcall _Tree_Create(struct TREE  *pTree,
                                             // ũ( ׸ Ѽ).
                                             int           pSize);

                //[2009.09.13.][Ϸ!!!]
                void __fastcall _Tree_ReSize(struct TREE  *pTree);


                //[2009.09.13.][Ϸ!!!]
                void __fastcall _Tree_Init(struct TREE  *pTREE,
                                           //[2009.09.13.][߰!!!]
                                           //ʱȭ  ũ⸦ Ҽ ְ Ѵ.
                                           int           pSize);

                //[2009.09.13.][Ϸ!!!]
                void __fastcall _Tree_Add_Item(struct TREE      *pTREE,
                                               struct TREEITEM  *pITEM);

                //[2009.09.13.][Ϸ!!!]
                bool __fastcall _Tree_Add_NodeItem(struct TREE      *pTREE,
                                                   char             *pNODEname,
                                                   struct TREEITEM  *pITEM);

                void __fastcall _Tree_Get_ItemIndex_withNAME(struct TREE  *pTREE,
                                                             char         *pITEMname,
                                                             int          *rITEMindex);

                //[2009.08.18.ȭ][Ϸ!!!]
                void __fastcall _Tree_Get_ItemIndex_withText(struct TREE  *pTree,
                                                             char         *pItemText,
                                                             int          *rItemIndex);

                void __fastcall _Tree_Get_NodeInfo(struct TREE  *pTREE,
                                                   // []  [̸].
                                                   char         *pNODEname,
                                                   // []  tree 󿡼 item-index.
                                                   int          *rNODEindex,
                                                   // []    []   item-index.
                                                   int          *rNODEendITEMindex,
                                                   // []    []  item-index.
                                                   int          *rNODElastITEMindex);

                void __fastcall _Tree_Make_InsertPosition(struct TREE  *pTREE,
                                                          // ġ.(   Ѵ.)
                                                          int           pINSERTindex);

                void __fastcall _Tree_Get_XY(struct ITEMXY  *prITEMxy);

                //[2009.08.18.ȭ][Ϸ!!!]
                void __fastcall _Tree_Get_Node_LastItemIndex(struct TREE  *pTREE,
                                                             // []  index.
                                                             int           pNODEindex,
                                                             // []    []   item-index.
                                                             int          *rNODEendITEMindex,
                                                             // []     item-index.
                                                             int          *rNODElastITEMindex);

                //[2009.01.30.][Ϸ!!!]
                void __fastcall _Tree_Get_Node_LastItemIndex2(struct TREE  *pTree,
                                                              // []  name.
                                                              char         *pNodeName,
                                                              // []  <itemindex>  ȯѴ.
                                                              int          *rNodeItemIndex,
                                                              // []   [ ]   item-index.
                                                              int          *rNodeJikgyeLastItemIndex,
                                                              // []     item-index.
                                                              int          *rNodeLastItemIndex);


                //[2009.02.02.][Ϸ!!!]
                void __fastcall _Tree_Get_ThisItemNode_LastItemIndex(struct TREE  *pTREE,
                                                                     // itemindex.
                                                                     int           pITEMindex,
                                                                     //[2009.02.02.][߰!!!]
                                                                     int          *rNodeIndex,
                                                                     // []    []   item-index.
                                                                     int          *rNODEendITEMindex,
                                                                     // itemindex  ϴ []   itemindex.
                                                                     int          *rNODElastITEMindex);

                void __fastcall _Tree_Bmp_Create_Load(Graphics::TBitmap **pBITMAP,
                                                      AnsiString          pBMPname);

                //[2006.12.08.][Ϸ!!!]
                void __fastcall _Get_ItemIndex_withLINE(struct TREE    *pTREE,
                                                        int             pLINEnumber,
                                                        int            *rITEMindex,
                                                        int            *rTEXTx,
                                                        int            *rTEXTy);

                //[2006.12.11.][Ϸ!!!]
                int __fastcall _Get_ViewLineCount(struct TREE  *pTREE);

                //[2009.01.27.ȭ][Ϸ!!!]
                void __fastcall _Tree_Get_Node_ItemCount(struct TREE  *pTree,
                                                         // []  [̸].
                                                         char         *pNodeName,
                                                         // []  item-index.
                                                         int          *rNodeItemindex,
                                                         // []    .
                                                         int          *rItemCount);

                //[2009.01.29.][Ϸ!!!]
                void __fastcall _Tree_Get_Node_ItemIndex_withText(struct TREE  *pTree,
                                                                  // []  [̸].
                                                                  char         *pNodeName,
                                                                  //˻ <text> ׸.
                                                                  char         *pItemText,
                                                                  //[/]   (true:).
                                                                  bool          pCase,
                                                                  // []  item-index.
                                                                  int          *rNodeItemindex,
                                                                  //<text>   itemindex.
                                                                  int          *rItemindex);

                //[2009.02.02.][Ϸ!!!]
                bool __fastcall _Tree_Delete_Item(struct TREE  *pTree,
                                                  // itemIndex.
                                                  int           pDeleteItemIndex);

                //[2009.04.01.][Ϸ!!!]
                bool __fastcall _Tree_Delete_AllSubItem(struct TREE  *pTree,
                                                        //  ׸ [] itemIndex.
                                                        int    pDeleteNodeIndex);

                //[2009.02.02.][Ϸ!!!]
                void __fastcall _Tree_Get_NodeIndex_of_ThisItem(struct TREE  *pTree,
                                                                // itemIndex.
                                                                int           pItemIndex,
                                                                // []  itemIndex.
                                                                int          *rNodeIndex);

                //[2009.05.31.][Ϸ!!!]
                void __fastcall _Tree_ExpandAll(//ó .
                                                int  pTreeIndex);

                //[2009.05.31.][Ϸ!!!]
                void __fastcall _Tree_CloseAll(//ó .
                                               int  pTreeIndex);

                //[2009.05.31.][Ϸ!!!]
                void __fastcall _Tree_ThisItemExpandAll(//ó .
                                                        int  pTreeIndex,
                                                        int  pItemIndex);

                //[2009.05.31.][Ϸ!!!]
                void __fastcall _Tree_ThisItemCloseAll(//ó .
                                                       int  pTreeIndex,
                                                       int  pItemIndex);

                //[2009.05.31.][Ϸ!!!]
                void __fastcall _Tree_ThisLevelExpandAll(//ó .
                                                         int  pTreeIndex,
                                                         int  pLevel);

                //[2009.05.31.][Ϸ!!!]
                void __fastcall _Tree_ThisLevelCloseAll(//ó .
                                                        int  pTreeIndex,
                                                        int  pLevel);

            //}

            //[2006.11.29.][Ϸ!!!]
            void __fastcall _Scroll_Set(void);

        //}

        //[ ]
        //{
            //[2009.04.20.][Ϸ!!!]
            void __fastcall _BACKBMP_Brightness(int  pBrightness);

            //[2009.04.20.][Ϸ!!!]
            void __fastcall _BACKBMP_ChangeJpeg(AnsiString  pJpegFilePath);

        //}



};
//---------------------------------------------------------------------------
extern PACKAGE TGTree_Form *GTree_Form;
//---------------------------------------------------------------------------
#endif
