
//[2009.04.13.][!!!]{--------------------------------------------------------------------
// [˵󱸵]  ſ Ǹ,  [˵]  ſ  ʴ´.
//ǰ [˵]     [Ĺ]  ϰ ִ.
//}--------------------------------------------------------------------------------------------


#ifndef gxcom_h
#define gxcom_h

//[  ]
//{
    //[!!!]{-------------------------------------------------------------------------------
    // [帧]  ϴ [MODE:0]  ⺻ [MODE:1]  
    //[MODE]    [ ]  .
    //  ȥ   и   ó Ҽִ.
    //̴ USB  []    [MODE]  ϴ Ͱ    ̴.
    //
    //[߿!!!]--------------------------------------------------------------------------------
    //[MODE]   ̰   [ɹ]   ù Byte   4Bit  ȴ.
    //Ϻϰ ̹Ƿ ó 1 Byte  ϰ [MODE]  Ͽ ó Ҽִ.
    //
    //[߿!!!]--------------------------------------------------------------------------------
    //[MODE:0]  [MODE:0] , [MODE:1]  [MODE:1]  Ѵ.
    //,  ϳ  Ʈó ϴ ̴.
    //}----------------------------------------------------------------------------------------

    //[MODE:0]{-------------------------------------------------------------------------
    //
    //[MODE:0]  ü  [帧]  Ͽ Ǹ <ACK>   óѴ.
    // 1Byte ũ⸦ Ƿ  MCU  ϰ óȴ.
    //[ڷ] κ 4Bit ũ⸦ Ƿ  [16 ]   Ҽִ.
    //
    //  |<--<8BIT>-->|
    //     4       4
    //{ [MODE:0][ڷ] }
    //
    //}---------------------------------------------------------------------------------

    //[MODE:1]{---------------------------------------------------------------------------------------------------------------------------
    //
    //[MODE:1]  Ϲ []   ܼϰ ⺻  ԰̴.
    // н  ſ Ǵ ⺻ .
    //[ũ]  10Bbit ̹Ƿ ִ 1024 Byte  Ѳ [/б] Ҽ ִ.
    //帧 [MODE:0]  óѴ.
    //
    //[]   |<--------<16BIT>--------->|                             |<---------<16BIT>-------->|
    //[BIT]      4       1     1     10     8                             4     1        1    10
    // <TXD> { [MODE:1][(A)/D][(W)/R][ũ][ּ] }                   { [MODE:1][A/(D)][(W)/R][ũ][(ũ Byte)] }
    // <RXD>                                        { [MODE:0][ACK] }                                                   { [MODE:0][ACK] }
    //                                                    4     4                                                            4      4
    //[б]
    //[BIT]      4       1     1     10     8                             4     1      1      10
    // <TXD> { [MODE:1][(A)/D][W/(R)][ũ][ּ] }
    // <RXD>                                        { [MODE:0][ACK] } { [MODE:1][A/(D)][W/(R)][ũ][(ũ Byte)] } { [MODE:0][ACK] }
    //                                                    4     4                                                            4      4
    // ܼϰ Ϻ ̴.
    //[/б]  []  Ϻϰ ϴ.
    //Ͱ ޴° ó 12BIT  [A/D]  ݴ̰  ϹǷ  CRC ó 밡ϴ.
    //12BIT κ XOR  ϸ [A/D] Ʈ 1 ̸     ִ.
    //
    //[ Ʈ ]--------------------------------------------------------------------------------------------------------------------
    //
    //[BIT]  15 :  12    11       10     9  :   0
    //[   ]  [ MODE ]  [ A/D ]  [ W/R ]  [ ũ ]
    //
    //}-----------------------------------------------------------------------------------------------------------------------------------

    //[źƮ ]
    //{
        //[16 Bit  ]
        //{
            //[Ʈ ġ ]
            #define  d_GxCom_M1_Hdr_Bit_Mode        12
            #define  d_GxCom_M1_Hdr_Bit_AdrData     11
            #define  d_GxCom_M1_Hdr_Bit_WrRd        10
            #define  d_GxCom_M1_Hdr_Bit_Size        0

            //[Ʈ Ⱚ ]
            #define  d_GxCom_M1_Hdr_Mask_Mode       0x0f  //4  Bit
            #define  d_GxCom_M1_Hdr_Mask_AdrData    0x01  //1  Bit
            #define  d_GxCom_M1_Hdr_Mask_WrRd       0x01  //1  Bit
            #define  d_GxCom_M1_Hdr_Mask_Size       0x3ff //10 Bit

        //}

        //[Ʈ  ]
        //{
            // MODE0, MODE1  Ѵ.
            #define  d_GxCom_Mode_0     0x00  //[帧]   .
            #define  d_GxCom_Mode_1     0x01  // ⺻ [].
            #define  d_GxCom_Mode_2     0x02  //[]  .

            #define  d_GxCom_M1_Adr     0
            #define  d_GxCom_M1_Data    1

            #define  d_GxCom_M1_Wr      0
            #define  d_GxCom_M1_Rd      1

        //}

        //[MODE:0  ]
        //{
            //[!]{--------------------------------------------------------
            //[MODE:0]  ϴ [帧]  Ѵ.
            // 4Bit  Ǹ  [16 ]   Ҽ ִ.
            //
            //{ [MODE:0] [MSG] }  1 Byte  ȴ.
            //}-----------------------------------------------------------

            #define  d_GxCom_M0_Ack        0x01  //̻.
            #define  d_GxCom_M0_Rpt        0x02  //ۿ䱸.

            //⺻  ߰ [˸]  Ѵ.

        //}

        //[MODE:2  ]
        //{
            //[!]{-------------------------------------------------------------
            //[MODE:2]  ϴ [˸]  Ѵ.
            // 4Bit  Ǹ  [16 ]  [˸]  Ҽ ִ.
            //
            //{ [MODE:2] [MSG] }  1 Byte  ȴ.
            //}----------------------------------------------------------------

            #define  d_GxCom_M2_Break      0x0b  // .

            #define  d_GxCom_M2_Error      0x0e  // .



            //⺻  ߰ [˸]  Ѵ.

        //}

    //}

//}

//------------------------------------------------------------------------------
//[MODE:0]----------------------------------------------------------------------
//------------------------------------------------------------------------------

//[2009.04.13.][Ϸ!!!]
void __fastcall GxCom_M0_Encode(//  ġ.
                                unsigned char  *rPacketBuf,
                                unsigned char   pMsg);

//[2009.04.13.][Ϸ!!!]
int __fastcall GxCom_M0_AckWrite(//[  ] ġ.
                                 unsigned char  *rPacketBuf);

//[2009.04.13.][Ϸ!!!]
bool __fastcall GxCom_M0_AckRead(//[  ] ġ.
                                 unsigned char  *pPacketBuf);

//------------------------------------------------------------------------------
//[MODE:1]----------------------------------------------------------------------
//------------------------------------------------------------------------------

//[2009.04.13.][Ϸ!!!]
void __fastcall GxCom_M1_Hdr_Encode(//[]    ġ.
                                    unsigned char   *rHdr,
                                    //[]  ռ .
                                    unsigned char    pAdrData,
                                    unsigned char    pWrRd,
                                    unsigned short   pSize);

//[2009.04.14.ȭ][Ϸ!!!]
void __fastcall GxCom_M1_Hdr_Decode(//[]  ִ һ ġ.
                                    unsigned char   *pHdr,
                                    //[]  йȯ .
                                    //NULL ƴ 츸 ȯѴ
                                    unsigned char   *rAdrData,
                                    unsigned char   *rWrRd,
                                    unsigned short  *rSize);

//[2009.04.13.][Ϸ!!!]
void __fastcall GxCom_M1_AdrPacket(//[ּŹ]    ġ.
                                   unsigned char  *rPacketBuf,
                                   //[/б] .
                                   unsigned char   pWrRd,
                                   //[/б] ũ.
                                   unsigned short  pSize,
                                   //[ּ] .
                                   unsigned char   pAdr);

//[2009.04.14.ȭ][Ϸ!!!]
void __fastcall GxCom_M1_AdrPacket_Decode(//[ּŹ]    ġ.
                                          unsigned char   *pPacketBuf,
                                          //[]  йȯ .
                                          //NULL ƴ 츸 ȯѴ
                                          unsigned char   *rWrRd,
                                          unsigned short  *rSize,
                                          unsigned char   *rAdr);

//[2009.04.13.][Ϸ!!!]
int __fastcall GxCom_M1_DataPacket_Write(//[ڷŹ]    ġ.
                                         unsigned char  *rPacketBuf,
                                         //[/б] ũ.
                                         unsigned short  pSize,
                                         // ڷġ.
                                         unsigned char  *pStream);

//[2009.04.13.][Ϸ!!!]
void __fastcall GxCom_M1_DataPacket_Read(//[ڷŹ]   ִ ġ.
                                         unsigned char  *pPacketBuf,
                                         //о ڷḦ  ġ.
                                         unsigned char  *rStream);

//[2009.04.13.][Ϸ!!!]
bool __fastcall GxCom_M1_Is_AdrPacket(//[Ź]   ִ ġ.
                                      unsigned char  *pPacketBuf);

//[2009.04.13.][Ϸ!!!]
bool __fastcall GxCom_M1_Is_DataPacket(//[Ź]   ִ ġ.
                                       unsigned char  *pPacketBuf);

//------------------------------------------------------------------------------
//[MODE:2]----------------------------------------------------------------------
//------------------------------------------------------------------------------

//[2009.04.18.][Ϸ!!!]
void __fastcall GxCom_M2_Encode(//  ġ.
                                unsigned char  *rPacketBuf,
                                unsigned char   pMsg);

//[2009.04.18.][Ϸ!!!]
int __fastcall GxCom_M2_BreakWrite(//[  ] ġ.
                                   unsigned char  *rPacketBuf);

//[2009.04.18.][Ϸ!!!]
bool __fastcall GxCom_M2_BreakRead(//[  ] ġ.
                                   unsigned char  *pPacketBuf);

//[2009.05.10.][Ϸ!!!]
int __fastcall GxCom_M2_ErrorWrite(//[  ] ġ.
                                   unsigned char  *rPacketBuf);

//[2009.05.10.][Ϸ!!!]
bool __fastcall GxCom_M2_ErrorRead(//[  ] ġ.
                                   unsigned char  *pPacketBuf);





#endif



