
#include <vcl.h>
#pragma hdrstop

#include "gui.h"

#include <jpeg.hpp>

#include "..\gui_part.h"

//[2021.03.26.][߰]
#include "ide_library.h"


//[!!!]
//{
    //-------------------------------------------------------
    //Bitmap ó Լ  24bit-Bitmap   Ѵ.
    //-------------------------------------------------------
//}


void __fastcall BMP_Dot(Graphics::TBitmap *pBITMAP,
                        int                pX,
                        int                pY,
                        int                pCOLOR)
{
  //[2006.10.26.][!!!]{--------------------
  //bitmap   ġ    ´.
  //}--------------------------------------------

  //[VAR]
  //{
      RGBTRIPLE  *lineptr;
  //}

  //׸ ȿ  ̷  Ѵ.
  if(((0 <= pX) && ( pX < pBITMAP->Width)) &&
     ((0 <= pY) && ( pY < pBITMAP->Height)))
  {
    //{-------------------------------------------
    //[]  pointer  ´.
    lineptr = (RGBTRIPLE *)pBITMAP->ScanLine[pY];
    //}-------------------------------------------

    //  ĥѴ.
    lineptr[pX].rgbtBlue   = (pCOLOR>>16)&0xff;
    lineptr[pX].rgbtGreen  = (pCOLOR>> 8)&0xff;
    lineptr[pX].rgbtRed    = (pCOLOR>> 0)&0xff;
  }
  
  return;

}

int __fastcall BMP_GetDot(Graphics::TBitmap *pBITMAP,
                          int                pX,
                          int                pY)
{
  //[2010.02.21.][!!!]{-------------------------
  //bitmap   ġ  Ͽ ȯѴ.
  //}-------------------------------------------------

  //[VAR]
  //{
      RGBTRIPLE  *lineptr;

  //}

  //׸ ȿ  ̷  Ѵ.
  if(((0 <= pX) && ( pX < pBITMAP->Width)) &&
     ((0 <= pY) && ( pY < pBITMAP->Height)))
  {
    //{-------------------------------------------
    //[]  pointer  ´.
    lineptr = (RGBTRIPLE *)pBITMAP->ScanLine[pY];
    //}-------------------------------------------

    return(((lineptr[pX].rgbtBlue  << 16) |
            (lineptr[pX].rgbtGreen << 8)  |
            (lineptr[pX].rgbtRed)) &
            0x00ffffff);

  }

  //   []  ȯѴ.
  return(clWhite);

}

void __fastcall BMP_Paint(Graphics::TBitmap *pBITMAP,
                          int                pCOLOR)
{
  //[2006.09.04.][!!!]{------------------------
  // bitmap  ü  []  ĥѴ.
  //}------------------------------------------------

  //[]
  //{
      //Canvas->FillRect()  ϴ ͺ ӵ .
      //̴    ó ϱ ΰ .
      //  Լ Ư 뵵 ƴ϶  ʴ´.
  //}


  //[VAR]
  //{
      int         x, y;

      RGBTRIPLE  *lineptr;
  //}


  for(y = 0; y < pBITMAP->Height; y++)
  {
    //{------------------------------------------
    //[]  pointer  ´.
    lineptr = (RGBTRIPLE *)pBITMAP->ScanLine[y];
    //}------------------------------------------

    for(x = 0 ; x < pBITMAP->Width; x++)
    {
      //  ĥѴ.
      lineptr[x].rgbtBlue   = (pCOLOR>>16)&0xff;
      lineptr[x].rgbtGreen  = (pCOLOR>> 8)&0xff;
      lineptr[x].rgbtRed    = (pCOLOR>> 0)&0xff;

    }
  }

  return;

}

void __fastcall BMP_Brightness(Graphics::TBitmap *pBITMAP,
                               int                pBRIGHT)
{
  //[2006.11.02.][!!!]{------------------------------------------
  //޵ bmp  ⸦ Ѵ.
  //
  //[2018.08.07.ȭ][!!!]-------------------------------------------
  //<pBRIGHT:>   [Ӱ]  2  ϵ .
  //,   <-255:255> .
  //  Ѵ   ʴ´.
  //}------------------------------------------------------------------

  //[VAR]
  //{
      RGBTRIPLE  *line_ptr;

      int         x, y;
      
  //}

  //[  ˻]
  //{
      //[2018.08.08.][߰!!!]{-------------------------------------------
      //{ -255 <=  <= 255 }  ش ʴ   ʰ .
      //}-------------------------------------------------------------------

      if(!((-255 <= pBRIGHT) && (pBRIGHT <= 255))) return;

  //}

  for(y = 0; y < pBITMAP->Height; y++)
  {
    //[line_ptr]{---------------------------------
    //[]  pointer  ´.
    line_ptr = (RGBTRIPLE *)pBITMAP->ScanLine[y];
    //}-------------------------------------------

    for(x = 0; x < pBITMAP->Width; x++)
    {
      if(pBRIGHT >= 0)
      {
        //ū ϼ  .

        //[]{------------------------------------------------------------------------------------
        line_ptr[x].rgbtBlue  = line_ptr[x].rgbtBlue  + ((255 - line_ptr[x].rgbtBlue)  * pBRIGHT) / 255;
        line_ptr[x].rgbtGreen = line_ptr[x].rgbtGreen + ((255 - line_ptr[x].rgbtGreen) * pBRIGHT) / 255;
        line_ptr[x].rgbtRed   = line_ptr[x].rgbtRed   + ((255 - line_ptr[x].rgbtRed)   * pBRIGHT) / 255;
        //}----------------------------------------------------------------------------------------------

      }
      else
      {
        //ū ϼ  Ӵ.

        //[ӱ]{-------------------------------------------------------------------------------
        line_ptr[x].rgbtBlue  = line_ptr[x].rgbtBlue  - ((line_ptr[x].rgbtBlue)  * (-pBRIGHT)) / 255;
        line_ptr[x].rgbtGreen = line_ptr[x].rgbtGreen - ((line_ptr[x].rgbtGreen) * (-pBRIGHT)) / 255;
        line_ptr[x].rgbtRed   = line_ptr[x].rgbtRed   - ((line_ptr[x].rgbtRed)   * (-pBRIGHT)) / 255;
        //}-------------------------------------------------------------------------------------------

      }

    }

  }

}

void __fastcall BMP_Get_Bright_Color(int   pCOLOR,
                                     int   pBRIGHT,
                                     int  *rBRIGHTcolor)
{
  //[2006.12.05.ȭ][!!!]{-------------------------------------------------
  //޵    Ͽ ٽ  ȯѴ.
  //
  //[2018.08.10.][!!!]**************************************************
  //<BMP_Brightness()>   []  [(Ӱ)]  ϵ .
  //<pBRIGHT:>   [Ӱ]  2  ϵ .
  //,   <-255:255> .
  //  Ѵ   ʴ´.
  //}-------------------------------------------------------------------------

  //[VAR]
  //{
      RGBTRIPLE  pcolor,
                 mcolor;

      int        color;

  //}

  //[  ˻]
  //{
      //[2018.08.08.][߰!!!]{-------------------------------------------
      //{ -255 <=  <= 255 }  ش ʴ   ʰ .
      //}-------------------------------------------------------------------

      if(!((-255 <= pBRIGHT) && (pBRIGHT <= 255))) return;

  //}

  //[]
  //{
      pcolor.rgbtBlue   = (pCOLOR>>16)&0xff;
      pcolor.rgbtGreen  = (pCOLOR>> 8)&0xff;
      pcolor.rgbtRed    = (pCOLOR>> 0)&0xff;
      
  //}

  //[ ]
  //{
      if(pBRIGHT >= 0)
      {
        //ū ϼ  .

        mcolor.rgbtBlue  = pcolor.rgbtBlue  + ((255 - pcolor.rgbtBlue)  * pBRIGHT) / 255;
        mcolor.rgbtGreen = pcolor.rgbtGreen + ((255 - pcolor.rgbtGreen) * pBRIGHT) / 255;
        mcolor.rgbtRed   = pcolor.rgbtRed   + ((255 - pcolor.rgbtRed)   * pBRIGHT) / 255;

      }
      else
      {
        //ū ϼ  Ӵ.

        mcolor.rgbtBlue  = pcolor.rgbtBlue  - ((pcolor.rgbtBlue)  * (-pBRIGHT)) / 255;
        mcolor.rgbtGreen = pcolor.rgbtGreen - ((pcolor.rgbtGreen) * (-pBRIGHT)) / 255;
        mcolor.rgbtRed   = pcolor.rgbtRed   - ((pcolor.rgbtRed)   * (-pBRIGHT)) / 255;

      }

  //}

  //[ռ]
  //{
      color = ((int)(mcolor.rgbtBlue)  << 16) |
              ((int)(mcolor.rgbtGreen) <<  8) |
              ((int)(mcolor.rgbtRed)   <<  0);

  //}

  //[ȯ]
  //{
      (*rBRIGHTcolor) = color;

  //}

}

int __fastcall Bmp_Color_Enable(int   pColor,
                                bool  pEnable)
{
  //[2018.08.23.][!!!]{---------------------------------------------
  //<pEnable>   <pColor>   [/ȿ]  .
  //[׸ǰ]  [/ȿ] ο  ٸ · ׷ֱ Ͽ ʿ.
  //
  //<pEnable:true>  : <pColor> ״ ȯ.
  //<pEnable:false> : <pColor>  [ȿ]  Ͽ ȯ.
  //}---------------------------------------------------------------------

  if(pEnable == true)
  {
    //[ȿ]   ״ ȯ.
    return(pColor);

  }
  else
  {
    //[ȿ]   [ȿ()]  ؼ ȯ.
    BMP_Get_Bright_Color(pColor, d_Bright_Disable, &pColor);

    return(pColor);

  }
  
}

void __fastcall BMP_Load(Graphics::TBitmap *pBITMAP,
                         AnsiString         pBMPname,
                         //0  ȿ.
                         int                pSETwidth,
                         //0  ȿ.
                         int                pSETheight,
                         int                pOPTION)
{
  //[2006.11.04.][!!!]{-----------------------------------
  // []  bitmap  оε ó  Ѵ.
  //}-----------------------------------------------------------

  //[VAR]
  //{
      int  width;
      int  height;

      int  x, y;
  //}

  //[bmp load]
  //{
      //׸ о δ.
      pBITMAP->LoadFromFile(pBMPname);

      // ׸ ũ  ´.
      width  = pBITMAP->Width;
      height = pBITMAP->Height;
  //}

  //[ ũ ]
  //{
      //ũⰡ   ٽ bmp   ũ⿡ .
      //,  ũⰡ 0    ʴ´.
      if(pSETwidth != 0)  { pBITMAP->Width  = pSETwidth;  }
      if(pSETheight != 0) { pBITMAP->Height = pSETheight; }
  //}

  //[option]
  //{
      //option  
      switch(pOPTION)
      {
        case  d_BMP_load_left_top :
        {
          //̹ LoadFromFile  о ̸鼭 []  ĵ ̴.
          //ó ʴ´.

        } break;

        case  d_BMP_load_tile :
        {
          //ٵǽ ġѴ.
          for(y = 0; y < pBITMAP->Height; y += height)
          {
            for(x = 0; x < pBITMAP->Width ; x += width)
            {
              //̹ Load   ̹ copy Ͽ ٸ  Ѵ.
              BitBlt(// .
                     pBITMAP->Canvas->Handle, x, y, width, height,
                     //ҽ .
                     pBITMAP->Canvas->Handle, 0, 0,
                     SRCCOPY);

            }

          }

        } break;

      }
  //}

  return;

}

void __fastcall BMP_LoadJpeg(//о  Jpeg ׸ ÷  Ʈ.
                             Graphics::TBitmap *pBITMAP,
                             AnsiString         pJpegFileName,
                             //0  ȿ.
                             int                pSETwidth,
                             //0  ȿ.
                             int                pSETheight,
                             int                pOPTION)
{
  //[2007.12.01.][!!!]{-----------------------------------------------------
  //BMP_Load() Լ Ͽ bmp  ƴ϶ jpeg  о 鿩
  // [Ʈ]  ÷ ִ Լ  Ͽ.
  //̴ [Ʈ]   伥 ϰ   BCB  о϶
  // ߻ϴ 찡 ֱ ̴.
  //}-----------------------------------------------------------------------------

  //[VAR]
  //{
      int  width;
      int  height;

      int  x, y;

      //[2007.12.01.][߰!!!]
      //о  jpeg ׸ .
      TJPEGImage *jpegFile = new TJPEGImage();

  //}

  //[Jpeg ׸ б]
  //{
      // jpeg ׸ о δ.
      jpegFile->LoadFromFile(pJpegFileName);

      //jpeg ׸ [Ʈ]  ȯѴ.
      pBITMAP->Assign(jpegFile);

      // jpeg ü Ѵ.
      if(jpegFile != NULL) { delete jpegFile; jpegFile = NULL; }

      // ׸ ũ  ´.
      width  = pBITMAP->Width;
      height = pBITMAP->Height;

  //}

  //[ ũ ]
  //{
      //ũⰡ   ٽ bmp   ũ⿡ .
      //,  ũⰡ 0    ʴ´.
      if(pSETwidth != 0)  { pBITMAP->Width  = pSETwidth;  }
      if(pSETheight != 0) { pBITMAP->Height = pSETheight; }

  //}

  //[option]
  //{
      //option  
      switch(pOPTION)
      {
        case  d_BMP_load_left_top :
        {
          //̹ LoadFromFile  о ̸鼭 []  ĵ ̴.
          //ó ʴ´.

        } break;

        case  d_BMP_load_tile :
        {
          //ٵǽ ġѴ.
          for(y = 0; y < pBITMAP->Height; y += height)
          {
            for(x = 0; x < pBITMAP->Width ; x += width)
            {
              //̹ Load   ̹ copy Ͽ ٸ  Ѵ.
              BitBlt(// .
                     pBITMAP->Canvas->Handle, x, y, width, height,
                     //ҽ .
                     pBITMAP->Canvas->Handle, 0, 0,
                     SRCCOPY);

            }

          }

        } break;

      }

  //}

}

void __fastcall BMP_Copy_Transparent(// .
                                     Graphics::TBitmap *pBMPsrc,
                                     int                pXsrc,
                                     int                pYsrc,
                                     int                pWIDTHsrc,
                                     int                pHEIGHTsrc,
                                     // .
                                     Graphics::TBitmap *pBMPdst,
                                     int                pXdst,
                                     int                pYdst,
                                     int                pWIDTHdst,
                                     int                pHEIGHTdst,
                                     //  .
                                     int                pTRANSPARENTcolor)
{
  //[2006.11.16.][!!!]{-------------------------
  //Ʈ ϵ,    ϰ,
  //    ʴ´.
  //}-------------------------------------------------

  //[VAR]
  //{
      DWORD    copy_option = SRCCOPY;
  //}

  //[VAR]
  //{
      int         x_src, y_src,
                  x_dst, y_dst;

      RGBTRIPLE  *lineptr_src,
                 *lineptr_dst;

      int         color;
  //}

  //[׸ ]
  //{
      for(y_src = pYsrc, y_dst = pYdst;
          // Ѿ  ߻ ʰѴ.
          ((pYsrc <= y_src) && (y_src < (pYsrc + pHEIGHTsrc))) &&
          ((pYdst <= y_dst) && (y_dst < (pYdst + pHEIGHTdst))) &&
          ((0 <= y_dst)     && (y_dst < pBMPdst->Height));
          y_src++, y_dst++)
      {
        //[ ڵ ]{------------------------------------
        //[]  pointer  ´.
        lineptr_src = (RGBTRIPLE *)pBMPsrc->ScanLine[y_src];
        lineptr_dst = (RGBTRIPLE *)pBMPdst->ScanLine[y_dst];
        //}--------------------------------------------------

        for(x_src = pXsrc, x_dst = pXdst;
            // Ѿ  ߻ ʰѴ.
            ((pXsrc <= x_src) && (x_src < (pXsrc + pWIDTHsrc))) &&
            ((pXdst <= x_dst) && (x_dst < (pXdst + pWIDTHdst))) &&
            ((0 <= x_dst)     && (x_dst < pBMPdst->Width));
            x_src++, x_dst++)
        {
          //[color]
          //{
              color = ((int)(lineptr_src[x_src].rgbtBlue)  << 16) |
                      ((int)(lineptr_src[x_src].rgbtGreen) <<  8) |
                      ((int)(lineptr_src[x_src].rgbtRed)   <<  0);
          //}

          //[ ˻]
          //{
              //    ˻Ѵ.
              if(color == pTRANSPARENTcolor)
              {
                //  ʴ´.

              }
              else
              {
                //  ʴ  Ѵ.
                lineptr_dst[x_dst].rgbtBlue  = (color >> 16) & 0xff;
                lineptr_dst[x_dst].rgbtGreen = (color >>  8) & 0xff;
                lineptr_dst[x_dst].rgbtRed   = (color >>  0) & 0xff;

              }
          //}

        }

      }
  //}

  return;

}

void __fastcall BMP_OneColor_CopyAndChange(// .
                                           Graphics::TBitmap *pBMPsrc,
                                           int                pXsrc,
                                           int                pYsrc,
                                           int                pWIDTHsrc,
                                           int                pHEIGHTsrc,
                                           // .
                                           Graphics::TBitmap *pBMPdst,
                                           int                pXdst,
                                           int                pYdst,
                                           int                pWIDTHdst,
                                           int                pHEIGHTdst,
                                           //ϰ ٲ .
                                           int                pThisColor,
                                           //ٲ .
                                           int                pChangeColor)
{
  //[2007.12.20.][!!!]{----------------------------------------------
  //Ʈ ϵ,    ϰ,
  //Ư ϵ  ٲٴ ͵ ÿ Ѵ.
  //
  //[2012.07.14.][!!!]-----------------------------------------------
  //<pXdst>, <pXdst>  []    ƿ ó ȵǴ .
  //}----------------------------------------------------------------------

  //[VAR]
  //{
      DWORD    copy_option = SRCCOPY;
  //}

  //[VAR]
  //{
      int         x_src, y_src,
                  x_dst, y_dst;

      RGBTRIPLE  *lineptr_src,
                 *lineptr_dst;

      int         color;
  //}

  //[׸ ]
  //{
      //[   ó]
      //{
          //[2012.07.14.][߰!!!]{--------------------------------------------
          //[]  []    <for()> 
          //[ȿ]  ƴ϶ ƿ ƹ͵ ó ʰ ȴ.
          //, []   [ȿ]    .
          //, [] κ ŭ []    ġ  .
          //}--------------------------------------------------------------------

          if(pXdst < 0) { pXsrc -= pXdst; pWIDTHsrc  += pXdst; pXdst = 0; }
          if(pYdst < 0) { pYsrc -= pYdst; pHEIGHTdst += pYdst; pYdst = 0; }

      //}

      for(y_src = pYsrc, y_dst = pYdst;
          // Ѿ  ߻ ʰѴ.
          ((pYsrc <= y_src) && (y_src < (pYsrc + pHEIGHTsrc))) &&
          ((pYdst <= y_dst) && (y_dst < (pYdst + pHEIGHTdst))) &&
          ((0 <= y_dst)     && (y_dst < pBMPdst->Height));
          y_src++, y_dst++)
      {
        //[ ڵ ]{------------------------------------
        //[]  pointer  ´.
        lineptr_src = (RGBTRIPLE *)pBMPsrc->ScanLine[y_src];
        lineptr_dst = (RGBTRIPLE *)pBMPdst->ScanLine[y_dst];
        //}--------------------------------------------------

        for(x_src = pXsrc, x_dst = pXdst;
            // Ѿ  ߻ ʰѴ.
            ((pXsrc <= x_src) && (x_src < (pXsrc + pWIDTHsrc))) &&
            ((pXdst <= x_dst) && (x_dst < (pXdst + pWIDTHdst))) &&
            ((0 <= x_dst)     && (x_dst < pBMPdst->Width));
            x_src++, x_dst++)
        {
          //[color]
          //{
              color = ((int)(lineptr_src[x_src].rgbtBlue)  << 16) |
                      ((int)(lineptr_src[x_src].rgbtGreen) <<  8) |
                      ((int)(lineptr_src[x_src].rgbtRed)   <<  0);
          //}

          //[ ˻]
          //{
              //    ˻Ѵ.
              if(color == pThisColor)
              {
                //  ٲܻ ٲپ Ѵ.
                color = pChangeColor;

                lineptr_dst[x_dst].rgbtBlue  = (color >> 16) & 0xff;
                lineptr_dst[x_dst].rgbtGreen = (color >>  8) & 0xff;
                lineptr_dst[x_dst].rgbtRed   = (color >>  0) & 0xff;

              }
              else
              {
                // ƴ   ʴ´.

              }

          //}

        }

      }

  //}

  return;

}

/*
void __fastcall BMP_OneColor_CopyAndChange(// .
                                           Graphics::TBitmap *pBMPsrc,
                                           int                pXsrc,
                                           int                pYsrc,
                                           int                pWIDTHsrc,
                                           int                pHEIGHTsrc,
                                           // .
                                           Graphics::TBitmap *pBMPdst,
                                           int                pXdst,
                                           int                pYdst,
                                           int                pWIDTHdst,
                                           int                pHEIGHTdst,
                                           //ϰ ٲ .
                                           int                pThisColor,
                                           //ٲ .
                                           int                pChangeColor)
{
  //[2007.12.20.][!!!]{---------------------------------
  //Ʈ ϵ,    ϰ,
  //Ư ϵ  ٲٴ ͵ ÿ Ѵ.
  //}---------------------------------------------------------

  //[VAR]
  //{
      DWORD    copy_option = SRCCOPY;
  //}

  //[VAR]
  //{
      int         x_src, y_src,
                  x_dst, y_dst;

      RGBTRIPLE  *lineptr_src,
                 *lineptr_dst;

      int         color;
  //}

  //[׸ ]
  //{
      if(pYdst < 0) { pYdst = 0; pYsrc -= pYdst; pWIDTHsrc += pYdst; }

      for(y_src = pYsrc, y_dst = pYdst;
          // Ѿ  ߻ ʰѴ.
          ((pYsrc <= y_src) && (y_src < (pYsrc + pHEIGHTsrc))) &&
          ((pYdst <= y_dst) && (y_dst < (pYdst + pHEIGHTdst))) &&
          ((0 <= y_dst)     && (y_dst < pBMPdst->Height));
          y_src++, y_dst++)
      {
        //[ ڵ ]{------------------------------------
        //[]  pointer  ´.
        lineptr_src = (RGBTRIPLE *)pBMPsrc->ScanLine[y_src];
        lineptr_dst = (RGBTRIPLE *)pBMPdst->ScanLine[y_dst];
        //}--------------------------------------------------

        for(x_src = pXsrc, x_dst = pXdst;
            // Ѿ  ߻ ʰѴ.
            ((pXsrc <= x_src) && (x_src < (pXsrc + pWIDTHsrc))) &&
            ((pXdst <= x_dst) && (x_dst < (pXdst + pWIDTHdst))) &&
            ((0 <= x_dst)     && (x_dst < pBMPdst->Width));
            x_src++, x_dst++)
        {
          //[color]
          //{
              color = ((int)(lineptr_src[x_src].rgbtBlue)  << 16) |
                      ((int)(lineptr_src[x_src].rgbtGreen) <<  8) |
                      ((int)(lineptr_src[x_src].rgbtRed)   <<  0);
          //}

          //[ ˻]
          //{
              //    ˻Ѵ.
              if(color == pThisColor)
              {
                //  ٲܻ ٲپ Ѵ.
                color = pChangeColor;

                lineptr_dst[x_dst].rgbtBlue  = (color >> 16) & 0xff;
                lineptr_dst[x_dst].rgbtGreen = (color >>  8) & 0xff;
                lineptr_dst[x_dst].rgbtRed   = (color >>  0) & 0xff;

              }
              else
              {
                // ƴ   ʴ´.

              }

          //}

        }

      }

  //}

  return;

}
*/

void __fastcall BMP_Copy_ChangeColor(// .
                                     Graphics::TBitmap *pBMPsrc,
                                     int                pXsrc,
                                     int                pYsrc,
                                     int                pWIDTHsrc,
                                     int                pHEIGHTsrc,
                                     // .
                                     Graphics::TBitmap *pBMPdst,
                                     int                pXdst,
                                     int                pYdst,
                                     int                pWIDTHdst,
                                     int                pHEIGHTdst,
                                     //ȯ ̵Ǵ .
                                     int                pORGINcolor,
                                     //ȯ .
                                     int                pCHANGEcolor)
{
  //[2006.11.09.][!!!]{-------------------------
  //Ʈ ϵ,    ϰ,
  //縦 Ҽ ֵѴ.
  // ϸ鼭 Ư  ȯѴ.
  //}-------------------------------------------------

  //[VAR]
  //{
      int         x_src, y_src,
                  x_dst, y_dst;

      RGBTRIPLE  *lineptr_src,
                 *lineptr_dst;

      int         color;
  //}

  //[׸ ]
  //{
      for(y_src = pYsrc, y_dst = pYdst;
          // Ѿ  ߻ ʰѴ.
          ((pYsrc <= y_src) && (y_src < (pYsrc + pHEIGHTsrc))) &&
          ((pYdst <= y_dst) && (y_dst < (pYdst + pHEIGHTdst))) &&
          ((0 <= y_dst)     && (y_dst < pBMPdst->Height));
          y_src++, y_dst++)
      {
        //[ ڵ ]{------------------------------------
        //[]  pointer  ´.
        lineptr_src = (RGBTRIPLE *)pBMPsrc->ScanLine[y_src];
        lineptr_dst = (RGBTRIPLE *)pBMPdst->ScanLine[y_dst];
        //}--------------------------------------------------

        for(x_src = pXsrc, x_dst = pXdst;
            // Ѿ  ߻ ʰѴ.
            ((pXsrc <= x_src) && (x_src < (pXsrc + pWIDTHsrc))) &&
            ((pXdst <= x_dst) && (x_dst < (pXdst + pWIDTHdst))) &&
            ((0 <= x_dst)     && (x_dst < pBMPdst->Width));
            x_src++, x_dst++)
        {
          //[color]
          //{
              color = ((int)(lineptr_src[x_src].rgbtBlue)  << 16) |
                      ((int)(lineptr_src[x_src].rgbtGreen) <<  8) |
                      ((int)(lineptr_src[x_src].rgbtRed)   <<  0);
          //}

          //[ȯ ˻]
          //{
              //  ȯ  Ǵ  ˻Ѵ.
              if(color == pORGINcolor)
              {
                // ȯ  ٲ۴.
                color = pCHANGEcolor;

              }
          //}

          //[ ]
          //{
              lineptr_dst[x_dst].rgbtBlue  = (color >> 16) & 0xff;
              lineptr_dst[x_dst].rgbtGreen = (color >>  8) & 0xff;
              lineptr_dst[x_dst].rgbtRed   = (color >>  0) & 0xff;
          //}
        }
      }
  //}

  return;

}

void __fastcall BMP_Self_ChangeColor2(Graphics::TBitmap *pBITMAP,
                                     int                 pFcolor,
                                     int                 pFCcolor,
                                     int                 pBcolor,
                                     int                 pBCcolor)
{
  //[2006.11.12.][!!!]{---------------------------------------
  //޹ bipmap   2   ȯ  ٲ۴.
  //}---------------------------------------------------------------

  //[VAR]
  //{
      int         x, y;

      RGBTRIPLE  *lineptr;

      int         color;
  //}

  //[׸ ]
  //{
      for(y = 0;
          // Ѿ  ߻ ʰѴ.
          (0 <= y) && (y < pBITMAP->Height);
          y++)
      {
        //[ ڵ ]{----------------------------
        //[]  pointer  ´.
        lineptr = (RGBTRIPLE *)pBITMAP->ScanLine[y];
        //}------------------------------------------

        for(x = 0;
            // Ѿ  ߻ ʰѴ.
            (0 <= x) && (x < pBITMAP->Width);
            x++)
        {
          //[ ]
          //{
              color = ((int)(lineptr[x].rgbtBlue)  << 16) |
                      ((int)(lineptr[x].rgbtGreen) <<  8) |
                      ((int)(lineptr[x].rgbtRed)   <<  0);
          //}

          //[ ]
          //{
              if     (color == pFcolor)
              {
                //ش  ٲ۴.
                color = pFCcolor;

              }
              else if(color == pBcolor)
              {
                //ش  ٲ۴.
                color = pBCcolor;

              }
          //}

          //[ٽ  ]
          //{
              lineptr[x].rgbtBlue  = (color >> 16) & 0xff;
              lineptr[x].rgbtGreen = (color >>  8) & 0xff;
              lineptr[x].rgbtRed   = (color >>  0) & 0xff;
          //}
        }
      }
  //}

  return;

}

void __fastcall Bmp_Area_ChangeColor_2(Graphics::TBitmap *pBmp,
                                       //[]----------------
                                       int                pX,
                                       int                pY,
                                       int                pWidth,
                                       int                pHeight,
                                       //[ȯ]--------------
                                       int                pClrOrg1,
                                       int                pClrChg1,
                                       int                pClrOrg2,
                                       int                pClrChg2)
{
  //[2011.06.29.][!!!]{-----------------------------------
  // BMP    ΰ  ش.
  //}-----------------------------------------------------------

  //[VAR]
  //{
      int         x, y;

      RGBTRIPLE  *lineptr;

      int         color;
  //}

  //[׸ ]
  //{
      for(y = pY;
          // Ѿ  ߻ ʰѴ.
          (pY <= y) && (y < (pY + pHeight));
          y++)
      {
        //[ ڵ ]{-------------------------
        //[]  pointer  ´.
        lineptr = (RGBTRIPLE *)pBmp->ScanLine[y];
        //}---------------------------------------

        for(x = pX;
            // Ѿ  ߻ ʰѴ.
            (pX <= x) && (x < (pX + pWidth));
            x++)
        {
          //[ ]
          //{
              color = ((int)(lineptr[x].rgbtBlue)  << 16) |
                      ((int)(lineptr[x].rgbtGreen) <<  8) |
                      ((int)(lineptr[x].rgbtRed)   <<  0);
          //}

          //[ ]
          //{
              if     (color == pClrOrg1)
              {
                //ش  ٲ۴.
                color = pClrChg1;

              }
              else if(color == pClrOrg2)
              {
                //ش  ٲ۴.
                color = pClrChg2;

              }
          //}

          //[ٽ  ]
          //{
              lineptr[x].rgbtBlue  = (color >> 16) & 0xff;
              lineptr[x].rgbtGreen = (color >>  8) & 0xff;
              lineptr[x].rgbtRed   = (color >>  0) & 0xff;
          //}
        }
      }
  //}

  return;

}

void __fastcall _Bmp_Create_And_Load(Graphics::TBitmap **pBmp,
                                     AnsiString          pBmpFileName)
{
  //[2011.06.25.][!!!]{------------------------------------------
  //<bmp>  ϰ   ׸ оδ.
  //⼭ <bmp>  ϹǷ **ͷ  ޾Ƽ óؾ Ѵ.
  //
  // Լ <editor_edit.cpp:_DbgView_Shape()> Լ Ͽ .
  //}------------------------------------------------------------------

  // ׸  Ѵ.
  (*pBmp) = new Graphics::TBitmap;

  //׸ о ̱.
  (*pBmp)->LoadFromFile(pBmpFileName);

  //24bit bitmap  .
  (*pBmp)->PixelFormat = pf24bit;

}

bool __fastcall Bmp_Get_Size(char          *pPathNameExt,
                             unsigned int  *rWidth,
                             unsigned int  *rHeight)
{
  //[2021.03.26.][]{---------------------
  //<bmp>  [/]  ؼ ȯ.
  //}------------------------------------------

  //[VAR]
  //{
      Graphics::TBitmap  *_bmp_;

      char  ext[1024];

  //}

  //[ Ȯ]
  //{
      if(FileExists(pPathNameExt) != true) return(false);

  //}

  //[BMP ΰ?]
  //{
      STR_GetFileExt(pPathNameExt, ext);

      //<bmp>  ƴ϶ ̻ ó ʰ .
      if(STR_Match_NoCase(ext, "bmp") != true) return(false);

  //}

  //[]
  //{
      _bmp_ = new Graphics::TBitmap;

      //24bit bitmap  .
      _bmp_->PixelFormat = pf24bit;

  //}

  //[׸ ]
  //{
      //[2021.05.23.][]{---
      //<try ...catch> ߰.
      //}------------------------

      try
      {
        _bmp_->LoadFromFile(pPathNameExt);

      }
      catch(...)
      {
        //[!]{--------------------------------------------------------
        //Ȯڴ <bmp> ε,  ׸ <bmp>  ƴ 쿡 ش.
        //     ߻Ѵ.
        //}-----------------------------------------------------------

        delete  _bmp_;

        return(false);

      }

  //}

  //[ũ  ȯ]
  //{
      if(rWidth  != NULL) { (*rWidth)  = _bmp_->Width;  }

      if(rHeight != NULL) { (*rHeight) = _bmp_->Height; }

  //}

  //[]
  //{
      delete  _bmp_;

  //}

  return(true);

}

bool __fastcall Jpg_Get_Size(char          *pPathNameExt,
                             unsigned int  *rWidth,
                             unsigned int  *rHeight)
{
  //[2021.03.26.][]{---------------------
  //<jpg>  [/]  ؼ ȯ.
  //}------------------------------------------
  
  //[VAR]
  //{
      TJPEGImage  *jpgFile; 

      char  ext[1024];

  //}

  //[ Ȯ]
  //{
      if(FileExists(pPathNameExt) != true) return(false);

  //}

  //[JPG/JPEG ΰ?]
  //{
      STR_GetFileExt(pPathNameExt, ext);

      //<jpg/jpeg>  ƴ϶ ̻ ó ʰ .
      if(!((STR_Match_NoCase(ext, "jpg") == true) || (STR_Match_NoCase(ext, "jpeg") == true))) return(false);

  //}

  //[]
  //{
      jpgFile = new TJPEGImage();

  //}

  //[׸ ]
  //{
      //[2021.05.23.][]{---
      //<try ...catch> ߰.
      //}------------------------

      try
      {
        jpgFile->LoadFromFile(pPathNameExt);

      }
      catch(...)
      {
        //[!]{--------------------------------------------------------
        //Ȯڴ <bmp> ε,  ׸ <bmp>  ƴ 쿡 ش.
        //     ߻Ѵ.
        //}-----------------------------------------------------------

        delete  jpgFile;

        return(false);

      }

  //}
                                   
  //[ũ  ȯ]
  //{
      if(rWidth  != NULL) { (*rWidth)  = jpgFile->Width;  }

      if(rHeight != NULL) { (*rHeight) = jpgFile->Height; }

  //}

  //[]
  //{
      delete  jpgFile;

  //}

  return(true);

}

bool __fastcall Image_Get_Size(char          *pPathNameExt,
                               unsigned int  *rWidth,
                               unsigned int  *rHeight)
{
  //[2021.03.29.][]{------------------------------
  //<bmp/jpg/jpeg>  [/]  ؼ ȯ.
  //ش ʴ   <false> ȯ.
  //}---------------------------------------------------
  
  //[VAR]
  //{
      char  ext[1024];

  //}

  //[ Ȯ]
  //{
      if(FileExists(pPathNameExt) != true) return(false);

  //}

  //[  ó]
  //{
      //[Ȯ] .
      STR_GetFileExt(pPathNameExt, ext);

      if     (STR_Match_NoCase(ext, "bmp") == true)
      {
        return(Bmp_Get_Size(pPathNameExt, rWidth, rHeight));

      }
      else if((STR_Match_NoCase(ext, "jpg") == true) || (STR_Match_NoCase(ext, "jpeg") == true))
      {
        return(Jpg_Get_Size(pPathNameExt, rWidth, rHeight));

      }
      else
      {
        return(false);

      }

  //}

}

void __fastcall Bmp_Stretch(Graphics::TBitmap  *pBmp,
                            unsigned int        pWidth,
                            unsigned int        pHeight)
{
  //[2021.04.06.ȭ][]{----------------------------------------------------------
  //<pBmp>  <pWidth, pHeight>  ũ [/Ȯ] Ų.
  // ٸ [/κ]  Ͽ [/]   ø ִ.
  //
  //[]   ̹ ջ , [Ȯ]   []  ߻Ѵ.
  //
  //<GImageBox>  ϸ鼭 ʿؼ .
  //}-------------------------------------------------------------------------------

  //[VAR]
  //{
      Graphics::TBitmap  *tempBmp;

      TRect               reSize;

  //}

  //[]
  //{
      tempBmp              = new Graphics::TBitmap;

      tempBmp->PixelFormat = pf24bit;

      tempBmp->Width       = pWidth;

      tempBmp->Height      = pHeight;

  //}

  //[ũ ]
  //{
      reSize.Top    = 0;
      reSize.Left   = 0;
      reSize.Right  = pWidth;
      reSize.Bottom = pHeight;

  //}

  //[׸ ]
  //{
      //<pBmp>  <ũ:reSize>  øų ٿ <tempBmp>  .
      tempBmp->Canvas->StretchDraw(reSize, pBmp);

  //}

  //[ũ ]
  //{
      //ðų پ ׸   Ͽ ش ũ .
      pBmp->Width  = pWidth;
      pBmp->Height = pHeight;

  //}

  //[׸ ]
  //{
      //<tempBmp>  ִ  ׸ ٽ <pBmp>  .
      pBmp->Canvas->CopyRect(reSize, tempBmp->Canvas, reSize);

  //}

  //[]
  //{
      delete tempBmp;

  //}

}




