//---------------------------------------------------------------------------

#ifndef ide_treeH
#define ide_treeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------

#include "font.h"

#include "gui_captionbar.h"
#include "gui_page.h"
#include "gui_scroll_v.h"
#include "gui_tabs.h"

//[2022.06.13.][߰]
#include "GEdit.h"


class Tide_tree_Form : public TForm
{
__published:	// IDE-managed Components
        void __fastcall FormResize(TObject *Sender);
private:	// User declarations
public:		// User declarations

        __fastcall Tide_tree_Form(TComponent* Owner);

        //[2012.04.29.][Ϸ!!!]
        __fastcall ~Tide_tree_Form(void);

        //[Ŭ]
        //{
            //[2012.06.07.][Ϸ!!!]
            void __fastcall WndProc(Messages::TMessage &Message);

        //}

        //[VAR]
        //{
            //[ȯ溯]
            //{
                //[2022.06.13.][߰]
                struct  IDE_OPTION   *_ide_option;

            //}

            //[ Ʈ]
            //{ 
                Tgui_captionbar_Form  *_captionbar_Form;
                Tgui_page_Form        *_page_Form;
                Tgui_scroll_v_Form    *_scroll_v_Form;
                Tgui_tabs_Form        *_tabs_Form;
            //}

            //[API ã ]
            //{
                //[2022.06.13.][߰]

                //[VAR]
                //{
                    TGEdit_Form  *_findEdit;

                    //[]  <Ctrl+P>  [API ˻]  Ȱȭ  <true>.
                    bool  _editor_Ctrl_P; //(⺻:false)

                //}

                //[2022.06.27.][Ϸ]
                void __fastcall _EVENT_findEdit_KeyDown_Esc(void);

                //[2022.06.20.][Ϸ]
                void __fastcall _EVENT_findEdit_Change(void);

                //[2022.06.21.ȭ][Ϸ]
                void __fastcall _EVENT_findEdit_CaretMove(void);

                //[2022.07.03.][Ϸ]
                void __fastcall _EVENT_findEdit_KeyDown_Up(void);

                //[2022.07.03.][Ϸ]
                void __fastcall _EVENT_findEdit_KeyDown_Down(void);

                //[2022.06.27.][Ϸ]
                void __fastcall _EVENT_tree_tree_Form_KeyDown_Esc(void);

            //}

        //}

        //[FUNCTION]
        //{
            void __fastcall _Resize(void);
            void __fastcall _Split_v(void);
            void __fastcall _Split_h(void);

            //[2022.06.15.][Ϸ]
            void __fastcall _Tree_All_Init(//[2009.05.30.][!!!]
                                           // Ʈ  ϴ  Ѵ.
                                           int   pTrees,
                                           //[2012.06.03.][߰!!!]
                                           bool  pRePaint);
            //{
                //[2009.05.30.][߰!!!]
                //[μ]  ܼȭ ϰ Ȯ Ͽ  Ʈ  ϴ  Ѵ.
                #define d_Tree_Prj       0x01
                #define d_Tree_Info      0x02
                #define d_Tree_Api       0x04
                #define d_Tree_Sys       0x08

                //[2011.07.11.][߰!!!]
                #define d_Tree_DbgExp    0x10

                //[2019.02.16.][߰]
                #define d_Tree_Find      0x20

                //[2022.06.15.][߰]
                #define d_Tree_ApiSrch   0x40

            //}

        //}

        //[EVENT FUNCTION]
        //{
            void __fastcall _EVENT_V_Scroll(void);
            void __fastcall _EVENT_V_MouseDown(void);

            void __fastcall _EVENT_PageUp(void);
            void __fastcall _EVENT_PageDown(void);

            //[2022.06.15.][Ϸ]
            void __fastcall _EVENT_TabSelect(void);

            //[2011.07.21.][Ϸ!!!]
            void __fastcall _EVENT_TabSelect_DbgExpTree_ViewAll(void);

        //}

        //[ΰԼ]
        //{
            //[2011.07.13.][Ϸ!!!]
            void __fastcall _Tab_Change(bool  pTdefault_Fdebug);


        //}


};
//---------------------------------------------------------------------------
extern PACKAGE Tide_tree_Form *ide_tree_Form;
//---------------------------------------------------------------------------
#endif
