
#include  "API_VRingBuf.h"

#include  "vmos_def.h"
#include  "vmos.h"
#include  "c_define.h"

#include  "ring_buffer.h"


void __fastcall _API_VRingBuf_Create(void)
{
  //[2018.11.01.][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU8  pBufAdr;
          DTU4  pSize;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{-------------------------------------
  //void _VRingBuf__(void           *p,
  //                     unsigned char  *p,
  //                     unsigned int    pũ);
  //}---------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned char  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pBufAdr)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pBufAdr, &pBufAdr);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  pũ]
  //{
      //[] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (4), (DTU1 *)(&pSize)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (4);
      //}--------------------------

  //}

  //[ó]
  //{
      VRingBuf_Create((void *)pCreator, pBufAdr, pSize);

  //}

}

void __fastcall _API_VRingBuf_Delete(void)
{
  //[2018.11.01.][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{-----------------------------
  //void _VRingBuf__(void  *p);
  //}-------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      VRingBuf_Delete((void *)pCreator);

  //}

}

void __fastcall _API_VRingBuf_Clear(void)
{
  //[2018.11.01.][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{-------------------------------
  //void _VRingBuf__(void  *p);
  //}---------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      VRingBuf_->RingBuf_Clear();

  //}

}

void __fastcall _API_VRingBuf_GetCount(void)
{
  //[2018.11.01.][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.

          //ȯ.
          DTU4  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{-------------------------------------------------
  //unsigned int _VRingBuf____(void  *p);
  //}---------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBuf_Count();

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (4), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}

}

void __fastcall _API_VRingBuf_Write(void)
{
  //[2018.11.01.][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU1  pByte;

          //ȯ.
          DTU1  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{-----------------------------------------------
  //unsigned char _VRingBuf__(void           *p,
  //                              unsigned char   pڷ);
  //}-------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned char  pڷ]
  //{
      //[] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (1), (DTU1 *)(&pByte)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (1);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBuf_Write(pByte);

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (1), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}

}

void __fastcall _API_VRingBuf_WriteX(void)
{
  //[2018.11.02.][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU8  pByteX;
          DTU4  pSize;
          DTU8  rRealCount;

          //ȯ.
          DTU1  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{----------------------------------------------------
  //unsigned char _VRingBuf_X_(void           *p,
  //                               unsigned char  *pڷ῭,
  //                               unsigned int    pũ,
  //                               unsigned int   *r);
  //}------------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned char  *pڷ῭]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pByteX)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pByteX, &pByteX);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  pũ]
  //{
      //[] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (4), (DTU1 *)(&pSize)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (4);
      //}--------------------------

  //}

  //[unsigned int  *r]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rRealCount)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rRealCount, &rRealCount);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBuf_WriteX((DTU1 *)pByteX, pSize, (DTU4 *)rRealCount);

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (1), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}

}

void __fastcall _API_VRingBuf_Read(void)
{
  //[2018.11.01.][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU8  rByte;

          //ȯ.
          DTU1  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{-------------------------------------------------
  //unsigned char _VRingBuf_б_(void           *p,
  //                              unsigned char  *rڷ);
  //}---------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned char  *rڷ]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rByte)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rByte, &rByte);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBuf_Read((unsigned char *)rByte);

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (1), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}

}

void __fastcall _API_VRingBuf_ReadX(void)
{
  //[2018.11.02.][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU8  rByteX;
          DTU4  pSize;
          DTU8  rRealCount;

          //ȯ.
          DTU1  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{------------------------------------------------------
  //unsigned char _VRingBuf_бX_(void           *p,
  //                               unsigned char  *rڷ῭,
  //                               unsigned int    pũ,
  //                               unsigned int   *r);
  //}--------------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned char  *rڷ῭]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rByteX)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rByteX, &rByteX);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  pũ]
  //{
      //[] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (4), (DTU1 *)(&pSize)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (4);
      //}--------------------------

  //}

  //[unsigned int  *r]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rRealCount)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rRealCount, &rRealCount);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBuf_ReadX((DTU1 *)rByteX, pSize, (DTU4 *)rRealCount);

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (1), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}

}

void __fastcall _API_VRingBuf_DataArea_Check(void)
{
  //[2018.11.06.ȭ][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU4  pIndex;

          //ȯ.
          DTU1  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{----------------------------------------------------------
  //unsigned char _VRingBuf_ڷ῵_Ȯ_(void          *p,
  //                                           unsigned int   pġ);
  //}------------------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  pġ]
  //{
      //[] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (4), (DTU1 *)(&pIndex)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (4);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBuf_DataArea_Check(pIndex);

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (1), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}

}

void __fastcall _API_VRingBuf_Info(void)
{
  //[2018.11.06.ȭ][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU8  rWrInx;
          DTU8  rRdInx;
          DTU8  rRxPos;
          DTU8  rCount;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{----------------------------------------------
  //void _VRingBuf__(void          *p,
  //                         unsigned int  *rġ,
  //                         unsigned int  *rбġ,
  //                         unsigned int  *rбġ,
  //                         unsigned int  *r簳);
  //}------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  *rġ]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rWrInx)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rWrInx, &rWrInx);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  *rбġ]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rRdInx)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rRdInx, &rRdInx);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  *rбġ]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rRxPos)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rRxPos, &rRxPos);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  *r簳]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rCount)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rCount, &rCount);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      VRingBuf_->RingBuf_Info((DTU4 *)rWrInx, (DTU4 *)rRdInx, (DTU4 *)rRxPos,(DTU4 *)rCount);
      
  //}

}

void __fastcall _API_VRingBufRead_RxPos_Set(void)
{
  //[2018.11.06.ȭ][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU4  pRxPos;

          //ȯ.
          DTU1  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{------------------------------------------------------------
  //unsigned char _VRingBufRead_ġ_(void          *p,
  //                                      unsigned int   pбġ);
  //}--------------------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  pбġ]
  //{
      //[] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (4), (DTU1 *)(&pRxPos)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (4);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBufRead_RxPos_Set(pRxPos);

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (1), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}

}

void __fastcall _API_VRingBufRead_RxPos_Set_WrInx(void)
{
  //[2018.11.06.ȭ][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          
      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{-------------------------------------------------------
  //void _VRingBufRead_ġ_ġ__(void  *p);
  //}---------------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      VRingBuf_->RingBufRead_RxPos_Set_WrInx();

  //}

}

void __fastcall _API_VRingBufRead_ReadX(void)
{
  //[2018.11.06.ȭ][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU8  rByteX;
          DTU4  pSize;
          DTU8  rRealCount;

          //ȯ.
          DTU1  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{---------------------------------------------------------------
  //unsigned char _VRingBufRead_б_(void           *p,
  //                                        unsigned char  *rڷ῭,
  //                                        unsigned int    pũ,
  //                                        unsigned int   *r);
  //}-----------------------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned char  *rڷ῭]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rByteX)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rByteX, &rByteX);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  pũ]
  //{
      //[] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (4), (DTU1 *)(&pSize)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (4);
      //}--------------------------

  //}

  //[unsigned int  *r]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rRealCount)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rRealCount, &rRealCount);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBufRead_ReadX((DTU1 *)rByteX, pSize, (DTU4 *)rRealCount);

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (1), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}

}

void __fastcall _API_VRingBufRead_ReadX_Back(void)
{
  //[2018.11.06.ȭ][!!!]

  //[VAR]
  //{
      //[⺻]
      //{
          class  VMOS  *vmos;

          //<@LOCAL>  ⺻  [ּ](빮ڷ ּ ).
          DTU8   ADR;

      //}

      //[API]
      //{
          //ּҴ  MCU  ּҴ.
          DTU8  pCreator;  //ּ.
          DTU8  rByteX;
          DTU4  pSize;
          DTU8  rRealCount;

          //ȯ.
          DTU1  rReturn;

      //}

      //[ ü]
      //{
          class VRING_BUFFER  *VRingBuf_;

      //}

  //}

  //[VMOS ġ ]{--
  VMOS_GetPtr(&vmos);
  //}------------------

  //[Լ]{-------------------------------------------------------------
  //unsigned char _VRingBufRead_ڷб_(void           *p,
  //                                      unsigned char  *rڷ῭,
  //                                      unsigned int    pũ,
  //                                      unsigned int   *r);
  //}---------------------------------------------------------------------

  //[⺻ּ ]
  //{
      //[!]{--------------------------------------------------------
      //<@LOCAL>   [ּ] .
      //Լ [μ]    <@LOCAL>  ۵Ǳ .
      //ù° [(μ)]  [ּ]  ȴ.
      //}-----------------------------------------------------------

      ADR = (vmos->regREG_[d_VM_Reg_LOCAL]);

  //}

  //[void  *p]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&pCreator)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(pCreator, &pCreator);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned char  *rڷ῭]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rByteX)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rByteX, &rByteX);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[unsigned int  pũ]
  //{
      //[] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (4), (DTU1 *)(&pSize)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (4);
      //}--------------------------

  //}

  //[unsigned int  *r]
  //{
      //[ּ] б.
      if(vmos->VMOS_WrRd(d_Rd, ADR, (8), (DTU1 *)(&rRealCount)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

      //MCU ó ϹǷ  ּҷ ٲ۴.
      vmos->VMOS_Conv_AdrToSysAdr(rRealCount, &rRealCount);

      //[ ּ ]{----------
      // [μ] ũ⸦ Ѵ.
      ADR += (8);
      //}--------------------------

  //}

  //[ó]
  //{
      //[]  ش ü .
      VRingBuf_ = (class VRING_BUFFER *)(*((DTU8 *)pCreator));

      rReturn = VRingBuf_->RingBufRead_ReadX_Back((DTU1 *)rByteX, pSize, (DTU4 *)rRealCount);

  //}

  //[ ȯ]
  //{
      //[] .
      if(vmos->VMOS_WrRd(d_Wr, ADR, (1), (DTU1 *)(&rReturn)) != true)
      { vmos->regSysFuncCallResult = d_False; return; }

  //}
  
}


