//---------------------------------------------------------------------------

#ifndef vmosH
#define vmosH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------

#include  "vmos_def.h"

//[GUI]
//{
    //[2011.11.11.][߰!!!]
    //<struct  VMOS_SYNC>  ʿ.
    #include  "GProgress.h"

//}

struct OPND
{
  //[2009.02.25.][!!!]{----------------------------------------------------------
  //[ǿ] Ѱ Ѵ.
  //̴ ׻ [type][opnd]  ¦ ̷ ǹǷ  ϰ ϱ  ̴.
  //}----------------------------------------------------------------------------------

  //[type ]
  //{
      //׻ 2 Byte  ũ⸦ ´.

      //------------------------------------------------------------------------------------
      // 1bit    1bit     4bit     2bit      4bit       4bit   : Ʈ.
      //  15      14     13:10     9:8        7:4       3:0    : Ʈ.
      // [i/f] . [s/u] . [size] . [kind] . [segment] . [byte]  : ̸.
      //------------------------------------------------------------------------------------
      //
      // [i/f]
      //
      // - /Ǽ Ѵ.
      // - i(0) : .
      //   f(1) : Ǽ.
      //
      // [s/u]
      //
      // - signed  unsigned  Ѵ.
      // - u(0) : unsigned.
      //   s(1) : signed.
      //
      // [size]
      //
      // -  о  [ũ]  (c-type ũ).
      // - 1, 2, 4, 8   ũ  Ѵ(ٷ о Ҽ ֵ ϱ  ).
      //
      // [kind]
      //
      // -   ΰ?
      // - pv(3) : .
      //   cv(2) : .
      //   v (1) : .
      //   c (0) : .
      //
      // [segment]
      //
      // -   .
      // - #(0) : .
      //   R(1) : .
      //   C(2) : @CODE.
      //   G(3) : @DATA.
      //   L(4) : @LOCAL.
      //   T(5) : @TEMP.
      //   F(6) : @FUNC.
      //
      // [byte]
      //
      // - [ǿ] ü ũ "i.u.8.c.F.8:ofsAdr"  "ofsAdr" ü ũⰡ ȴ.
      // - 1 - 8    ״ Ѵ.
      //
      //------------------------------------------------------------------------------------

  //}

  DTU2  type;

  //[ǿ] ü 8 byte ũ⸦  ʴ´([ּ/]   شϹǷ).
  //[opnd] κ [޸]  ״ Ѵ(Ǽ/  ).
  DTU1  mem[8];

};

class VMOS : public TThread
{
  private:

  protected:

    //[߿!!!]{--------------------------------------
    // Լ BCB6   ״  ġ д.
    //ٸ  ξ   .
    //  Լ MCU  main() Լ ȴ.
    //[2010.02.27.][߿Ϸ!!!]
    //[2018.05.06.][Ϸ!!!]
    void __fastcall Execute();
    //}-----------------------------------------------

  public:

  //[CLASS]
  //{
      __fastcall VMOS(bool CreateSuspended);

      //[2012.05.02.][߰!!!]{---------------------------------
      //{ OnTerminate = Thread_OnTerminate; } 
      //<__fastcall VMOS(bool CreateSuspended)> ȿ ݵ
      //Լ Ҵؾ Ѵ.
      //غ  ̺Ʈ ʹ ʰ ߻Ͽ ū ġ .
      void __fastcall Thread_OnTerminate(TObject *Sender);
      //}---------------------------------------------------------

  //}

  //[]
  //{
      //[2009.02.19.][߰!!!]{--------------------
      //[MCU] 󿡼 []  ȴ.
      //[]  شϴ  ⿡ Ѵ.
      //}--------------------------------------------

      //[޸]
      //{
          //64KByte ũ ϴ .
          unsigned char  _ROM_[d_Sim_VMOS_RomSize];
          //{
              //<*.gvmx>     ġ ´.
              int        _mountEnd;

          //}

          //64KByte ũ ϴ .
          unsigned char  _RAM_[d_Sim_VMOS_RamSize];

          //[2009.02.23.][߰!!!]
          unsigned char  _HEAP_[d_Sim_VMOS_HeapSize];

      //}

      //[VMOS ü  ]
      //{
          //[]
          //{
              //[2009.02.22.][߰!!!]{-----------------------------------------------------------
              //   Ͽ MCU 󿡼 ٷ  Ҽ ִ []  .
              //  VMOS  [64Bit  ּ ]   ϴ° ƴ϶ ü Ѵ.
              //MCU    ü []   ̴.
              //}-----------------------------------------------------------------------------------
              
              // ó  [VMEX]  [64 bit  ּ ]  []  ´.
              DTU8   regVMEXP;

              // ó  [VM]  [64 bit  ּ ]  []  ´.
              DTU8   regVMP;

              // ó  [VMEX]  []  MCU  ġ ´.
              //̴ []  ٷ [迭] ó ϱ  ̴.
              DTU8  *regVMEXHDR_;

              // ó  [VM]  []  MCU  ġ ´.
              //̴ []  ٷ [迭] ó ϱ  ̴.
              //  [VM]  üҶ ٽ ŵǾ Ѵ.
              DTU8  *regVMHDR_;

              // ó  [VM]  [REG]  MCU  ġ ´.
              //̴ [REG]  ٷ [迭] ó ϱ  ̴.
              //  [VM]  üҶ ٽ ŵǾ Ѵ.
              //[VM] 󿡼 []   ÷ ̱ؾ ϹǷ ̷  ġ ʿϴ.
              DTU8  *regREG_;

              //[]
              //{
                  //[2009.04.05.][߰!!!]{----------------------------------------------------
                  //[]  Ѵ.
                  //[]  [VMOS] ü Ǵ []   [IDE]   
                  //[]  ڰ Ϲ ϴ []    ִ.
                  //
                  //0xF:F : 64bit  0xff    ʴ  .
                  //         ġ <system> ̹Ƿ ڰ  Ҽ .
                  //        []     ʱȭ  ־ Ѵ.
                  //}----------------------------------------------------------------------------

                  //[Ϲ ]
                  //{
                      #define  d_VMOS_BreakPointMax  12
                      DTU8  regBP[d_VMOS_BreakPointMax];

                  //}

                  //[ ]
                  //{
                      //[2009.04.09.][߰!!!]
                      // [ ]  <VMOS> θ Ѵ.
                      DTU8  regSysBreakPoint;

                  //}

              //}

              //[Լȣ]
              //{
                  //[2009.04.19.][߰!!!]{---------------------------------------------------
                  //[Լȣ]   ͸ .
                  //<0xF:fffffff8>  ϸ  [Լȣ] ϴ  óϰ
                  //[ּ] ó ο true   ָ ڵ óȴ.
                  // , ̹ <0xF:fffffff8> ġ ó [ɹ]  ִ [VMOS] 
                  //[ּ]   ִ. ,  [8 Byte]  ϰ ִ ̴.
                  // [ɹ]]  VM  [Լ]  [] ġ Ѵ.
                  //  ڴ Ҽ  [н] ̴.
                  //
                  //  ӵ ̹Ƿ  [ּ]  ȴ.
                  //}---------------------------------------------------------------------------

                  DTU1   regSysFuncCallRqst; //(BASE : false)
                  //true  : ش  ó Ѵ.
                  //false : ó  .

                  //[!]{-------------------------------------------------------------------------------
                  //[ɹ]  ִ [VMOS]  [ּ]  ִ.
                  // [ּ]  ݵ <8 Byte Align> ִٰ  Ƿ
                  //MCU 󿡼 ٷ []  Ҽ.  Ѵ!!!
                  // ׳ [VMOS]  []  Ѵ.
                  //
                  //[2011.11.29.ȭ][߿!!!]-------------------------------------------------------
                  //API ȣ  [ɹ] Ŀ [API]   ѱ  ǾǷ
                  //[ɹ]  [ּ]  ϴ   ̻ ǹ̰ .
                  //߿ ϴ  API   Ǳ  ܵд.
                  //
                  //[2011.12.20.ȭ][!!!]-----------------------------------------------------------
                  //̸ { regSysFuncCallAdr => regSysFuncCallApi }  ü.
                  DTU8   regSysFuncCallApi;  //(BASE : 0)
                  //}----------------------------------------------------------------------------------

                  //[2009.05.13.][߰!!!]
                  //[ɹ] ó  Ѵ.
                  DTU1   regSysFuncCallResult; //(BASE : false)

              //}

          //}

      //}

      //[ۺ]
      //{
          DTU1    opcode;

      //}

  //}

  //[ó Լ]
  //{
      //[2009.04.05.][Ϸ!!!]
      void __fastcall Memory_Init(void);

      //[2009.04.09.][Ϸ!!!]
      void __fastcall BreakPoint_Init(void);

      //[2011.12.28.][Ϸ!!!]
      bool __fastcall Mount(char  *pGvmsFileName);

      //[2009.03.15.][Ϸ!!!]
      void __fastcall REG_Init(void);

      //[2009.04.30.][Ϸ!!!]
      void __fastcall VM_Reg_Init(void);

      //[2009.03.15.][Ϸ!!!]
      void __fastcall VM_Create(void);

  //}

  //[VMOS ü Լ]
  //{
      //[2012.08.01.][Ϸ!!!]
      bool __fastcall VMOS_WrRd(//[б/] .
                                DTU1   pWrRd,
                                //64bit ּ.
                                DTU8   pAdr,
                                // ũ.
                                DTU8   pStreamSize,
                                // .
                                DTU1  *pStream);

      //[2012.08.01.][Ϸ!!!]
      bool __fastcall VMOS_Conv_AdrToSysAdr(//64bit ּ.
                                            DTU8   pAdr,
                                            // [ý] ü ּ( ּҰ ƴ϶ MCU ü ּ  ȴ).
                                            DTU8  *rSysAdr);

  //}

  //[VMOS ó Լ]
  //{ 
      //[OPCODE]
      //{
          //[2009.02.25.][Ϸ!!!]
          void __fastcall Opcode_Ptr_Init(void);

          //[2009.02.25.][Ϸ!!!]
          //{
              //[!]{------------------------------------------------------
              // ó ó [Լ]  Ѵ.
              // OPCODE 0   Ƿ NULL  ä Ѵ.
              //, 1    ش.
              //}---------------------------------------------------------

              //[!!!]{------------------------------------------------------
              //__closure  BCB  ִ ̳ [Լ]  [Լ] 
              //޾Ƽ ϱ Ͽ ʿϴ.
              //}---------------------------------------------------------------

              void __fastcall (__closure * _Opcode_[d_VMOS_OpcodeCount + 1])(void);

          //}

          //[2009.02.24.ȭ][Ϸ!!!]{-----------------------------------------------
          // [ɾ]  [Լ 1 ] ̸   ش ɾ óѴ.
          //}-------------------------------------------------------------------------

          //[]
          //[2009.03.04.][Ϸ!!!]
          void __fastcall Opcode_Operator_1(void);  //(OPCODE : 1)  : "[]"
          //[2009.03.04.][Ϸ!!!]
          void __fastcall Opcode_Operator_2(void);  //(OPCODE : 2)  : "->"
          //[2009.03.04.][Ϸ!!!]
          void __fastcall Opcode_Operator_3(void);  //(OPCODE : 3)  : "."
          //[2009.03.04.][Ϸ!!!]
          void __fastcall Opcode_Operator_4(void);  //(OPCODE : 4)  : "!/"
          //[2009.03.04.][Ϸ!!!]
          void __fastcall Opcode_Operator_5(void);  //(OPCODE : 5)  : "~/"
          //[2009.03.04.][Ϸ!!!]
          void __fastcall Opcode_Operator_6(void);  //(OPCODE : 6)  : "++"
          //[2009.03.04.][Ϸ!!!]
          void __fastcall Opcode_Operator_7(void);  //(OPCODE : 7)  : "--"
          //[2009.03.22.][Ϸ!!!]
          void __fastcall Opcode_Operator_8(void);  //(OPCODE : 8)  : "-/"
          //[2009.03.22.][Ϸ!!!]
          void __fastcall Opcode_Operator_9(void);  //(OPCODE : 9)  : "*/"
          //[2009.03.21.][Ϸ!!!]
          void __fastcall Opcode_Operator_10(void); //(OPCODE : 10) : "&/"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_11(void); //(OPCODE : 11) : "*"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_12(void); //(OPCODE : 12) : "/"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_13(void); //(OPCODE : 13) : "%"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_14(void); //(OPCODE : 14) : "+"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_15(void); //(OPCODE : 15) : "+*"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_16(void); //(OPCODE : 16) : "-"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_17(void); //(OPCODE : 17) : "-*"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_18(void); //(OPCODE : 18) : "<<"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_19(void); //(OPCODE : 19) : ">>"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_20(void); //(OPCODE : 20) : "<"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_21(void); //(OPCODE : 21) : "<="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_22(void); //(OPCODE : 22) : ">"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_23(void); //(OPCODE : 23) : ">="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_24(void); //(OPCODE : 24) : "=="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_25(void); //(OPCODE : 25) : "!="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_26(void); //(OPCODE : 26) : "&"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_27(void); //(OPCODE : 27) : "^"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_28(void); //(OPCODE : 28) : "|"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_29(void); //(OPCODE : 29) : "&&"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_30(void); //(OPCODE : 30) : "||"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_31(void); //(OPCODE : 31) : "="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_32(void); //(OPCODE : 32) : "+="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_33(void); //(OPCODE : 33) : "+=*"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_34(void); //(OPCODE : 34) : "-="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_35(void); //(OPCODE : 35) : "-=*"
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_36(void); //(OPCODE : 36) : "*="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_37(void); //(OPCODE : 37) : "/="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_38(void); //(OPCODE : 38) : "%="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_39(void); //(OPCODE : 39) : "&="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_40(void); //(OPCODE : 40) : "^="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_41(void); //(OPCODE : 41) : "|="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_42(void); //(OPCODE : 42) : "<<="
          //[2009.03.05.][Ϸ!!!]
          void __fastcall Opcode_Operator_43(void); //(OPCODE : 43) : ">>="

          //[Ϲ ɾ]
          //[2009.03.06.][Ϸ!!!]
          void __fastcall Opcode_jump(void);        //(OPCODE : 44) : "jump"
          //[2009.03.06.][Ϸ!!!]
          void __fastcall Opcode_fncall(void);      //(OPCODE : 45) : "fncall"
          //[2009.03.06.][Ϸ!!!]
          void __fastcall Opcode_fnstart(void);     //(OPCODE : 46) : "fnstart"
          //[2009.04.30.][߿Ϸ!!!]
          void __fastcall Opcode_fnend(void);       //(OPCODE : 47) : "fnend"
          //[2009.03.23.][Ϸ!!!]
          void __fastcall Opcode_copy(void);        //(OPCODE : 48) : "copy"
          //[2009.03.09.][Ϸ!!!]
          void __fastcall Opcode_conjt(void);       //(OPCODE : 49) : "conjt"
          //[2009.03.09.][Ϸ!!!]
          void __fastcall Opcode_conjf(void);       //(OPCODE : 50) : "conjf"
          //[2009.03.09.][Ϸ!!!]
          void __fastcall Opcode_push(void);        //(OPCODE : 51) : "push"
          //[2009.03.09.][Ϸ!!!]
          void __fastcall Opcode_pop(void);         //(OPCODE : 52) : "pop"
          //[2009.03.09.][Ϸ!!!]
          void __fastcall Opcode_mpush(void);       //(OPCODE : 53) : "mpush"
          //[2009.03.09.][Ϸ!!!]
          void __fastcall Opcode_mpop(void);        //(OPCODE : 54) : "mpop"
          //[2009.03.09.][Ϸ!!!]
          void __fastcall Opcode_tstart(void);      //(OPCODE : 55) : "tstart"
          //[2009.03.09.][Ϸ!!!]
          void __fastcall Opcode_tend(void);        //(OPCODE : 56) : "tend"

      //}

      //[ӽ ó  Լ]
      //{
          //[2009.05.10.][Ϸ!!!]
          bool __fastcall Opnd_Reader(struct OPND  *pOpndList,
                                      // [ǿ] .
                                      DTU1          pOpndCount);

          //[2009.03.21.][Ϸ!!!]
          void __fastcall Opnd_Adr(//ó [ǿ] .
                                   struct OPND  *pOpnd,
                                   // [ּ] .
                                   DTU8         *prOpndAdr,
                                   //[2009.03.21.][߰!!!]
                                   //[׸Ʈ]  ȯѴ.
                                   DTU1         *rSegment);

          //[2009.05.25.][!!!]
          bool __fastcall Opnd_WrRd(//[/б ]{-----------------------
                                    //б/.
                                    DTU1          pWrRd,
                                    //[/б ]--------------------------
                                    //ó [ǿ] .
                                    struct OPND  *pOpnd,
                                    //[/б ]----------------------------
                                    //Ǽΰ ΰ?
                                    DTU1         *prFI,
                                    //ų  .
                                    // 8 Byte ũ⸦ Ƿ [/Ǽ]
                                    // ϸ ȴ.
                                    void         *prData
                                    //}-----------------------------------------
                                   );

      //}

      //[Լȣ]
      //{
          //[2020.09.25.][Ϸ]
          void __fastcall SysFuncCall(void);

      //}

      //[̺Ʈ]
      //{
          //[2010.02.26.][Ϸ!!!]
          void __fastcall Event_FuncCall(void);

      //}

  //}

  //[VMOS  ]
  //{
      //[2009.04.08.][߿!!!]{-----------------------------------------------------
      // VMOS 󿡼  ,   [Ż ּ]  Ҵ ް Ƿ
      //[н]  [Ĺ]  [ּ]  Ͽ ٷ Ҽ ִ.
      //}---------------------------------------------------------------------------------

      //[VAR]
      //{
          //[VMOS]
          //{
              DTU1   vmosMsg;
              DTU1   vmosMsgExe;       //(BASE : d_Msg_Exe_Clear)
              DTU1   vmosMode;         //(BASE : d_VMOS_Mode_Run)

          //}

          //[VM]
          //{
              DTU1   vmMsg;
              DTU1   vmMsgExe;       //(BASE : d_Msg_Exe_Clear)
              DTU1   vmMode;         //(BASE : d_VM_Mode_Run)

          //}

          //[ʱȭ Լ]
          //{
              //[2009.04.11.][Ϸ!!!]
              void __fastcall VAR_Init(void);

          //}

      //}

      //[ ó Լ]
      //{
          //[2009.04.06.][Ϸ!!!]
          void __fastcall Msg_VMOS_Rom_Erase(void);

          //[2009.04.30.][߿Ϸ!!!]
          void __fastcall Msg_VM_Reset(void);

      //}

  //}

  //[  Ʈ]
  //{
      //[Ĺ]
      //{
          //[2009.04.14.ȭ][߰!!!]{------------------------------------
          //[Ĺ]   ϱ   .
          // ù° [ּŹ]   ٷ  ϴ.
          //}------------------------------------------------------------

          unsigned char   sbusAdr;   //1Byte [ּ]  Ѵ.
          unsigned char   sbusWR;    //[/б  .
          unsigned short  sbusSize;  //[/б]  [ũ(Byte)]  .

      //}

      //[MODE:0]
      //{
          //[TXD]{-----------------------------------------------------
          DTU1  comM0_TxdBuf[1];  //[MODE:0]  1 Byte  [۽] Ѵ.
          DTU2  comM0_TxdCount;   // (1Byte  óѴ).
          //[RXD]------------------------------------------------------
          DTU1  comM0_RxdBuf[1];  //[MODE:0]  1 Byte  [] Ѵ.
          DTU2  comM0_RxdCount;   // (1Byte  óѴ).
          //}----------------------------------------------------------

          //[Լ]
          //{
              void __fastcall ComM0_Txd(void);

              void __fastcall ComM0_Rxd(// .
                                        DTU1  *pBuf,
                                        // .
                                        DTU2   pCount);

          //}

      //}

      //[MODE:1]
      //{
          //[TXD]{------------------------------------------------
          DTU1  comM1_TxdBuf[2 + 0x400]; // (2 + 1024).
          DTU2  comM1_TxdCount;       // .
          //[RXD]-------------------------------------------------
          DTU1  comM1_RxdBuf[2 + 0x400]; // (2 + 1024).
          DTU2  comM1_RxdCount;       // .
          //}-----------------------------------------------------

          //[Լ]
          //{
              void __fastcall ComM1_Txd(void);

              void __fastcall ComM1_Rxd(// .
                                        DTU1  *pBuf,
                                        // .
                                        DTU2   pCount);

          //}

      //}

      //[MODE:2]
      //{
          //[TXD]{------------------------------------------------
          DTU1  comM2_TxdBuf[2 + 0x400]; // (2 + 1024).
          DTU2  comM2_TxdCount;           // .
          //[RXD]-------------------------------------------------
          DTU1  comM2_RxdBuf[2 + 0x400]; // (2 + 1024).
          DTU2  comM2_RxdCount;           // .
          //}-----------------------------------------------------

          //[Լ]
          //{
              void __fastcall ComM2_Txd(void);

              void __fastcall ComM2_Rxd(// .
                                        DTU1  *pBuf,
                                        // .
                                        DTU2   pCount);

          //}

      //}

      //[ó]
      //{
          void __fastcall Com_Process(void);

          void __fastcall Com_Init(void);

          void __fastcall Com_Send_Ack(void);

          void __fastcall Com_Send_Break(void);

          //[2009.05.10.][Ϸ!!!]
          void __fastcall Com_Send_Error(void);

      //}

  //}

  //[VMOS  ]
  //{
      //[2010.04.09.][Ϸ!!!]
      void __fastcall Vmos_Stop(void);

  //}

  //[ ]
  //{
      //[VAR]
      //{
          //   Ѵ.
          //̴     ̸ ǥϿ ˷ֱ  ̴.
          DTU8  regREG_Before[d_VM_RegCount];

          char  degStr[1024];

      //}                          
      
      //[2009.03.20.][Ϸ!!!]
      void __fastcall Debug_RegBackup(void);

  //}

  //[IDE ũ ]
  //{
      //[2010.03.27.][Ϸ!!!]
      void __fastcall Ide_Size_Default(void);

      //[2010.03.27.][Ϸ!!!]
      void __fastcall Ide_Size_Min(void);

      //[2010.03.27.][Ϸ!!!]
      void __fastcall Ide_Size_Max(void);

      //[2018.02.26.][Ϸ!!!]
      void __fastcall Ide_Size_Default_Body(void);

      //[2018.03.04.][Ϸ!!!]
      void __fastcall Ide_Size_Min_Body(void);

      //[2018.02.26.][Ϸ!!!]
      void __fastcall Ide_Size_Max_Body(void);

  //}

};

//[Ÿ Լ]
//{
    //[2009.03.16.][Ϸ!!!]
    void __fastcall VMOS_ThreadCreate(void);

    //[2012.05.03.][Ϸ!!!]
    void __fastcall VMOS_ThreadDelete(void);

    //[2009.03.16.][Ϸ!!!]
    void __fastcall VMOS_GetPtr(class VMOS **rVmosPtr);

    //[2009.03.18.][Ϸ!!!]
    bool __fastcall VMOS_Exist(void);

    //[2023.01.29.][Ϸ]
    bool __fastcall VMOS_Ready_GVMS_Install(void);

//}

struct  VMOS_SYNC
{
  //[2011.11.11.][!!!]{-------------------------------------------------------------------------
  //PC:VMOS  Ǵ [(GVMS)]  ȭ  [μ]  .
  //[]  API  [˵-հȯ]  ߿ ɿ Ҽ ֵ ϱ  
  //[]  API  [˵(G.MTDL.X)]  [(GVMX)]   ġҶ [ื] 
  // [GVMS:GUI]  <GProgress>  Ҷ    Ѿ ߿ ڷḦ ѱ涧 Ѵ.
  //
  //[!!!]-----------------------------------------------------------------------------------------
  // [˵C]   ϴ  ϴ ̶ Ϳ Ѵ.
  //}-------------------------------------------------------------------------------------------------

  //[ื]
  //{
      //<˵C>  [ื]  []  ȯϿ ´.
      // API  óѴ.
      TGProgress_Form  *GProgress; //(⺻:NULL).

  //}

  //[ ڿ]
  //{
      //[2011.11.12.][߰!!!]{--------------------------------------------------
      //API   ڿ ´.
      //<_API_Mtdl_Gvmx_Verify()>  [/Ȯ]  ġ  ȯ ش.
      //}--------------------------------------------------------------------------

      char  *infoStr;

  //}

};



//---------------------------------------------------------------------------
#endif
